/// [225.用队列实现栈](https://leetcode.cn/problems/implement-stack-using-queues/)
///
/// 2022-08-03 16:39:36
///
/// 请你仅使用两个队列实现一个后入先出（LIFO）的栈，并支持普通栈的全部四种操作（`push`、`top`、`pop` 和 `empty`）。
///
/// + 实现 `MyStack` 类：
///     * `void push(int x)` 将元素 x 压入栈顶。
///     * `int pop()` 移除并返回栈顶元素。
///     * `int top()` 返回栈顶元素。
///     * `boolean empty()` 如果栈是空的，返回 `true` ；否则，返回 `false` 。
/// + **注意：**
///     * 你只能使用队列的基本操作 —— 也就是 `push to back`、`peek/pop from front`、`size` 和 `is empty` 这些操作。
///     * 你所使用的语言也许不支持队列。 你可以使用 list （列表）或者 deque（双端队列）来模拟一个队列 , 只要是标准的队列操作即可。
/// + **示例：**
///     + **输入：**
///         - \["MyStack", "push", "push", "top", "pop", "empty"\]
///         - \[\[\], \[1\], \[2\], \[\], \[\], \[\]\]
///     + **输出：**
///         \[null, null, null, 2, 2, false\]
///     + **解释：**
///         ```java
///         MyStack myStack = new MyStack();
///         myStack.push(1);
///         myStack.push(2);
///         myStack.top(); // 返回 2
///         myStack.pop(); // 返回 2
///         myStack.empty(); // 返回 False
///         ```
/// + **提示：**
///     * `1 <= x <= 9`
///     * 最多调用`100` 次 `push`、`pop`、`top` 和 `empty`
///     * 每次调用 `pop` 和 `top` 都保证栈不为空
/// + **进阶：** 你能否仅用一个队列来实现栈。
/// + Related Topics
///     * 栈
///     * 设计
///     * 队列
/// * 👍 555
/// * 👎 0
#[derive(Default)]
struct MyStack {
    q: std::collections::vec_deque::VecDeque<i32>,
}

impl MyStack {
    fn new() -> Self {
        Default::default()
    }

    fn push(&mut self, x: i32) {
        self.q.push_front(x)
    }

    fn pop(&mut self) -> i32 {
        match self.empty() {
            true => -1,
            _ => self.q.pop_front().unwrap()
        }
    }

    fn top(&self) -> i32 {
        match self.empty() {
            true => -1,
            _ => *self.q.front().unwrap()
        }
    }

    fn empty(&self) -> bool {
        self.q.is_empty()
    }
}

#[cfg(test)]
mod test {
    #[test]
    fn test_q0225() {
        let mut obj = crate::design::q0225::MyStack::new();
        obj.push(1);
        assert_eq!(obj.pop(), 1);
        assert_eq!(obj.top(), -1);
        assert_eq!(obj.empty(), true);
    }
}
