use crate::structure::TreeNode;

use std::rc::Rc;
use std::cell::RefCell;
use std::convert::TryInto;
use std::iter::Map;
use std::slice::Chunks;

/// [297.二叉树的序列化与反序列化](https://leetcode-cn.com/problems/serialize-and-deserialize-binary-tree/)
///
/// [剑指 Offer II 048. 序列化与反序列化二叉树](https://leetcode.cn/problems/h54YBf/)
///
/// 2021-07-16 11:29:22
///
/// 序列化是将一个数据结构或者对象转换为连续的比特位的操作，进而可以将转换后的数据存储在一个文件或者内存中，同时也可以通过网络传输到另一个计算机环境，采取相反方
/// 式重构得到原数据。
///
/// 请设计一个算法来实现二叉树的序列化与反序列化。这里不限定你的序列 / 反序列化算法执行逻辑，你只需要保证一个二叉树可以被序列化为一个字符串并且将这个字符串
/// 反序列化为原始的树结构。
///
/// 提示: 输入输出格式与 `LeetCode` 目前使用的方式一致，详情请参阅 `LeetCode` 序列化二叉树的格式。你并非必须采取这种方式，你也可以采用其他的
/// 方法解决这个问题。
///
/// + 示例 1：
///     - 输入：`root = [1,2,3,null,null,4,5]`
///     - 输出：`[1,2,3,null,null,4,5]`
/// + 示例 2：
///     - 输入：`root = []`
///     - 输出：`[]`
/// + 示例 3：
///     - 输入：`root = [1]`
///     - 输出：`[1]`
/// + 示例 4：
///     - 输入：`root = [1,2]`
///     - 输出：`[1,2]`
/// + 提示：
///     - 树中结点数在范围 `[0, 104]` 内
///     - `-1000 <= Node.val <= 1000`
///
/// Related Topics 树 深度优先搜索 广度优先搜索 设计 字符串 二叉树
///
/// 👍 595 👎 0
pub struct Codec {}

impl Codec {
    fn new() -> Self {
        Self {}
    }

    fn serialize_sub(&self, root: Option<Rc<RefCell<TreeNode>>>, bytes: &mut Vec<u8>) {
        if let Some(node) = root {
            bytes.append(&mut node.borrow_mut().val.to_be_bytes().to_vec());
            self.serialize_sub(node.borrow_mut().left.take(), bytes);
            self.serialize_sub(node.borrow_mut().right.take(), bytes);
        } else {
            bytes.append(&mut i32::MAX.to_be_bytes().to_vec())
        }
    }

    fn serialize(&self, root: Option<Rc<RefCell<TreeNode>>>) -> String {
        let mut bytes = Vec::<u8>::new();
        self.serialize_sub(root, &mut bytes);
        unsafe { String::from_utf8_unchecked(bytes) }
    }

    fn deserialize_sub(&self, map: &mut Map<Chunks<u8>, fn(&[u8]) -> i32>) -> Option<Rc<RefCell<TreeNode>>> {
        match map.next()? {
            i32::MAX => None,
            val => Some(Rc::new(RefCell::new(TreeNode { val, left: self.deserialize_sub(map), right: self.deserialize_sub(map) })))
        }
    }

    fn deserialize(&self, data: String) -> Option<Rc<RefCell<TreeNode>>> {
        self.deserialize_sub(&mut data.into_bytes().chunks(4).map(|p| i32::from_be_bytes(p.try_into().unwrap())))
    }
}

#[cfg(test)]
mod test {
    use std::rc::Rc;
    use std::cell::RefCell;
    use crate::design::q0297::Codec;
    use crate::structure::TreeNode;

    #[test]
    fn test_q0297() {
        let root = Some(Rc::new(RefCell::new(TreeNode {
            val: 1,
            left: Some(Rc::new(RefCell::new(TreeNode {
                val: 2,
                left: None,
                right: None,
            }))),
            right: Some(Rc::new(RefCell::new(TreeNode {
                val: 3,
                left: Some(Rc::new(RefCell::new(TreeNode {
                    val: 4,
                    left: None,
                    right: None,
                }))),
                right: Some(Rc::new(RefCell::new(TreeNode {
                    val: 5,
                    left: None,
                    right: None,
                }))),
            }))),
        })));
        let obj = Codec::new();
        let data = obj.serialize(root);
        let ans = obj.deserialize(data);
    }
}
