/// [622.设计循环队列](https://leetcode-cn.com/problems/design-circular-queue/)
///
/// 2022-08-02 10:24:43
///
/// 设计你的循环队列实现。 循环队列是一种线性数据结构，其操作表现基于 FIFO（先进先出）原则并且队尾被连接在队首之后以形成一个循环。它也被称为“环形缓冲器”。
///
/// 循环队列的一个好处是我们可以利用这个队列之前用过的空间。在一个普通队列里，一旦一个队列满了，我们就不能插入下一个元素，即使在队列前面仍有空间。但是使用循环队列，我们能使用这些空间去存储新的值。
///
/// + 你的实现应该支持如下操作：
///     * `MyCircularQueue(k)`: 构造器，设置队列长度为 k 。
///     * `Front`: 从队首获取元素。如果队列为空，返回 -1 。
///     * `Rear`: 获取队尾元素。如果队列为空，返回 -1 。
///     * `enQueue(value)`: 向循环队列插入一个元素。如果成功插入则返回真。
///     * `deQueue()`: 从循环队列中删除一个元素。如果成功删除则返回真。
///     * `isEmpty()`: 检查循环队列是否为空。
///     * `isFull()`: 检查循环队列是否已满。
/// + **示例：**
///     ```c++
///     MyCircularQueue circularQueue = new MyCircularQueue(3); // 设置长度为 3
///     circularQueue.enQueue(1);  // 返回 true
///     circularQueue.enQueue(2);  // 返回 true
///     circularQueue.enQueue(3);  // 返回 true
///     circularQueue.enQueue(4);  // 返回 false，队列已满
///     circularQueue.Rear();  // 返回 3
///     circularQueue.isFull();  // 返回 true
///     circularQueue.deQueue();  // 返回 true
///     circularQueue.enQueue(4);  // 返回 true
///     circularQueue.Rear();  // 返回 4
///     ```
/// + **提示：**
///     * 所有的值都在 0 至 1000 的范围内；
///     * 操作数将在 1 至 1000 的范围内；
///     * 请不要使用内置的队列库。
/// + Related Topics
///     * 设计
///     * 队列
///     * 数组
///     * 链表
/// * 👍 337
/// * 👎 0
///
/// `&self` 表示该方法采用不可变引用。
/// 如果您需要可变引用，请将其更改为 `&mut self`。
struct MyCircularQueue {
    s:usize,
    e:usize,
    c:usize,
    q:Vec<i32>
}

impl MyCircularQueue {
    fn new(k: i32) -> Self {
        MyCircularQueue {
            s: 0,
            e: 0,
            c: (k + 1) as usize,
            q: vec![-1; (k + 1) as usize],
        }
    }

    fn en_queue(&mut self, value: i32) -> bool {
        if self.is_full() {
            return false;
        }
        self.q[self.e] = value;
        self.e = (self.e + 1) % self.c;
        true
    }

    fn de_queue(&mut self) -> bool {
        if self.is_empty() {
            return false;
        }
        self.s = (self.s + 1) % self.c;
        true
    }

    fn front(&self) -> i32 {
        match self.is_empty() {
            true => -1,
            _ => self.q[self.s]
        }
    }

    fn rear(&self) -> i32 {
        match self.is_empty() {
            true => -1,
            _ => self.q[(self.e + self.c - 1) % self.c]
        }
    }

    fn is_empty(&self) -> bool {
        self.s == self.e
    }

    fn is_full(&self) -> bool {
        ((self.e + 1) % self.c) == self.s
    }
}

#[cfg(test)]
mod test {
    use crate::design::q0622::MyCircularQueue;

    #[test]
    fn test_q0622() {
        let mut obj = MyCircularQueue::new(3);
        assert_eq!(obj.en_queue(1), true);
        assert_eq!(obj.en_queue(2), true);
        assert_eq!(obj.en_queue(3), true);
        assert_eq!(obj.en_queue(4), false);
        assert_eq!(obj.rear(), 3);
        assert_eq!(obj.is_full(), true);
        assert_eq!(obj.de_queue(), true);
        assert_eq!(obj.en_queue(4), true);
        assert_eq!(obj.rear(), 4);
    }
}