use crate::Solution;

/// [641.设计循环双端队列](https://leetcode.cn/problems/design-circular-deque/)
///
/// 2022-08-15 09:41:14
///
/// 设计实现双端队列。
///
/// + 实现 `MyCircularDeque` 类:
///     * `MyCircularDeque(int k)` ：构造函数,双端队列最大为 `k` 。
///     * `boolean insertFront()`：将一个元素添加到双端队列头部。 如果操作成功返回 `true` ，否则返回 `false` 。
///     * `boolean insertLast()` ：将一个元素添加到双端队列尾部。如果操作成功返回 `true` ，否则返回 `false` 。
///     * `boolean deleteFront()` ：从双端队列头部删除一个元素。 如果操作成功返回 `true` ，否则返回 `false` 。
///     * `boolean deleteLast()` ：从双端队列尾部删除一个元素。如果操作成功返回 `true` ，否则返回 `false` 。
///     * `int getFront()` )：从双端队列头部获得一个元素。如果双端队列为空，返回 `-1` 。
///     * `int getRear()` ：获得双端队列的最后一个元素。 如果双端队列为空，返回 `-1` 。
///     * `boolean isEmpty()` ：若双端队列为空，则返回 `true` ，否则返回 `false`  。
///     * `boolean isFull()` ：若双端队列满了，则返回 `true` ，否则返回 `false` 。
/// + **示例 1：**
///
/// + **输入**
///     + \["MyCircularDeque", "insertLast", "insertLast", "insertFront", "insertFront", "getRear", "isFull", "deleteLast", "insertFront", "getFront"\]
///     + \[\[3\], \[1\], \[2\], \[3\], \[4\], \[\], \[\], \[\], \[4\], \[\]\]
/// + **输出**
///     + \[null, true, true, true, false, 2, true, true, true, 4\]
/// + **解释**
///     ```java
///     MyCircularDeque circularDeque = new MycircularDeque(3); // 设置容量大小为3
///     circularDeque.insertLast(1);			                // 返回 true
///     circularDeque.insertLast(2);			                // 返回 true
///     circularDeque.insertFront(3);			                // 返回 true
///     circularDeque.insertFront(4);			                // 已经满了，返回 false
///     circularDeque.getRear();  				                // 返回 2
///     circularDeque.isFull();				                    // 返回 true
///     circularDeque.deleteLast();			                    // 返回 true
///     circularDeque.insertFront(4);			                // 返回 true
///     circularDeque.getFront();				                // 返回 4
///     ```
/// + **提示：**
///     * `1 <= k <= 1000`
///     * `0 <= value <= 1000`
///     * `insertFront`, `insertLast`, `deleteFront`, `deleteLast`, `getFront`, `getRear`, `isEmpty`, `isFull`  调用次数不大于 `2000` 次
/// + Related Topics
///     * 设计
///     * 队列
///     * 数组
///     * 链表
struct MyCircularDeque {
    s: usize,
    e: usize,
    c: usize,
    q: Vec<i32>,
}

impl MyCircularDeque {
    fn new(k: i32) -> Self {
        MyCircularDeque {
            s: 0,
            e: 0,
            c: (k + 1) as usize,
            q: vec![-1; (k + 1) as usize],
        }
    }

    fn insert_front(&mut self, value: i32) -> bool {
        if self.is_full() {
            return false;
        }
        self.s = match self.s {
            0 => self.c - 1,
            _ => (self.s - 1) % self.c
        };
        self.q[self.s] = value;
        true
    }

    fn insert_last(&mut self, value: i32) -> bool {
        if self.is_full() {
            return false;
        }
        self.q[self.e] = value;
        self.e = (self.e + 1) % self.c;
        true
    }

    fn delete_front(&mut self) -> bool {
        if self.is_empty() {
            return false;
        }
        self.s = (self.s + 1) % self.c;
        true
    }

    fn delete_last(&mut self) -> bool {
        if self.is_empty() {
            return false;
        }
        self.e = match self.e {
            0 => self.c - 1,
            _ => (self.e - 1) % self.c
        };
        true
    }

    fn get_front(&self) -> i32 {
        match self.is_empty() {
            true => -1,
            _ => self.q[self.s]
        }
    }

    fn get_rear(&self) -> i32 {
        match self.is_empty() {
            true => -1,
            _ => self.q[(self.e + self.c - 1) % self.c]
        }
    }

    fn is_empty(&self) -> bool {
        self.s == self.e
    }

    fn is_full(&self) -> bool {
        ((self.e + 1) % self.c) == self.s
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;
    use crate::design::q0641::MyCircularDeque;

    #[test]
    fn test_q0641() {
        let mut obj = MyCircularDeque::new(3);
        assert_eq!(obj.insert_last(1), true);
        assert_eq!(obj.insert_last(2), true);
        assert_eq!(obj.insert_front(3), true);
        assert_eq!(obj.insert_front(4), false);
        assert_eq!(obj.get_rear(), 2);
        assert_eq!(obj.is_full(), true);
        assert_eq!(obj.delete_last(), true);
        assert_eq!(obj.insert_front(4), true);
        assert_eq!(obj.get_front(), 4);
    }
}
