/// [705.设计哈希集合](https://leetcode-cn.com/problems/design-hashset/)
///
/// 2021-11-02 09:29:07
///
/// 不使用任何内建的哈希表库设计一个哈希集合（HashSet）。
///
/// 实现 `MyHashSet` 类：
///
/// * `void add(key)` 向哈希集合中插入值 `key` 。
/// * `bool contains(key)` 返回哈希集合中是否存在这个值 `key` 。
/// * `void remove(key)` 将给定值 `key` 从哈希集合中删除。如果哈希集合中没有这个值，什么也不做。
///
/// **示例：**
///
/// **输入：**
///
/// \["MyHashSet", "add", "add", "contains", "contains", "add", "contains", "remove", "contains"\]
/// \[\[\], \[1\], \[2\], \[1\], \[3\], \[2\], \[2\], \[2\], \[2\]\]
///
/// **输出：**
///
/// \[null, null, null, true, false, null, true, null, false\]
///
/// **解释：**
///
/// ```java
/// MyHashSet myHashSet = new MyHashSet();
/// myHashSet.add(1);      // set = [1]
/// myHashSet.add(2);      // set = [1, 2]
/// myHashSet.contains(1); // 返回 True
/// myHashSet.contains(3); // 返回 False ，（未找到）
/// myHashSet.add(2);      // set = [1, 2]
/// myHashSet.contains(2); // 返回 True
/// myHashSet.remove(2);   // set = [1]
/// myHashSet.contains(2); // 返回 False ，（已移除）
/// ```
///
/// **提示：**
///
/// * `0 <= key <= 10^6`
/// * 最多调用 `10^4` 次 `add`、`remove` 和 `contains` 。
///
/// **进阶：** 你可以不使用内建的哈希集合库解决此问题吗？
///
/// Related Topics
///
/// + 设计
/// + 数组
/// + 哈希表
/// + 链表
/// + 哈希函数
///
/// * 👍 190
/// * 👎 0
struct MyHashSet {
    data: Vec<Vec<i32>>,
}


impl MyHashSet {
    const BASE: i32 = 811;

    fn new() -> Self {
        MyHashSet {
            data: vec![vec![]; MyHashSet::BASE as usize]
        }
    }

    fn hash(key: i32) -> usize {
        (key % MyHashSet::BASE) as usize
    }

    fn add(&mut self, key: i32) {
        let h = MyHashSet::hash(key);
        match self.data[h].binary_search(&key) {
            Err(idx) => { self.data[h].insert(idx, key); }
            _ => {}
        }
    }

    fn remove(&mut self, key: i32) {
        let h = MyHashSet::hash(key);
        match self.data[h].binary_search(&key) {
            Ok(idx) => { self.data[h].remove(idx); }
            _ => {}
        }
    }

    fn contains(&self, key: i32) -> bool {
        self.data[MyHashSet::hash(key)].binary_search(&key).is_ok()
    }
}


#[cfg(test)]
mod test {
    #[test]
    fn test_q0705() {
        let key = 123;
        let mut obj = crate::design::q0705::MyHashSet::new();
        obj.add(key);
        assert_eq!(obj.contains(key), true);
        obj.remove(key);
        assert_eq!(obj.contains(key), false);
    }
}
