use crate::Solution;

impl Solution {
    /// [面试题 16.07.最大数值](https://leetcode.cn/problems/maximum-lcci/)
    ///
    /// 2022-08-09 10:36:43
    ///
    /// 编写一个方法，找出两个数字`a`和`b`中最大的那一个。不得使用if-else或其他比较运算符。
    ///
    /// + **示例：**
    ///     + **输入：** a = 1, b = 2
    ///     + **输出：** 2
    /// + Related Topics
    ///     * 位运算
    ///     * 脑筋急转弯
    ///     * 数学
    /// # 方法1
    /// 内置函数
    /// ```rust
    /// pub fn maximum(a: i32, b: i32) -> i32 {
    ///     std::cmp::max(a, b)
    /// }
    /// ```
    /// # 方法2
    /// 数学公式 max(a, b) = (|a - b| + a + b) / 2。使用64位计算，避免溢出。实现见源码。
    pub fn maximum(a: i32, b: i32) -> i32 {
        ((a as i64 - b as i64).abs() + a as i64 + b as i64 >> 1) as i32
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_m1607() {
        assert_eq!(Solution::maximum(1, 2), 2);
    }
}
