use crate::Solution;

impl Solution {
    /// 面试题 17.21.直方图的水量
    ///
    /// [原题链接](https://leetcode-cn.com/problems/volume-of-histogram-lcci/)
    ///
    /// 2021-04-02 08:16:10
    ///
    /// 给定一个直方图(也称柱状图)，假设有人从上面源源不断地倒水，最后直方图能存多少水量?直方图的宽度为 1。
    ///
    /// ![示意图](https://assets.leetcode-cn.com/aliyun-lc-upload/uploads/2018/10/22/rainwatertrap.png)
    ///
    /// 上面是由数组 `[0,1,0,2,1,0,1,3,2,1,2,1]` 表示的直方图，在这种情况下，可以接 6 个单位的水（蓝色部分表示水）。 感谢 Marco
    /// s 贡献此图。
    ///
    /// 示例:
    /// - 输入: `[0,1,0,2,1,0,1,3,2,1,2,1]`
    /// - 输出: 6
    ///
    /// Related Topics 栈 数组 双指针
    ///
    /// 👍 77 👎 0
    pub fn trap(height: Vec<i32>) -> i32 {
        if height.len() < 3 {
            return 0;
        }
        let mut ans = 0;
        let (mut left, mut right) = (0usize, height.len() - 1);
        let (mut left_max, mut right_max) = (0, 0);
        while left < right {
            left_max = left_max.max(height[left]);
            right_max = right_max.max(height[right]);
            if height[left] < height[right] {
                ans += left_max - height[left];
                left += 1;
            } else {
                ans += right_max - height[right];
                right -= 1;
            }
        }
        ans
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_m1721() {
        let height = vec![0,1,0,2,1,0,1,3,2,1,2,1];
        let a = Solution::trap(height);
        assert_eq!(a, 6);
    }
}