use crate::Solution;

impl Solution {
    /// [1.两数之和](https://leetcode-cn.com/problems/two-sum/)
    ///
    /// 2022-02-18 10:37:48
    ///
    /// 给定一个整数数组 `nums` 和一个整数目标值 `target`，请你在该数组中找出 **和为目标值** _`target`_ 的那 **两个** 整数，并返回它们的数组下标。
    ///
    /// 你可以假设每种输入只会对应一个答案。但是，数组中同一个元素在答案里不能重复出现。
    ///
    /// 你可以按任意顺序返回答案。
    ///
    /// + **示例 1：**
    ///     + **输入：** nums = \[2,7,11,15\], target = 9
    ///     + **输出：** \[0,1\]
    ///     + **解释：** 因为 nums\[0\] + nums\[1\] == 9 ，返回 \[0, 1\] 。
    /// + **示例 2：**
    ///     + **输入：** nums = \[3,2,4\], target = 6
    ///     + **输出：** \[1,2\]
    /// + **示例 3：**
    ///     + **输入：** nums = \[3,3\], target = 6
    ///     + **输出：** \[0,1\]
    /// + **提示：**
    ///     * `2 <= nums.length <= 104`
    ///     * `-109 <= nums[i] <= 109`
    ///     * `-109 <= target <= 109`
    ///     * **只会存在一个有效答案**
    /// + **进阶：**你可以想出一个时间复杂度小于 `O(n2)` 的算法吗？
    /// + Related Topics
    ///     * 数组
    ///     * 哈希表
    /// * 👍 13449
    /// * 👎 0
    pub fn two_sum(nums: Vec<i32>, target: i32) -> Vec<i32> {
        let mut m = std::collections::HashMap::new();
        for (i, v) in nums.into_iter().enumerate() {
            if m.contains_key(&v) {
                return vec![m[&v], i as i32];
            }
            m.insert(target - v, i as i32);
        }
        vec![]
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0001() {
        let nums = vec![2, 7, 11, 15];
        let target = 9;
        assert_eq!(Solution::two_sum(nums, target), vec![0, 1]);
    }
}
