use crate::Solution;
use crate::structure::ListNode;

impl Solution {
    /// [2.两数相加](https://leetcode-cn.com/problems/add-two-numbers/)
    ///
    /// 2022-02-18 10:56:18
    ///
    /// 给你两个 **非空** 的链表，表示两个非负的整数。它们每位数字都是按照 **逆序** 的方式存储的，并且每个节点只能存储 **一位** 数字。
    ///
    /// 请你将两个数相加，并以相同形式返回一个表示和的链表。
    ///
    /// 你可以假设除了数字 0 之外，这两个数都不会以 0 开头。
    ///
    /// + **示例 1：**
    ///     + ![](https://assets.leetcode-cn.com/aliyun-lc-upload/uploads/2021/01/02/addtwonumber1.jpg)
    ///     + **输入：** l1 = \[2,4,3\], l2 = \[5,6,4\]
    ///     + **输出：** \[7,0,8\]
    ///     + **解释：** 342 + 465 = 807.
    /// + **示例 2：**
    ///     + **输入：** l1 = \[0\], l2 = \[0\]
    ///     + **输出：** \[0\]
    /// + **示例 3：**
    ///     + **输入：** l1 = \[9,9,9,9,9,9,9\], l2 = \[9,9,9,9\]
    ///     + **输出：** \[8,9,9,9,0,0,0,1\]
    /// + **提示：**
    ///     * 每个链表中的节点数在范围 `[1, 100]` 内
    ///     * `0 <= Node.val <= 9`
    ///     * 题目数据保证列表表示的数字不含前导零
    /// + Related Topics
    ///     * 递归
    ///     * 链表
    ///     * 数学
    /// * 👍 7500
    /// * 👎 0
    pub fn add_two_numbers(mut l1: Option<Box<ListNode>>, mut l2: Option<Box<ListNode>>) -> Option<Box<ListNode>> {
        let mut sum = 0;
        let mut l = None;
        let mut p = &mut l;

        loop {
            match (l1, l2) {
                (Some(v1), Some(v2)) => {
                    sum += v1.val + v2.val;
                    l1 = v1.next;
                    l2 = v2.next;
                }
                (Some(v1), None) => {
                    sum += v1.val;
                    l1 = v1.next;
                    l2 = None;
                }
                (None, Some(v2)) => {
                    sum += v2.val;
                    l2 = v2.next;
                    l1 = None;
                }
                _ => {
                    break;
                }
            }
            *p = Some(Box::new(ListNode::new(sum % 10))); //不管sum是否大于10，都可以使用sum%10的值来构建新“节点“
            sum /= 10; // 获取进位值，否则初始为0
            if let Some(p_box_node) = p {
                p = &mut p_box_node.next
            }
        }
        if sum != 0 {
            *p = Some(Box::new(ListNode::new(sum)));
        }
        l
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;
    use crate::structure::ListNode;

    #[test]
    fn test_q0002() {
        let l1 = Some(Box::new(ListNode {
            val: 2,
            next: Some(Box::new(ListNode {
                val: 4,
                next: Some(Box::new(ListNode::new(3))),
            })),
        }));
        let l2 = Some(Box::new(ListNode {
            val: 5,
            next: Some(Box::new(ListNode {
                val: 6,
                next: Some(Box::new(ListNode::new(4))),
            })),
        }));
        let ans = Some(Box::new(ListNode {
            val: 7,
            next: Some(Box::new(ListNode {
                val: 0,
                next: Some(Box::new(ListNode::new(8))),
            })),
        }));
        assert_eq!(Solution::add_two_numbers(l1, l2), ans);
    }
}
