use crate::Solution;


impl Solution {
    /// 3.无重复字符的最长子串
    ///
    /// [原题链接](https://leetcode-cn.com/problems/longest-substring-without-repeating-characters/)
    ///
    /// 2021-08-01 10:56:14
    ///
    /// 给定一个字符串 `s` ，请你找出其中不含有重复字符的 **最长子串** 的长度。
    ///
    /// + 示例 1:
    ///     - 输入: `s = "abcabcbb"`
    ///     - 输出: `3`
    ///     - 解释: 因为无重复字符的最长子串是 "abc"，所以其长度为 `3`。
    /// + 示例 2:
    ///     - 输入: `s = "bbbbb"`
    ///     - 输出: `1`
    ///     - 解释: 因为无重复字符的最长子串是 "b"，所以其长度为 1。
    /// + 示例 3:
    ///     - 输入: `s = "pwwkew"`
    ///     - 输出: `3`
    ///     - 解释: 因为无重复字符的最长子串是 "wke"，所以其长度为 `3`。
    ///        请注意，你的答案必须是 子串 的长度，"pwke" 是一个子序列，不是子串。
    /// + 示例 4:
    ///     - 输入: `s = ""`
    ///     - 输出: `0`
    /// + 提示：
    ///     - `0 <= s.length <= 5 * 104`
    ///     - `s` 由英文字母、数字、符号和空格组成
    ///
    /// Related Topics 哈希表 字符串 滑动窗口
    ///
    /// 👍 5840 👎 0
    ///
    /// # 方法1 HashMap
    /// ```rust
    /// pub fn length_of_longest_substring(s: String) -> i32 {
    ///     let s = s.into_bytes();
    ///     //存储每个字符最后的索引
    ///     let mut map = std::collections::HashMap::<u8, i32>::new();
    ///     //上一个重复值的索引 没有重复值的话返回 最后一个元素的索引减-1,为字符串的长度。
    ///     let mut k = -1i32;
    ///     //返回值
    ///     let mut ret = 0i32;
    ///     for (i, c) in s.iter().enumerate() {
    ///         let o = map.get(c).unwrap_or(&-1i32);
    ///         if k < *o {
    ///            k = *o;
    ///         } else {
    ///             ret = std::cmp::max(ret, i as i32 - k);
    ///         }
    ///         map.insert(*c, i as i32);
    ///     }
    ///     ret
    /// }
    /// ```
    /// # 方法2 查表
    /// 使用带索引的迭代好像效率差一点。。。实现见源码。
    pub fn length_of_longest_substring(s: String) -> i32 {
        let (s, mut map, mut k, mut ret) = (s.into_bytes(), [-1; 128], -1i32, 0i32);
        for i in 0..s.len() {
            let o = map[s[i] as usize];
            if k < o {
                k = o;
            } else {
                ret = ret.max(i as i32 - k);
            }
            map[s[i] as usize] = i as i32;
        }
        ret
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0003() {
        assert_eq!(Solution::length_of_longest_substring("tmmzuxt".to_string()), 5);
    }
}
