use crate::Solution;

impl Solution {
    /// [6.Z 字形变换](https://leetcode-cn.com/problems/zigzag-conversion/)
    ///
    /// 2022-02-18 11:14:16
    ///
    /// 将一个给定字符串 `s` 根据给定的行数 `numRows` ，以从上往下、从左到右进行 Z 字形排列。
    ///
    /// 比如输入字符串为 `"PAYPALISHIRING"` 行数为 `3` 时，排列如下：
    ///
    /// ``` txt
    /// P   A   H   N
    /// A P L S I I G
    /// Y   I   R
    /// ```
    ///
    /// 之后，你的输出需要从左往右逐行读取，产生出一个新的字符串，比如：`"PAHNAPLSIIGYIR"`。
    ///
    /// 请你实现这个将字符串进行指定行数变换的函数：
    ///
    /// ``` c++
    /// string convert(string s, int numRows);
    /// ```
    ///
    /// + **示例 1：**
    ///     + **输入：** s = "PAYPALISHIRING", numRows = 3
    ///     + **输出：** "PAHNAPLSIIGYIR"
    /// + **示例 2：**
    ///     + **输入：** s = "PAYPALISHIRING", numRows = 4
    ///     + **输出：** "PINALSIGYAHRPI"
    ///     + **解释：**
    ///         ``` txt
    ///         P     I    N
    ///         A   L S  I G
    ///         Y A   H R
    ///         P     I
    ///         ```
    /// + **示例 3：**
    ///     + **输入：**s = "A", numRows = 1
    ///     + **输出：**"A"
    /// + **提示：**
    ///     * `1 <= s.length <= 1000`
    ///     * `s` 由英文字母（小写和大写）、`','` 和 `'.'` 组成
    ///     * `1 <= numRows <= 1000`
    /// + Related Topics
    ///     * 字符串
    /// * 👍 1477
    /// * 👎 0
    pub fn convert(s: String, num_rows: i32) -> String {
        if num_rows <= 1 {
            return s;
        }
        let n = s.len();
        let num_rows = num_rows as usize;
        let cycle_len = 2 * num_rows - 2;
        let s = s.into_bytes();
        let mut ret = String::with_capacity(n);
        for i in 0..num_rows {
            let mut j = 0;
            while j + i < n {
                ret.push(s[i + j] as char);
                if i != 0 && i != num_rows - 1 && j + cycle_len - i < n {
                    ret.push(s[j + cycle_len - i] as char);
                }
                j += cycle_len;
            }
        }
        ret
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0006() {
        assert_eq!(Solution::convert("PAYPALISHIRING".to_string(), 3), "PAHNAPLSIIGYIR".to_string());
    }
}
