use crate::Solution;

impl Solution {
    /// 7.整数反转
    ///
    /// [原题链接](https://leetcode-cn.com/problems/reverse-integer/)
    ///
    /// 2021-05-03 09:50:59
    ///
    /// 给你一个 32 位的有符号整数 x ，返回将 x 中的数字部分反转后的结果。
    ///
    /// 如果反转后整数超过 32 位的有符号整数的范围 `[−2^31, 2^31 − 1]` ，就返回 0。
    /// 假设环境不允许存储 64 位整数（有符号或无符号）。
    ///
    /// + 示例 1：
    ///     - 输入：x = 123
    ///     - 输出：321
    /// + 示例 2：
    ///     - 输入：x = -123
    ///     - 输出：-321
    /// + 示例 3：
    ///     - 输入：x = 120
    ///     - 输出：21
    /// + 示例 4：
    ///     - 输入：x = 0
    ///     - 输出：0
    /// + 提示：
    ///     - -2^31 <= x <= 2^31 - 1
    ///
    /// Related Topics 数学
    ///
    /// 👍 2745 👎 0
    pub fn reverse(x: i32) -> i32 {
        let mut res = 0;
        let mut a = x.abs();
        while a > 0 {
            if res > i32::MAX / 10 || (res == i32::MAX / 10 && a % 10 > 7) { return 0; }
            res = res * 10 + a % 10;
            a /= 10;
        }
        res * x.signum()
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0007() {
        let x = 1534236469;
        let a = Solution::reverse(x);
        assert_eq!(a, 0);
    }
}
