use crate::Solution;

impl Solution {
    /// [9.回文数](https://leetcode-cn.com/problems/palindrome-number/)
    ///
    /// 2022-02-18 14:04:23
    ///
    /// 给你一个整数 `x` ，如果 `x` 是一个回文整数，返回 `true` ；否则，返回 `false` 。
    ///
    /// 回文数是指正序（从左向右）和倒序（从右向左）读都是一样的整数。
    ///
    /// > 例如，`121` 是回文，而 `123` 不是。
    ///
    /// + **示例 1：**
    ///     + **输入：** x = 121
    ///     + **输出：** true
    /// + **示例 2：**
    ///     + **输入：** x = -121
    ///     + **输出：** false
    ///     + **解释：** 从左向右读, 为 -121 。 从右向左读, 为 121- 。因此它不是一个回文数。
    /// + **示例 3：**
    ///     + **输入：** x = 10
    ///     + **输出：** false
    ///     + **解释：** 从右向左读, 为 01 。因此它不是一个回文数。
    /// + **提示：**
    ///     * `-231 <= x <= 231 - 1`
    /// + **进阶：**你能不将整数转为字符串来解决这个问题吗？
    /// + Related Topics
    ///     * 数学
    /// * 👍 1806
    /// * 👎 0
    ///
    /// 1. 方法1 字符串
    ///     ```rust
    ///     pub fn is_palindrome(x: i32) -> bool {
    ///         let xs = x.to_string().into_bytes();
    ///         let mut xsc = xs.clone();
    ///         xsc.reverse();
    ///         xs == xsc
    ///     }
    ///     ```
    /// 2. 方法2 对数 双指针
    ///     ```rust
    ///     pub fn is_palindrome(mut x: i32) -> bool {
    ///         if x < 0 {
    ///             return false;
    ///         }
    ///         let exp = (x as f64).log10() as u32;
    ///         let mut n = 10i32.pow(exp);
    ///         while x > 0 {
    ///             let top = x / n;
    ///             if top != x % 10 {
    ///                 return false;
    ///             }
    ///             x -= n * top;
    ///             x /= 10;
    ///             n /= 100;
    ///         }
    ///         true
    ///     }
    ///     ```
    /// 3. 方法3 求一半逆序数
    ///
    /// 实现见源码
    pub fn is_palindrome(mut x: i32) -> bool {
        if x < 0 || (x % 10 == 0 && x != 0) {
            return false;
        }
        let mut r = 0;
        while x > r {
            r = r * 10 + x % 10;
            x /= 10;
        }
        x == r || x == r / 10
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0009() {
        assert_eq!(Solution::is_palindrome(121), true);
    }
}
