use crate::Solution;

impl Solution {
    /// [11.盛最多水的容器](https://leetcode-cn.com/problems/container-with-most-water/)
    ///
    /// 2022-02-18 14:37:33
    ///
    /// 给定一个长度为 `n` 的整数数组 `height` 。有 `n` 条垂线，第 `i` 条线的两个端点是 `(i, 0)` 和 `(i, height[i])` 。
    ///
    /// 找出其中的两条线，使得它们与 `x` 轴共同构成的容器可以容纳最多的水。
    ///
    /// 返回容器可以储存的最大水量。
    ///
    /// **说明：** 你不能倾斜容器。
    ///
    /// + **示例 1：**
    ///     + ![](https://aliyun-lc-upload.oss-cn-hangzhou.aliyuncs.com/aliyun-lc-upload/uploads/2018/07/25/question_11.jpg)
    ///     + **输入：** \[1,8,6,2,5,4,8,3,7\]
    ///     + **输出：** 49
    ///     + **解释：** 图中垂直线代表输入数组 \[1,8,6,2,5,4,8,3,7\]。在此情况下，容器能够容纳水（表示为蓝色部分）的最大值为 49。
    /// + **示例 2：**
    ///     + **输入：** height = \[1,1\]
    ///     + **输出：** 1
    /// + **提示：**
    ///     * `n == height.length`
    ///     * `2 <= n <= 105`
    ///     * `0 <= height[i] <= 104`
    /// + Related Topics
    ///     * 贪心
    ///     * 数组
    ///     * 双指针
    /// * 👍 3190
    /// * 👎 0
    /// 1. 暴力模拟
    ///     ```rust
    ///     pub fn max_area(height: Vec<i32>) -> i32 {
    ///         let mut area = 0;
    ///         for i in 0..height.len() {
    ///             for j in (i + 1)..height.len() {
    ///                 area = area.max((j - i) as i32 * height[i].min(height[j]));
    ///             }
    ///         }
    ///         area
    ///     }
    ///     ```
    /// 2. 双指针
    ///
    ///     每次淘汰掉双指针最小的那个数。实现见源码
    pub fn max_area(height: Vec<i32>) -> i32 {
        let (mut l, mut r) = (0, height.len() - 1);
        let mut area = 0;
        while l < r {
            area = area.max((r - l) as i32 * height[l].min(height[r]));
            if height[l] <= height[r] {
                l += 1;
            } else {
                r -= 1;
            }
        }
        area
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0011() {
        let height = vec![1, 8, 6, 2, 5, 4, 8, 3, 7];
        assert_eq!(Solution::max_area(height), 49);
    }
}
