use crate::Solution;

impl Solution {
    /// [20.有效的括号](https://leetcode-cn.com/problems/valid-parentheses/)
    ///
    /// 2022-02-18 14:32:08
    ///
    /// 给定一个只包括 `'('`，`')'`，`'{'`，`'}'`，`'['`，`']'` 的字符串 `s` ，判断字符串是否有效。
    ///
    /// 有效字符串需满足：
    ///
    /// > 1. 左括号必须用相同类型的右括号闭合。
    /// > 2. 左括号必须以正确的顺序闭合。
    ///
    /// + **示例 1：**
    ///     + **输入：** s = "()"
    ///     + **输出：** true
    /// + **示例 2：**
    ///     + **输入：** s = "()\[\]{}"
    ///     + **输出：** true
    /// + **示例 3：**
    ///     + **输入：** s = "(\]"
    ///     + **输出：** false
    /// + **示例 4：**
    ///     + **输入：** s = "(\[)\]"
    ///     + **输出：** false
    /// + **示例 5：**
    ///     + **输入：** s = "{\[\]}"
    ///     + **输出：** true
    /// + **提示：**
    ///     * `1 <= s.length <= 104`
    ///     * `s` 仅由括号 `'()[]{}'` 组成
    /// + Related Topics
    ///     * 栈
    ///     * 字符串
    /// * 👍 2979
    /// * 👎 0
    pub fn is_valid(s: String) -> bool {
        if s.len() & 1 == 1 { return false; }
        let mut v = vec![];
        for c in s.into_bytes() {
            match c {
                b'(' | b'[' | b'{' => v.push(c + (1 << (c & 1))),
                _ => if Some(c) != v.pop() { return false }
            }
        }
        v.is_empty()
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0020() {
        assert_eq!(Solution::is_valid("()[]{}".to_string()), true);
    }
}
