use crate::Solution;
use crate::structure::ListNode;


impl Solution {
    /// 21.合并两个有序链表
    ///
    /// [原题链接](https://leetcode-cn.com/problems/merge-two-sorted-lists/)
    ///
    /// 2021-07-31 15:20:33
    ///
    /// 将两个升序链表合并为一个新的 **升序** 链表并返回。新链表是通过拼接给定的两个链表的所有节点组成的。
    ///
    /// + 示例 1：
    ///     - 输入：`l1 = [1,2,4], l2 = [1,3,4]`
    ///     - 输出：`[1,1,2,3,4,4]`
    /// + 示例 2：
    ///     - 输入：`l1 = [], l2 = []`
    ///     - 输出：`[]`
    /// + 示例 3：
    ///     - 输入：`l1 = [], l2 = [0]`
    ///     - 输出：`[0]`
    /// + 提示：
    ///     - 两个链表的节点数目范围是 `[0, 50]`
    ///     - `-100 <= Node.val <= 100`
    ///     - `l1` 和 `l2` 均按 **非递减顺序** 排列
    ///
    /// Related Topics 递归 链表
    ///
    /// 👍 1822 👎 0
    pub fn merge_two_lists(l1: Option<Box<ListNode>>, l2: Option<Box<ListNode>>) -> Option<Box<ListNode>> {
        match (l1, l2) {
            (Some(n1), Some(n2)) =>
                if n1.val < n2.val {
                    Some(Box::new(ListNode { val: n1.val, next: Solution::merge_two_lists(n1.next, Some(n2)) }))
                } else {
                    Some(Box::new(ListNode { val: n2.val, next: Solution::merge_two_lists(Some(n1), n2.next) }))
                }
            (Some(n1), None) => Some(n1),
            (None, Some(n2)) => Some(n2),
            _ => None
        }
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;
    use crate::structure::ListNode;

    #[test]
    fn test_q0021() {
        let l1 = ListNode::from_vec(vec![1, 2, 4]);
        let l2 = ListNode::from_vec(vec![1, 3, 4]);
        let ans = Solution::merge_two_lists(l1, l2);
        let merge = ListNode::from_vec(vec![1, 1, 2, 3, 4, 4]);
        assert_eq!(merge, ans);
    }
}
