use crate::Solution;

impl Solution {
    /// 28.实现 strStr()
    ///
    /// [原题链接](https://leetcode-cn.com/problems/implement-strstr/)
    ///
    /// 2021-04-20 09:35:23
    ///
    /// 实现 strStr() 函数。
    ///
    /// 给你两个字符串 haystack 和 needle ，请你在 haystack 字符串中找出 needle 字符串出现的第一个位置（下标从 0 开始）。如
    /// 果不存在，则返回 -1 。
    ///
    /// 说明：
    ///
    /// 当 needle 是空字符串时，我们应当返回什么值呢？这是一个在面试中很好的问题。
    ///
    /// 对于本题而言，当 needle 是空字符串时我们应当返回 0 。这与 C 语言的 strstr() 以及 Java 的 indexOf() 定义相符。
    ///
    /// + 示例 1：
    ///     - 输入：haystack = "hello", needle = "ll"
    ///     - 输出：2
    /// + 示例 2：
    ///     - 输入：haystack = "aaaaa", needle = "bba"
    ///     - 输出：-1
    /// + 示例 3：
    ///     - 输入：haystack = "", needle = ""
    ///     - 输出：0
    /// + 提示：
    ///     - 0 <= haystack.length, needle.length <= 5 * 104
    ///     - haystack 和 needle 仅由小写英文字符组成
    ///
    /// Related Topics 双指针 字符串
    ///
    /// 👍 805 👎 0
    ///
    /// # 方法1 内置函数
    /// ```rust
    /// pub fn str_str(haystack: String, needle: String) -> i32 {
    ///     if let Some(idx) = haystack.find(&needle) {
    ///         idx as i32
    ///     } else {
    ///         -1i32
    ///     }
    /// }
    /// ```
    /// # 方法2 KMP
    /// todo
    pub fn str_str(haystack: String, needle: String) -> i32 {
        if let Some(idx) = haystack.find(&needle) {
            idx as i32
        } else {
            -1i32
        }
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0028() {
        let haystack = "hello".to_string();
        let needle = "ll".to_string();
        let i = Solution::str_str(haystack, needle);
        assert_eq!(i, 2);
    }
}
