use crate::Solution;

impl Solution {
    /// [29.两数相除](https://leetcode-cn.com/problems/divide-two-integers/)
    ///
    /// 2022-02-18 14:42:40
    ///
    /// 给定两个整数，被除数 `dividend` 和除数 `divisor`。将两数相除，要求不使用乘法、除法和 mod 运算符。
    ///
    /// 返回被除数 `dividend` 除以除数 `divisor` 得到的商。
    ///
    /// 整数除法的结果应当截去（`truncate`）其小数部分，例如：`truncate(8.345) = 8` 以及 `truncate(-2.7335) = -2`
    ///
    /// + **示例 1:**
    ///     + **输入:** dividend = 10, divisor = 3
    ///     + **输出:** 3
    ///     + **解释:** 10/3 = truncate(3.33333..) = truncate(3) = 3
    /// + **示例 2:**
    ///     + **输入:** dividend = 7, divisor = -3
    ///     + **输出:** -2
    ///     + **解释:** 7/-3 = truncate(-2.33333..) = -2
    /// + **提示：**
    ///     * 被除数和除数均为 32 位有符号整数。
    ///     * 除数不为 0。
    ///     * 假设我们的环境只能存储 32 位有符号整数，其数值范围是 \[−231,  231 − 1\]。本题中，如果除法结果溢出，则返回 231 − 1。
    /// + Related Topics
    ///     * 位运算
    ///     * 数学
    /// * 👍 839
    /// * 👎 0
    ///
    /// 1. 内置API
    ///     ```rust
    ///     pub fn divide(dividend: i32, divisor: i32) -> i32 {
    ///         use std::ops::Div;
    ///         if divisor == 0 {
    ///             return 0;
    ///         } else if divisor == -1 && dividend == i32::MIN {
    ///             return i32::MAX;
    ///         }
    ///         dividend.div(divisor)
    ///     }
    ///     ```
    /// 2. 位运算除法
    pub fn divide(dividend: i32, divisor: i32) -> i32 {
        if divisor == 0 {
            return 0;
        } else if divisor == -1 && dividend == i32::MIN {
            return i32::MAX;
        }
        let negative = (dividend ^ divisor) < 0;
        let mut t = (dividend as i64).abs();
        let mut d = (divisor as i64).abs();
        let mut ret = 0;
        for i in (0..32).rev() {
            if (t >> i) >= d {
                ret |= 1 << i;
                t -= d << i;
            }
        }
        match negative {
            true => -ret,
            _ => ret
        }
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0029() {
        assert_eq!(Solution::divide(10, 3), 3);
    }
}
