use crate::Solution;


impl Solution {
    /// 35.搜索插入位置
    ///
    /// [原题链接](https://leetcode-cn.com/problems/search-insert-position/)
    ///
    /// 2021-07-19 14:42:33
    ///
    /// 给定一个排序数组和一个目标值，在数组中找到目标值，并返回其索引。如果目标值不存在于数组中，返回它将会被按顺序插入的位置。
    ///
    /// 请必须使用时间复杂度为 `O(log n)` 的算法。
    ///
    /// + 示例 1:
    ///     - 输入: `nums = [1,3,5,6], target = 5`
    ///     - 输出: `2`
    /// + 示例 2:
    ///     - 输入: `nums = [1,3,5,6], target = 2`
    ///     - 输出: `1`
    /// + 示例 3:
    ///     - 输入: `nums = [1,3,5,6], target = 7`
    ///     - 输出: `4`
    /// + 示例 4:
    ///     - 输入: `nums = [1,3,5,6], target = 0`
    ///     - 输出: `0`
    /// + 示例 5:
    ///     - 输入: `nums = [1], target = 0`
    ///     - 输出: `0`
    /// + 提示:
    ///     - `1 <= nums.length <= 104`
    ///     - `-104 <= nums[i] <= 104`
    ///     - `nums` 为无重复元素的升序排列数组
    ///     - `-104 <= target <= 104`
    ///
    /// Related Topics 数组 二分查找
    ///
    /// 👍 969 👎 0
    ///
    /// # 方法1 线性搜索
    /// ```rust
    /// pub fn search_insert(nums: Vec<i32>, target: i32) -> i32 {
    ///     if nums.is_empty() {
    ///         return 0;
    ///     }
    ///     for i in 0..nums.len() {
    ///         if target <= nums[i] {
    ///             return i as i32;
    ///         }
    ///     }
    ///     nums.len() as i32
    /// }
    /// ```
    /// # 方法2 二分查找
    pub fn search_insert(nums: Vec<i32>, target: i32) -> i32 {
        let mut l: i32 = 0;
        let mut r: i32 = nums.len() as i32 - 1;
        while l <= r {
            let mut m = (l + (r - l) / 2);
            if target <= nums[m as usize] {
                r = m - 1;
            } else {
                l = m + 1;
            }
        }
        return l;
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0035() {
        let nums = vec![1, 3, 5, 6];
        let target = 5;
        let ans = Solution::search_insert(nums, target);
        assert_eq!(ans, 2);
    }
}
