use crate::Solution;

impl Solution {
    /// [36.有效的数独](https://leetcode-cn.com/problems/valid-sudoku/)
    ///
    /// 2022-02-18 14:48:44
    ///
    /// 请你判断一个 `9 x 9` 的数独是否有效。只需要 **根据以下规则** ，验证已经填入的数字是否有效即可。
    ///
    /// > 1. 数字 `1-9` 在每一行只能出现一次。
    /// > 2. 数字 `1-9` 在每一列只能出现一次。
    /// > 3. 数字 `1-9` 在每一个以粗实线分隔的 `3x3` 宫内只能出现一次。（请参考示例图）
    ///
    /// + **注意：**
    ///     * 一个有效的数独（部分已被填充）不一定是可解的。
    ///     * 只需要根据以上规则，验证已经填入的数字是否有效即可。
    ///     * 空白格用 `'.'` 表示。
    /// + **示例 1：**
    ///     + ![](https://assets.leetcode-cn.com/aliyun-lc-upload/uploads/2021/04/12/250px-sudoku-by-l2g-20050714svg.png)
    ///     + **输入：**
    ///         ``` txt
    ///         board = [["5","3",".",".","7",".",".",".","."],
    ///                  ["6",".",".","1","9","5",".",".","."],
    ///                  [".","9","8",".",".",".",".","6","."],
    ///                  ["8",".",".",".","6",".",".",".","3"],
    ///                  ["4",".",".","8",".","3",".",".","1"],
    ///                  ["7",".",".",".","2",".",".",".","6"],
    ///                  [".","6",".",".",".",".","2","8","."],
    ///                  [".",".",".","4","1","9",".",".","5"],
    ///                  [".",".",".",".","8",".",".","7","9"]]
    ///          ```
    ///     + **输出：** true
    /// + **示例 2：**
    ///     + **输入：**
    ///         ``` txt
    ///         board = [["8","3",".",".","7",".",".",".","."],
    ///                  ["6",".",".","1","9","5",".",".","."],
    ///                  [".","9","8",".",".",".",".","6","."],
    ///                  ["8",".",".",".","6",".",".",".","3"],
    ///                  ["4",".",".","8",".","3",".",".","1"],
    ///                  ["7",".",".",".","2",".",".",".","6"],
    ///                  [".","6",".",".",".",".","2","8","."],
    ///                  [".",".",".","4","1","9",".",".","5"],
    ///                  [".",".",".",".","8",".",".","7","9"]]
    ///         ```
    ///     + **输出：** false
    ///     + **解释：** 除了第一行的第一个数字从 **5** 改为 **8** 以外，空格内其他数字均与 示例1 相同。 但由于位于左上角的 3x3 宫内有两个 8 存在, 因此这个数独是无效的。
    /// + **提示：**
    ///     * `board.length == 9`
    ///     * `board[i].length == 9`
    ///     * `board[i][j]` 是一位数字（`1-9`）或者 `'.'`
    /// + Related Topics
    ///     * 数组
    ///     * 哈希表
    ///     * 矩阵
    /// * 👍 768
    /// * 👎 0
    pub fn is_valid_sudoku(board: Vec<Vec<char>>) -> bool {
        let mut row_lookup = [[false; 9]; 9];
        let mut col_lookup = [[false; 9]; 9];
        let mut sub_lookup = [[false; 9]; 9];
        for row in 0..9 {
            for col in 0..9 {
                if board[row][col] == '.' { continue; }
                let idx = board[row][col] as usize - '1' as usize;
                let sub_idx = ((row / 3) * 3 + col / 3) as usize;
                if row_lookup[row][idx] || col_lookup[col][idx] || sub_lookup[sub_idx][idx] {
                    return false;
                } else {
                    row_lookup[row][idx] = true;
                    col_lookup[col][idx] = true;
                    sub_lookup[sub_idx][idx] = true;
                }
            }
        }
        return true;
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0036() {
        let board =
            vec![vec!['5', '3', '.', '.', '7', '.', '.', '.', '.'],
                 vec!['6', '.', '.', '1', '9', '5', '.', '.', '.'],
                 vec!['.', '9', '8', '.', '.', '.', '.', '6', '.'],
                 vec!['8', '.', '.', '.', '6', '.', '.', '.', '3'],
                 vec!['4', '.', '.', '8', '.', '3', '.', '.', '1'],
                 vec!['7', '.', '.', '.', '2', '.', '.', '.', '6'],
                 vec!['.', '6', '.', '.', '.', '.', '2', '8', '.'],
                 vec!['.', '.', '.', '4', '1', '9', '.', '.', '5'],
                 vec!['.', '.', '.', '.', '8', '.', '.', '7', '9']];
        assert_eq!(Solution::is_valid_sudoku(board), true);
    }
}
