use crate::Solution;


impl Solution {
    /// 46.全排列
    ///
    /// [原题链接](https://leetcode-cn.com/problems/permutations/)
    ///
    /// 2021-08-01 10:31:42
    ///
    /// 给定一个不含重复数字的数组 nums ，返回其 所有可能的全排列 。你可以 按任意顺序 返回答案。
    ///
    /// + 示例 1：
    ///     - 输入：`nums = [1,2,3]`
    ///     - 输出：`[[1,2,3],[1,3,2],[2,1,3],[2,3,1],[3,1,2],[3,2,1]]`
    /// + 示例 2：
    ///     - 输入：`nums = [0,1]`
    ///     - 输出：`[[0,1],[1,0]]`
    /// + 示例 3：
    ///     - 输入：`nums = [1]`
    ///     - 输出：`[[1]]`
    /// + 提示：
    ///     - `1 <= nums.length <= 6`
    ///     - `-10 <= nums[i] <= 10`
    ///     - `nums` 中的所有整数 互不相同
    ///
    /// Related Topics 数组 回溯
    ///
    /// 👍 1468 👎 0
    pub fn permute(mut nums: Vec<i32>) -> Vec<Vec<i32>> {
        fn dfs(ret: &mut Vec<Vec<i32>>, nums: &mut Vec<i32>, path: &mut Vec<i32>) {
            if nums.is_empty() {
                ret.push(path.clone());
            }
            for i in 0..nums.len() {
                path.push(nums[i]);
                let mut new_nums = nums.clone();
                new_nums.remove(i);
                dfs(ret, &mut new_nums, path);
                path.pop();
            }
        }
        let mut ret = Vec::<Vec<i32>>::new();
        dfs(&mut ret, &mut nums, &mut Vec::new());
        ret
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0046() {
        assert_eq!(Solution::permute(vec![1, 2, 3]), vec![vec![1, 2, 3], vec![1, 3, 2], vec![2, 1, 3], vec![2, 3, 1], vec![3, 1, 2], vec![3, 2, 1]]);
    }
}
