use crate::Solution;


impl Solution {
    /// [48.旋转图像](https://leetcode-cn.com/problems/rotate-image/)
    ///
    /// 2022-02-18 15:03:55
    ///
    /// 给定一个 _n _× _n_ 的二维矩阵 `matrix` 表示一个图像。请你将图像顺时针旋转 90 度。
    ///
    /// 你必须在 **[原地](https://baike.baidu.com/item/%E5%8E%9F%E5%9C%B0%E7%AE%97%E6%B3%95)** 旋转图像，这意味着你需要直接修改输入的二维矩阵。**请不要** 使用另一个矩阵来旋转图像。
    ///
    /// + **示例 1：**
    ///     + ![](https://assets.leetcode.com/uploads/2020/08/28/mat1.jpg)
    ///     + **输入：** matrix = \[\[1,2,3\],\[4,5,6\],\[7,8,9\]\]
    ///     + **输出：** \[\[7,4,1\],\[8,5,2\],\[9,6,3\]\]
    /// + **示例 2：**
    ///     + ![](https://assets.leetcode.com/uploads/2020/08/28/mat2.jpg)
    ///     + **输入：** matrix = \[\[5,1,9,11\],\[2,4,8,10\],\[13,3,6,7\],\[15,14,12,16\]\]
    ///     + **输出：** \[\[15,13,2,5\],\[14,3,4,1\],\[12,6,8,9\],\[16,7,10,11\]\]
    /// + **提示：**
    ///     * `n == matrix.length == matrix[i].length`
    ///     * `1 <= n <= 20`
    ///     * `-1000 <= matrix[i][j] <= 1000`
    /// + Related Topics
    ///     * 数组
    ///     * 数学
    ///     * 矩阵
    /// * 👍 1169
    /// * 👎 0
    ///
    /// 1. 新矩阵旋转行
    ///     ```rust
    ///     pub fn rotate1(matrix: &mut Vec<Vec<i32>>) {
    ///         let n = matrix.len();
    ///         let mut matrix_new = matrix.clone();
    ///         for i in 0..n {
    ///             for j in 0..n {
    ///                 matrix_new[j][n - i - 1] = matrix[i][j];
    ///             }
    ///         }
    ///         *matrix = matrix_new;
    ///     }
    ///     ```
    /// 2. 原地旋转 分块
    ///     ```rust
    ///     pub fn rotate1(matrix: &mut Vec<Vec<i32>>) {
    ///         let n = matrix.len();
    ///         for i in 0..n / 2 {
    ///             for j in 0..(n + 1) / 2 {
    ///                 let temp = matrix[i][j];
    ///                 matrix[i][j] = matrix[n - j - 1][i];
    ///                 matrix[n - j - 1][i] = matrix[n - i - 1][n - j - 1];
    ///                 matrix[n - i - 1][n - j - 1] = matrix[j][n - i - 1];
    ///                 matrix[j][n - i - 1] = temp;
    ///             }
    ///         }
    ///     }
    ///     ```
    /// 3. 翻转代替旋转
    pub fn rotate1(matrix: &mut Vec<Vec<i32>>) {
        let n = matrix.len();
        for i in 0..n / 2 {
            for j in 0..n {
                matrix[i][j] ^= matrix[n - i - 1][j];
                matrix[n - i - 1][j] ^= matrix[i][j];
                matrix[i][j] ^= matrix[n - i - 1][j];
            }
        }
        for i in 0..n {
            for j in 0..i {
                matrix[i][j] ^= matrix[j][i];
                matrix[j][i] ^= matrix[i][j];
                matrix[i][j] ^= matrix[j][i];
            }
        }
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0048() {
        let mut matrix = vec![vec![5, 1, 9, 11], vec![2, 4, 8, 10], vec![13, 3, 6, 7], vec![15, 14, 12, 16]];
        let ans = vec![vec![15, 13, 2, 5], vec![14, 3, 4, 1], vec![12, 6, 8, 9], vec![16, 7, 10, 11]];
        Solution::rotate1(&mut matrix);
        assert_eq!(matrix, ans);
    }
}
