use crate::Solution;

impl Solution {
    /// 53.最大子序和
    ///
    /// [原题链接](https://leetcode-cn.com/problems/maximum-subarray/)
    ///
    /// 2021-07-15 12:43:11
    ///
    /// 给定一个整数数组 `nums` ，找到一个具有最大和的连续子数组（子数组最少包含一个元素），返回其最大和。
    ///
    /// + 示例 1：
    ///     - 输入：`nums = [-2,1,-3,4,-1,2,1,-5,4]`
    ///     - 输出：`6`
    ///     - 解释：连续子数组 `[4,-1,2,1]` 的和最大，为 `6` 。
    /// + 示例 2：
    ///     - 输入：`nums = [1]`
    ///     - 输出：`1`
    /// + 示例 3：
    ///     - 输入：`nums = [0]`
    ///     - 输出：`0`
    /// + 示例 4：
    ///     - 输入：`nums = [-1]`
    ///     - 输出：`-1`
    /// + 示例 5：
    ///     - 输入：`nums = [-100000]`
    ///     - 输出：`-100000`
    /// + 提示：
    ///     - `1 <= nums.length <= 3 * 104`
    ///     - `-105 <= nums[i] <= 105`
    ///
    /// 进阶：如果你已经实现复杂度为 `O(n)` 的解法，尝试使用更为精妙的 分治法 求解。
    ///
    /// Related Topics 数组 分治 动态规划
    ///
    /// 👍 3415 👎 0
    pub fn max_sub_array(nums: Vec<i32>) -> i32 {
        /*let mut pre= 0;
        let mut max_ans = i32::MIN;
        nums.iter().for_each(|v| { pre = core::cmp::max(pre + *v, *v); max_ans = core::cmp::max(max_ans, pre); });
        max_ans
        let mut pre = 0;
        nums.iter().fold(i32::MIN, |mut acc, &x| {
            pre = core::cmp::max(pre + x, x);
            core::cmp::max(pre, acc)
        })*/
        nums.iter().fold((0, i32::MIN), |(mut a, mut b), &x| {
            a = x.max(a + x);
            b = b.max(a);
            (a, b)
        }).1
        //nums.into_iter().fold((0, i32::MIN), |(a, b), x| (x.max(a + x), b.max(x.max(a + x)))).1
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0053() {
        let nums = vec![-2, 1, -3, 4, -1, 2, 1, -5, 4];
        let ans = Solution::max_sub_array(nums);
        assert_eq!(ans, 6);
    }
}
