use crate::Solution;

impl Solution {
    /// 55.跳跃游戏
    ///
    /// [原题链接](https://leetcode-cn.com/problems/jump-game/)
    ///
    /// 2021-07-15 08:50:04
    ///
    /// 给定一个非负整数数组 `nums` ，你最初位于数组的 第一个下标 。
    ///
    /// 数组中的每个元素代表你在该位置可以跳跃的最大长度。
    ///
    /// 判断你是否能够到达最后一个下标。
    ///
    /// + 示例 1：
    ///     - 输入：`nums = [2,3,1,1,4]`
    ///     - 输出：`true`
    ///     - 解释：可以先跳 `1` 步，从下标 `0` 到达下标 `1`, 然后再从下标 `1` 跳 `3` 步到达最后一个下标。
    /// + 示例 2：
    ///     - 输入：`nums = [3,2,1,0,4]`
    ///     - 输出：`false`
    ///     - 解释：无论怎样，总会到达下标为 3 的位置。但该下标的最大跳跃长度是 0 ， 所以永远不可能到达最后一个下标。
    /// + 提示：
    ///     - `1 <= nums.length <= 3 * 104`
    ///     - `0 <= nums[i] <= 105`
    ///
    /// Related Topics 贪心 数组 动态规划
    ///
    /// 👍 1263 👎 0
    pub fn can_jump(nums: Vec<i32>) -> bool {
        /*let mut dp = vec![0; nums.len()];
        dp[0] = 1;
        for (i, &n) in nums.iter().enumerate() {
            if dp[i] == 0 {
                break
            }
            for j in (i + 1)..= (i + n as usize) {
                if j >= dp.len() {
                    break;
                }
                dp[j] += 1;
            }
            if *dp.last().unwrap() > 0 {
                return true;
            }
        }
        *dp.last().unwrap() > 0*/
        let mut rightmost = 0;
        let mut i = 0;
        while i <= rightmost {
            rightmost = rightmost.max(i + nums[i] as usize);
            if rightmost + 1 >= nums.len() {
                return true;
            }
            i += 1;
        }
        false
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0055() {
        let nums = vec![3, 2, 1, 0, 4];
        let ans = Solution::can_jump(nums);
        assert_eq!(ans, false);
    }
}
