use crate::Solution;

impl Solution {
    /// [56.合并区间](https://leetcode.cn/problems/merge-intervals/)
    ///
    /// 2022-08-08 14:19:46
    ///
    /// 以数组 `intervals` 表示若干个区间的集合，其中单个区间为 `intervals[i] = [starti, endi]` 。请你合并所有重叠的区间，并返回 _一个不重叠的区间数组，该数组需恰好覆盖输入中的所有区间_ 。
    ///
    /// + **示例 1：**
    ///     + **输入：** intervals = \[\[1,3\],\[2,6\],\[8,10\],\[15,18\]\]
    ///     + **输出：** \[\[1,6\],\[8,10\],\[15,18\]\]
    ///     + **解释：** 区间 \[1,3\] 和 \[2,6\] 重叠, 将它们合并为 \[1,6\].
    /// + **示例 2：**
    ///     + **输入：** intervals = \[\[1,4\],\[4,5\]\]
    ///     + **输出：** \[\[1,5\]\]
    ///     + **解释：** 区间 \[1,4\] 和 \[4,5\] 可被视为重叠区间。
    /// + **提示：**
    ///     * `1 <= intervals.length <= 104`
    ///     * `intervals[i].length == 2`
    ///     * `0 <= starti <= endi <= 104`
    /// + Related Topics
    ///     * 数组
    ///     * 排序
    pub fn merge1(mut intervals: Vec<Vec<i32>>) -> Vec<Vec<i32>> {
        intervals.sort_unstable_by_key(|i| i[0]);
        let mut merged = Vec::<Vec<i32>>::new();
        for interval in intervals.into_iter() {
            if merged.is_empty() || merged[merged.len() -1][1] < interval[0] {
                merged.push(interval);
            } else {
                let last = merged.last_mut().unwrap();
                last[1] = last[1].max(interval[1]);
            }
        }
        merged
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0056() {
        assert_eq!(Solution::merge1(vec![vec![1, 3], vec![2, 6], vec![8, 10], vec![15, 18]]), vec![vec![1, 6], vec![8, 10], vec![15, 18]]);
    }
}
