use crate::Solution;

impl Solution {
    /// [57.插入区间](https://leetcode.cn/problems/insert-interval/)
    ///
    /// 2022-08-08 15:01:19
    ///
    /// 给你一个 **无重叠的** _，_按照区间起始端点排序的区间列表。
    ///
    /// 在列表中插入一个新的区间，你需要确保列表中的区间仍然有序且不重叠（如果有必要的话，可以合并区间）。
    ///
    /// + **示例 1：**
    ///     + **输入：** intervals = \[\[1,3\],\[6,9\]\], newInterval = \[2,5\]
    ///     + **输出：** \[\[1,5\],\[6,9\]\]
    /// + **示例 2：**
    ///     + **输入：** intervals = \[\[1,2\],\[3,5\],\[6,7\],\[8,10\],\[12,16\]\], newInterval = \[4,8\]
    ///     + **输出：** \[\[1,2\],\[3,10\],\[12,16\]\]
    ///     + **解释：** 这是因为新的区间 `[4,8]` 与 `[3,5],[6,7],[8,10]` 重叠。
    /// + **示例 3：**
    ///     + **输入：** intervals = \[\], newInterval = \[5,7\]
    ///     + **输出：** \[\[5,7\]\]
    /// + **示例 4：**
    ///     + **输入：** intervals = \[\[1,5\]\], newInterval = \[2,3\]
    ///     + **输出：** \[\[1,5\]\]
    /// + **示例 5：**
    ///     + **输入：** intervals = \[\[1,5\]\], newInterval = \[2,7\]
    ///     + **输出：** \[\[1,7\]\]
    /// + **提示：**
    ///     * `0 <= intervals.length <= 104`
    ///     * `intervals[i].length == 2`
    ///     * `0 <= intervals[i][0] <= intervals[i][1] <= 105`
    ///     * `intervals` 根据 `intervals[i][0]` 按 **升序** 排列
    ///     * `newInterval.length == 2`
    ///     * `0 <= newInterval[0] <= newInterval[1] <= 105`
    /// + Related Topics
    ///     * 数组
    pub fn insert(intervals: Vec<Vec<i32>>, new_interval: Vec<i32>) -> Vec<Vec<i32>> {
        let (mut l, mut r): (i32, i32) = (new_interval[0], new_interval[1]);
        let mut placed = false;
        let mut ans = Vec::<Vec<i32>>::new();
        for interval in intervals {
            if interval[0] > r {
                if !placed {
                    ans.push(vec![l, r]);
                    placed = true;
                }
                ans.push(interval);
            } else if interval[1] < l {
                ans.push(interval);
            } else {
                l = l.min(interval[0]);
                r = r.max(interval[1]);
            }
        }
        if !placed {
            ans.push(vec![l, r]);
        }
        ans
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0057() {
        assert_eq!(Solution::insert(vec![vec![1, 2], vec![3, 5], vec![6, 7], vec![8, 10], vec![12, 16]], vec![4, 8]), vec![vec![1, 2], vec![3, 10], vec![12, 16]]);
    }
}
