use crate::Solution;

impl Solution {
    /// [58.最后一个单词的长度](https://leetcode-cn.com/problems/length-of-last-word/)
    ///
    /// 2022-02-18 15:14:10
    ///
    /// 给你一个字符串 `s`，由若干单词组成，单词前后用一些空格字符隔开。返回字符串中最后一个单词的长度。
    ///
    /// **单词** 是指仅由字母组成、不包含任何空格字符的最大子字符串。
    ///
    /// + **示例 1：**
    ///     + **输入：** s = "Hello World"
    ///     + **输出：** 5
    /// + **示例 2：**
    ///     + **输入：** s = "   fly me   to   the moon  "
    ///     + **输出：** 4
    /// + **示例 3：**
    ///     + **输入：** s = "luffy is still joyboy"
    ///     + **输出：** 6
    /// + **提示：**
    ///     * `1 <= s.length <= 104`
    ///     * `s` 仅有英文字母和空格 `' '` 组成
    ///     * `s` 中至少存在一个单词
    /// + Related Topics
    ///     * 字符串
    /// * 👍 420
    /// * 👎 0
    /// 1. 反向遍历
    ///
    ///     实现见源码
    ///
    /// 2. 分割字符串
    ///
    ///     先删除尾部的无效字符，按空格分割字符串，去最后一个，返回其长度。
    ///
    ///     ```rust
    ///     pub fn length_of_last_word(s: String) -> i32 {
    ///         s.trim_end().split_whitespace().last().unwrap_or("").len() as i32
    ///     }
    ///     ```
    pub fn length_of_last_word(s: String) -> i32 {
        let mut ret = 0;
        let s = s.into_bytes();
        let mut is_last_word = false;
        for &c in s.iter().rev() {
            if c != b' ' {
                is_last_word = true;
            }
            if is_last_word {
                if c == b' ' {
                    is_last_word = false;
                    break;
                }
                ret += 1;
            }
        }
        ret
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0058() {
        assert_eq!(Solution::length_of_last_word("Hello World".to_string()), 5);
    }
}
