use crate::Solution;

impl Solution {
    /// [67.二进制求和](https://leetcode-cn.com/problems/add-binary/)
    ///
    /// 2022-02-18 15:27:04
    ///
    /// 给你两个二进制字符串，返回它们的和（用二进制表示）。
    ///
    /// 输入为 **非空** 字符串且只包含数字 `1` 和 `0`。
    ///
    /// + **示例 1:**
    ///     + **输入:** a = "11", b = "1"
    ///     + **输出:** "100"
    /// + **示例 2:**
    ///     + **输入:** a = "1010", b = "1011"
    ///     + **输出:** "10101"
    /// + **提示：**
    ///     * 每个字符串仅由字符 `'0'` 或 `'1'` 组成。
    ///     * `1 <= a.length, b.length <= 10^4`
    ///     * 字符串如果不是 `"0"` ，就都不含前导零。
    /// + Related Topics
    ///     * 位运算
    ///     * 数学
    ///     * 字符串
    ///     * 模拟
    /// * 👍 746
    /// * 👎 0
    pub fn add_binary(mut a: String, mut b: String) -> String {
        let mut carry = 0;
        let mut res = String::new();
        loop {
            let (n1, n2) = (a.pop(), b.pop());

            if n1 == None && n2 == None { break; }

            let mut sum = carry;
            if let Some(x) = n1 {
                sum += x.to_digit(2).unwrap();
            }
            if let Some(x) = n2 {
                sum += x.to_digit(2).unwrap();
            }

            carry = sum / 2;
            res.insert_str(0, &(sum % 2).to_string());
        }
        if carry > 0 { res.insert_str(0, &carry.to_string()); }
        res
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0067() {
        assert_eq!(Solution::add_binary("11".to_string(), "1".to_string()), "100".to_string());
    }
}
