use crate::Solution;

impl Solution {
    /// 70.爬楼梯
    ///
    /// [原题链接](https://leetcode-cn.com/problems/climbing-stairs/)
    ///
    /// 2021-07-13 21:32:05
    ///
    /// 假设你正在爬楼梯。需要 n 阶你才能到达楼顶。
    ///
    /// 每次你可以爬 1 或 2 个台阶。你有多少种不同的方法可以爬到楼顶呢？
    ///
    /// 注意：给定 n 是一个正整数。
    ///
    /// + 示例 1：
    ///     - 输入： 2
    ///     - 输出： 2
    ///     - 解释： 有两种方法可以爬到楼顶。
    ///         1.  1 阶 + 1 阶
    ///         2.  2 阶
    /// + 示例 2：
    ///     - 输入： 3
    ///     - 输出： 3
    ///     - 解释： 有三种方法可以爬到楼顶。
    ///         1.  1 阶 + 1 阶 + 1 阶
    ///         2.  1 阶 + 2 阶
    ///         3.  2 阶 + 1 阶
    ///
    /// Related Topics 记忆化搜索 数学 动态规划
    ///
    /// 👍 1745 👎 0
    pub fn climb_stairs(n: i32) -> i32 {
        (1..n).fold((1, 2), |(a, b), _| (b, a + b)).0
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0070() {
        let ans = Solution::climb_stairs(3);
        assert_eq!(ans, 3);
    }
}
