use crate::Solution;

impl Solution {
    /// [78.子集](https://leetcode-cn.com/problems/subsets/)
    ///
    /// 2022-02-18 15:34:16
    ///
    /// 给你一个整数数组 `nums` ，数组中的元素 **互不相同** 。返回该数组所有可能的子集（幂集）。
    ///
    /// 解集 **不能** 包含重复的子集。你可以按 **任意顺序** 返回解集。
    ///
    /// + **示例 1：**
    ///     + **输入：** nums = \[1,2,3\]
    ///     + **输出：** \[\[\],\[1\],\[2\],\[1,2\],\[3\],\[1,3\],\[2,3\],\[1,2,3\]\]
    /// + **示例 2：**
    ///     + **输入：** nums = \[0\]
    ///     + **输出：** \[\[\],\[0\]\]
    /// + **提示：**
    ///     * `1 <= nums.length <= 10`
    ///     * `-10 <= nums[i] <= 10`
    ///     * `nums` 中的所有元素 **互不相同**
    /// + Related Topics
    ///     * 位运算
    ///     * 数组
    ///     * 回溯
    /// * 👍 1482
    /// * 👎 0
    pub fn subsets(nums: Vec<i32>) -> Vec<Vec<i32>> {
        let mut ret = vec![vec![]];

        for num in nums {
            let mut temp = ret.clone();
            temp.iter_mut().for_each(|x| x.push(num));
            ret.append(&mut temp);
        }

        ret
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0078() {
        assert_eq!(Solution::subsets(vec![1, 2, 3]), vec![vec![], vec![1], vec![2], vec![1, 2], vec![3], vec![1, 3], vec![2, 3], vec![1, 2, 3]]);
    }
}
