use crate::Solution;

impl Solution {
    /// 80.删除有序数组中的重复项 II
    ///
    /// [原题链接](https://leetcode-cn.com/problems/remove-duplicates-from-sorted-array-ii/)
    ///
    /// 2021-04-06 07:19:27
    ///
    /// 给你一个有序数组`nums`，请你 原地 删除重复出现的元素，使每个元素 最多出现两次 ，返回删除后数组的新长度。
    ///
    /// 不要使用额外的数组空间，你必须在 原地 修改输入数组 并在使用 `O(1)` 额外空间的条件下完成。
    ///
    /// 说明：
    ///
    /// 为什么返回数值是整数，但输出的答案是数组呢？
    ///
    /// 请注意，输入数组是以「引用」方式传递的，这意味着在函数里修改输入数组对于调用者是可见的。
    ///
    /// 你可以想象内部操作如下:
    ///
    /// `nums`是以“引用”方式传递的。也就是说，不对实参做任何拷贝
    ///
    /// `int len = removeDuplicates(nums);`
    ///
    /// 在函数里修改输入数组对于调用者是可见的。
    ///
    /// 根据你的函数返回的长度, 它会打印出数组中 该长度范围内 的所有元素。
    /// ```c++
    /// for (int i = 0; i < len; i++) {
    ///     print(nums[i]);
    /// }
    /// ```
    ///
    /// + 示例 1：
    ///     - 输入：`nums = [1,1,1,2,2,3]`
    ///     - 输出：`5, nums = [1,1,2,2,3]`
    ///     - 解释：函数应返回新长度 `length = 5`, 并且原数组的前五个元素被修改为 `1, 1, 2, 2, 3` 。 不需要考虑数组中超出新长度后面的元素。
    /// + 示例 2：
    ///     - 输入：`nums = [0,0,1,1,1,1,2,3,3]`
    ///     - 输出：`7, nums = [0,0,1,1,2,3,3]`
    ///     - 解释：函数应返回新长度 `length = 7`, 并且原数组的前五个元素被修改为`0, 0, 1, 1, 2, 3, 3` 。 不需要考虑数组中超出新长度后面的元素。
    /// + 提示：
    ///     - `0 <= nums.length <= 3 * 104`
    ///     - `-104 <= nums[i] <= 104`
    ///     - nums 已按升序排列
    ///
    /// Related Topics 数组 双指针
    ///
    /// 👍 391 👎 0
    pub fn remove_duplicates1(nums: &mut Vec<i32>) -> i32 {
        let n = nums.len();
        if n <= 2 {
            return n as i32;
        }
        let (mut slow, mut fast) = (2, 2);
        while fast < n {
            if nums[slow - 2] != nums[fast] {
                nums[slow] = nums[fast];
                slow += 1;
            }
            fast += 1;
        }
        slow as i32
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0080() {
        let mut nums = vec![1,1,1,2,2,3];
        let a = Solution::remove_duplicates1(&mut nums);
        assert_eq!(a, 5);
    }
}
