use crate::Solution;
use crate::structure::ListNode;

impl Solution {
    /// [86.分隔链表](https://leetcode-cn.com/problems/partition-list/)
    ///
    /// 2022-02-18 15:41:39
    ///
    /// 给你一个链表的头节点 `head` 和一个特定值  `x` ，请你对链表进行分隔，使得所有 **小于** `x` 的节点都出现在 **大于或等于** `x` 的节点之前。
    ///
    /// 你应当 **保留** 两个分区中每个节点的初始相对位置。
    ///
    /// + **示例 1：**
    ///     + ![](https://assets.leetcode.com/uploads/2021/01/04/partition.jpg)
    ///     + **输入：** head = \[1,4,3,2,5,2\], x = 3
    ///     + **输出：** ：\[1,2,2,4,3,5\]
    /// + **示例 2：**
    ///     + **输入：** head = \[2,1\], x = 2
    ///     + **输出：** ：\[1,2\]
    /// **提示：**
    ///     * 链表中节点的数目在范围 `[0, 200]` 内
    ///     * `-100 <= Node.val <= 100`
    ///     * `-200 <= x <= 200`
    /// + Related Topics
    ///     * 链表
    ///     * 双指针
    /// * 👍 526
    /// * 👎 0
    pub fn partition(mut head: Option<Box<ListNode>>, x: i32) -> Option<Box<ListNode>> {
        let mut less_than_x_head = None;
        let mut less_than_x = &mut less_than_x_head;
        let mut greater_than_x_head = None;
        let mut greater_than_x = &mut greater_than_x_head;
        while let Some(mut box_node) = head {
            head = box_node.next.take();
            if box_node.val < x {
                *less_than_x = Some(box_node);
                less_than_x = &mut less_than_x.as_mut()?.next;
            } else {
                *greater_than_x = Some(box_node);
                greater_than_x = &mut greater_than_x.as_mut()?.next;
            }
        }
        *less_than_x = greater_than_x_head;
        less_than_x_head
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;
    use crate::structure::ListNode;

    #[test]
    fn test_q0086() {
        let head = Some(Box::new(ListNode {
            val:2,
            next:Some(Box::new(ListNode::new(1)))
        }));
        let ans = Some(Box::new(ListNode {
            val:1,
            next:Some(Box::new(ListNode::new(2)))
        }));
        assert_eq!(Solution::partition(head, 2), ans);
    }
}
