use crate::Solution;
impl Solution {
    /// 90.子集 II
    ///
    /// [原题链接](https://leetcode-cn.com/problems/subsets-ii/)
    ///
    /// 2021-03-31 08:50:11
    ///
    /// 给你一个整数数组 nums ，其中可能包含重复元素，请你返回该数组所有可能的子集（幂集）。
    ///
    /// 解集 不能 包含重复的子集。返回的解集中，子集可以按 任意顺序 排列。
    ///
    /// 示例 1：
    ///
    /// 输入：`nums = [1,2,2]`
    ///
    /// 输出：`[[],[1],[1,2],[1,2,2],[2],[2,2]]`
    ///
    /// 示例 2：
    ///
    /// 输入：`nums = [0]`
    ///
    /// 输出：`[[],[0]]`
    ///
    /// 提示：
    ///
    /// - `1 <= nums.length <= 10`
    /// - `-10 <= nums[i] <= 10`
    ///
    /// Related Topics 数组 回溯算法
    ///
    /// 👍 436 👎 0
    pub fn subsets_with_dup(mut nums: Vec<i32>) -> Vec<Vec<i32>> {
        nums.sort();
        let n = nums.len();
        let mut ans = vec![];
        for mask in 0..(1 << n) {
            let mut t = vec![];
            let mut flag = true;
            for i in 0..n {
                if (mask & (1 << i)) != 0 {
                    if i > 0 && (mask >> (i - 1) & 1) == 0 && nums[i] == nums[i - 1] {
                        flag = false;
                        break;
                    }
                    t.push(nums[i]);
                }
            }
            if flag {
                ans.push(t);
            }
        }
        return ans;
    }
}


#[cfg(test)]
mod test {
    #[test]
    fn test_0090() {
        unimplemented!()
    }
}