use crate::Solution;
use crate::structure::TreeNode;
use std::rc::Rc;
use std::cell::RefCell;


impl Solution {
    /// [94.二叉树的中序遍历](https://leetcode-cn.com/problems/binary-tree-inorder-traversal/)
    ///
    /// 2021-08-05 13:35:54
    ///
    /// 给定一个二叉树的根节点 `root` ，返回它的 **中序** 遍历。
    ///
    /// + 示例 1：
    ///     - 输入：`root = [1,null,2,3]`
    ///     - 输出：`[1,3,2]`
    /// + 示例 2：
    ///     - 输入：`root = []`
    ///     - 输出：`[]`
    /// + 示例 3：
    ///     - 输入：`root = [1]`
    ///     - 输出：`[1]`
    /// + 示例 4：
    ///     - 输入：`root = [1,2]`
    ///     - 输出：`[2,1]`
    /// + 示例 5：
    ///     - 输入：`root = [1,null,2]`
    ///     - 输出：`[1,2]`
    /// + 提示：
    ///     - 树中节点数目在范围 `[0, 100]` 内
    ///     - `-100 <= Node.val <= 100`
    /// + 进阶:
    ///     - 递归算法很简单，你可以通过迭代算法完成吗？
    ///
    /// Related Topics 栈 树 深度优先搜索 二叉树
    ///
    /// 👍 1051 👎 0
    pub fn inorder_traversal(root: Option<Rc<RefCell<TreeNode>>>) -> Vec<i32> {
        fn inorder(ret:&mut Vec<i32>, root: & Option<Rc<RefCell<TreeNode>>>) {
            if let Some(r) = root {
                inorder(ret, &r.borrow().left);
                ret.push(r.borrow().val);
                inorder(ret, &r.borrow().right);
            }
        }
        let mut ret = Vec::<i32>::new();
        inorder(&mut ret, &root);
        ret
        /*let mut ret = vec![];
        let mut stack = vec![];
        while root.is_some() || !stack.is_empty() {
            while let Some(r) = root {
                stack.push(r.clone());
                root = r.borrow().left.clone();
            }
            root = stack.pop();
            if let Some(n) = root {
                ret.push(n.borrow().val);
                root = n.borrow().right.clone();
            }
        }
        ret*/
    }
}



#[cfg(test)]
mod test {
    use crate::Solution;
    use crate::structure::TreeNode;
    use std::rc::Rc;
    use std::cell::RefCell;

    #[test]
    fn test_q0094() {
        let tree = Option::Some(Rc::new(RefCell::new(TreeNode {
            val: 1,
            left: None,
            right: Option::Some(Rc::new(RefCell::new(TreeNode {
                val: 2,
                left: Option::Some(Rc::new(RefCell::new(TreeNode {
                    val: 3,
                    left: None,
                    right: None,
                }))),
                right: None,
            }))),
        })));
        let vec = Solution::inorder_traversal(tree);

        assert_eq!(vec, vec![1, 3, 2]);
    }
}
