use crate::Solution;
use crate::structure::TreeNode;
use std::rc::Rc;
use std::cell::RefCell;

impl Solution {
    /// [100.相同的树](https://leetcode-cn.com/problems/same-tree/)
    ///
    /// 2022-02-09 16:05:06
    ///
    /// 给你两棵二叉树的根节点 `p` 和 `q` ，编写一个函数来检验这两棵树是否相同。
    ///
    /// 如果两个树在结构上相同，并且节点具有相同的值，则认为它们是相同的。
    ///
    /// + **示例 1：**
    ///     + ![](https://assets.leetcode.com/uploads/2020/12/20/ex1.jpg)
    ///     + **输入：**p = \[1,2,3\], q = \[1,2,3\]
    ///     + **输出：**true
    /// + **示例 2：**
    ///     + ![](https://assets.leetcode.com/uploads/2020/12/20/ex2.jpg)
    ///     + **输入：**p = \[1,2\], q = \[1,null,2\]
    ///     + **输出：**false
    /// + **示例 3：**
    ///     + ![](https://assets.leetcode.com/uploads/2020/12/20/ex3.jpg)
    ///     + **输入：**p = \[1,2,1\], q = \[1,1,2\]
    ///     + **输出：**false
    /// + **提示：**
    ///     * 两棵树上的节点数目都在范围 `[0, 100]` 内
    ///     * `-104 <= Node.val <= 104`
    /// + Related Topics
    ///     * 树
    ///     * 深度优先搜索
    ///     * 广度优先搜索
    ///     * 二叉树
    ///
    /// * 👍 761
    /// * 👎 0
    pub fn is_same_tree(p: Option<Rc<RefCell<TreeNode>>>, q: Option<Rc<RefCell<TreeNode>>>) -> bool {
        match (p, q) {
            (Some(l), Some(r)) => match (l.borrow_mut(), r.borrow_mut()) {
                (mut a, mut b) => a.val == b.val && Self::is_same_tree(a.left.take(), b.left.take()) && Self::is_same_tree(a.right.take(), b.right.take())
            }
            (Some(_), None) => false,
            (None, Some(_)) => false,
            _ => true,
        }
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;
    use crate::structure::TreeNode;
    use std::rc::Rc;
    use std::cell::RefCell;

    #[test]
    fn test_q0100() {
        let p = Some(Rc::new(RefCell::new(TreeNode {
            val: 1,
            left: None,
            right: Some(Rc::new(RefCell::new(TreeNode {
                val: 3,
                left: Some(Rc::new(RefCell::new(TreeNode::new(3)))),
                right: None,
            }))),
        })));
        let q = Some(Rc::new(RefCell::new(TreeNode {
            val: 1,
            left: None,
            right: Some(Rc::new(RefCell::new(TreeNode {
                val: 3,
                left: Some(Rc::new(RefCell::new(TreeNode::new(4)))),
                right: None,
            }))),
        })));;
        assert_eq!(Solution::is_same_tree(p, q), false);
    }
}
