use crate::Solution;
use crate::structure::TreeNode;
use std::rc::Rc;
use std::cell::RefCell;


impl Solution {
    /// [101.对称二叉树](https://leetcode-cn.com/problems/symmetric-tree/)
    ///
    /// 2021-11-15 17:17:06
    ///
    /// 给定一个二叉树，检查它是否是镜像对称的。
    ///
    /// 例如，二叉树 `[1,2,2,3,4,4,3]` 是对称的。
    ///
    /// ```txt
    ///     1
    ///    / \
    ///   2   2
    ///  / \ / \
    /// 3  4 4  3
    /// ```
    ///
    /// 但是下面这个 `[1,2,2,null,3,null,3]` 则不是镜像对称的:
    ///
    /// ```txt
    ///     1
    ///    / \
    ///   2   2
    ///    \   \
    ///    3    3
    /// ```
    ///
    /// **进阶：** 你可以运用递归和迭代两种方法解决这个问题吗？
    ///
    /// * Related Topics
    ///     + 树
    ///     + 深度优先搜索
    ///     + 广度优先搜索
    ///     + 二叉树
    ///
    /// * 👍 1603
    /// * 👎 0
    pub fn is_symmetric(root: Option<Rc<RefCell<TreeNode>>>) -> bool {
        fn check(t1: &Option<Rc<RefCell<TreeNode>>>, t2: &Option<Rc<RefCell<TreeNode>>>) -> bool {
            match (t1, t2) {
                (None, None) => true,
                (Some(n1), Some(n2)) => n1.borrow().val == n2.borrow().val && check(&n1.borrow().left, &n2.borrow().right) && check(&n1.borrow().right, &n2.borrow().left),
                _ => false
            }
        }
        root.is_none() || check(&root.as_ref().unwrap().borrow().left, &root.as_ref().unwrap().borrow().right)
        /*if let Some(n) = root {
            let mut stack = vec![n.borrow_mut().left.take()];
            stack.push(n.borrow_mut().right.take());
            while let (Some(t1), Some(t2)) = (stack.pop(), stack.pop()) {
                match (t1, t2) {
                    (None, None) => (),
                    (Some(n1), Some(n2)) => {
                        if n1.borrow().val == n2.borrow().val {
                            stack.push(n1.borrow_mut().left.take());
                            stack.push(n2.borrow_mut().right.take());
                            stack.push(n1.borrow_mut().right.take());
                            stack.push(n2.borrow_mut().left.take());
                        } else {
                            return false;
                        }
                    }
                    _ => return false
                }
            }
        }
        true*/
        /*if let Some(n) = root {
            let mut l = n.borrow_mut().left.take();
            let mut r = n.borrow_mut().right.take();
            match (l, r) {
                (None, None) => (),
                (Some(n1), Some(n2)) => {
                    return if n1.borrow().val == n2.borrow().val {
                        let b = Solution::is_symmetric(Some(Rc::new(RefCell::new(TreeNode { val: 0, left: n1.borrow_mut().left.take(), right: n2.borrow_mut().right.take() }))));
                        Solution::is_symmetric(Some(Rc::new(RefCell::new(TreeNode { val: 0, left: n1.borrow_mut().right.take(), right: n2.borrow_mut().left.take() })))) && b
                    } else {
                        false
                    }
                }
                _ => return false
            }
        }
        true*/
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;
    use crate::structure::TreeNode;
    use std::rc::Rc;
    use std::cell::RefCell;

    #[test]
    fn test_q0101() {
        let tree = Some(Rc::new(RefCell::new(TreeNode {
            val: 1,
            left: Some(Rc::new(RefCell::new(TreeNode {
                val: 2,
                left: Some(Rc::new(RefCell::new(TreeNode {
                    val: 3,
                    left: None,
                    right: None,
                }))),
                right: Some(Rc::new(RefCell::new(TreeNode {
                    val: 4,
                    left: None,
                    right: None,
                }))),
            }))),
            right: Some(Rc::new(RefCell::new(TreeNode {
                val: 2,
                left: Some(Rc::new(RefCell::new(TreeNode {
                    val: 4,
                    left: None,
                    right: None,
                }))),
                right: Some(Rc::new(RefCell::new(TreeNode {
                    val: 3,
                    left: None,
                    right: None,
                }))),
            }))),
        })));
        assert_eq!(Solution::is_symmetric(tree), true);
    }
}
