use crate::Solution;
use crate::structure::TreeNode;
use std::rc::Rc;
use std::cell::RefCell;


impl Solution {
    /// [102.二叉树的层序遍历](https://leetcode-cn.com/problems/binary-tree-level-order-traversal/)
    ///
    /// 2021-11-15 14:35:20
    ///
    /// 给你一个二叉树，请你返回其按 **层序遍历** 得到的节点值。 （即逐层地，从左到右访问所有节点）。
    ///
    /// * **示例：**
    ///     + 二叉树：`[3,9,20,null,null,15,7]`,
    ///     ```txt
    ///         3
    ///        / \
    ///       9  20
    ///         /  \
    ///        15   7
    ///     ```
    ///     + 返回其层序遍历结果：
    ///     ```txt
    ///     [
    ///       [3],
    ///       [9,20],
    ///       [15,7]
    ///     ]
    ///     ```
    /// * Related Topics
    ///     + 树
    ///     + 广度优先搜索
    ///     + 二叉树
    ///
    /// * 👍 1080
    /// * 👎 0
    pub fn level_order(root: Option<Rc<RefCell<TreeNode>>>) -> Vec<Vec<i32>> {
        let mut ret = vec![];
        if root.is_none() {
            return ret;
        }
        let mut q = vec![root.unwrap()];
        while !q.is_empty() {
            let mut level = vec![];
            for _ in 0..q.len() {
                let node = q.remove(0);
                level.push(node.borrow().val);
                if node.borrow().left.is_some() {
                    q.push(node.borrow_mut().left.take().unwrap());
                }
                if node.borrow().right.is_some() {
                    q.push(node.borrow_mut().right.take().unwrap());
                }
            }
            ret.push(level);
        }
        ret
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;
    use crate::structure::TreeNode;
    use std::rc::Rc;
    use std::cell::RefCell;

    #[test]
    fn test_q0102() {
        let tree = Some(Rc::new(RefCell::new(TreeNode {
            val: 3,
            left: Some(Rc::new(RefCell::new(TreeNode {
                val: 9,
                left: None,
                right: None,
            }))),
            right: Some(Rc::new(RefCell::new(TreeNode {
                val: 20,
                left: Some(Rc::new(RefCell::new(TreeNode {
                    val: 15,
                    left: None,
                    right: None,
                }))),
                right: Some(Rc::new(RefCell::new(TreeNode {
                    val: 7,
                    left: None,
                    right: None,
                }))),
            }))),
        })));
        assert_eq!(Solution::level_order(tree), vec![vec![3], vec![9, 20], vec![15, 7]]);
    }
}
