use crate::Solution;
use crate::structure::TreeNode;
use std::rc::Rc;
use std::cell::RefCell;

impl Solution {
    /// [104.二叉树的最大深度](https://leetcode-cn.com/problems/maximum-depth-of-binary-tree/)
    ///
    /// 2022-02-18 16:15:29
    ///
    /// 给定一个二叉树，找出其最大深度。
    ///
    /// 二叉树的深度为根节点到最远叶子节点的最长路径上的节点数。
    ///
    /// + **说明:** 叶子节点是指没有子节点的节点。
    /// + **示例：**
    ///
    ///     给定二叉树 `[3,9,20,null,null,15,7]`，
    ///     ``` txt
    ///         3
    ///        / \
    ///       9  20
    ///         /  \
    ///        15   7
    ///     ```
    ///     返回它的最大深度 3 。
    /// + Related Topics
    ///     * 树
    ///     * 深度优先搜索
    ///     * 广度优先搜索
    ///     * 二叉树
    /// * 👍 1113
    /// * 👎 0
    pub fn max_depth(root: Option<Rc<RefCell<TreeNode>>>) -> i32 {
        match root {
            Some(node) => match node.borrow_mut() {
                mut p => 1 + Self::max_depth(p.left.take()).max(Self::max_depth(p.right.take()))
            }
            _ => 0
        }
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;
    use crate::structure::TreeNode;
    use std::rc::Rc;
    use std::cell::RefCell;

    #[test]
    fn test_q0104() {
        let root = Some(Rc::new(RefCell::new(TreeNode {
            val: 3,
            left: Some(Rc::new(RefCell::new(TreeNode::new(9)))),
            right: Some(Rc::new(RefCell::new(TreeNode {
                val: 20,
                left: Some(Rc::new(RefCell::new(TreeNode::new(15)))),
                right: Some(Rc::new(RefCell::new(TreeNode::new(7)))),
            }))),
        })));
        assert_eq!(Solution::max_depth(root), 3);
    }
}
