use crate::Solution;
use crate::structure::TreeNode;
use std::rc::Rc;
use std::cell::RefCell;

impl Solution {
    /// [110.平衡二叉树](https://leetcode-cn.com/problems/balanced-binary-tree/)
    ///
    /// 2022-02-09 16:37:47
    ///
    /// 给定一个二叉树，判断它是否是高度平衡的二叉树。
    ///
    /// 本题中，一棵高度平衡二叉树定义为：
    ///
    /// > 一个二叉树_每个节点_ 的左右两个子树的高度差的绝对值不超过 1 。
    ///
    /// + **示例 1：**
    ///     + ![](https://assets.leetcode.com/uploads/2020/10/06/balance_1.jpg)
    ///     + **输入：** root = \[3,9,20,null,null,15,7\]
    ///     + **输出：** true
    /// + **示例 2：**
    ///     + ![](https://assets.leetcode.com/uploads/2020/10/06/balance_2.jpg)
    ///     + **输入：** root = \[1,2,2,3,3,null,null,4,4\]
    ///     + **输出：** false
    /// + **示例 3：**
    ///     + **输入：** root = \[\]
    ///     + **输出：** true
    /// + **提示：**
    ///     * 树中的节点数在范围 `[0, 5000]` 内
    ///     * `-104 <= Node.val <= 104`
    /// + Related Topics
    ///     * 树
    ///     * 深度优先搜索
    ///     * 二叉树
    /// * 👍 881
    /// * 👎 0
    pub fn is_balanced(root: Option<Rc<RefCell<TreeNode>>>) -> bool {
        pub fn balanced(root: &Option<Rc<RefCell<TreeNode>>>) -> i32 {
            match root {
                Some(node) => {
                    let left_h = balanced(&node.borrow().left);
                    if left_h == -1 {
                        return -1;
                    }
                    let right_h = balanced(&node.borrow().right);
                    if right_h == -1 || (left_h - right_h).abs() > 1 {
                        return -1;
                    }
                    left_h.max(right_h) + 1
                }
                _ => 0
            }
        }
        balanced(&root) != -1
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;
    use crate::structure::TreeNode;
    use std::rc::Rc;
    use std::cell::RefCell;

    #[test]
    fn test_q0110() {
        let tree = Some(Rc::new(RefCell::new(TreeNode {
            val: 3,
            left: Some(Rc::new(RefCell::new(TreeNode::new(9)))),
            right: Some(Rc::new(RefCell::new(TreeNode {
                val: 20,
                left: Some(Rc::new(RefCell::new(TreeNode::new(15)))),
                right: Some(Rc::new(RefCell::new(TreeNode::new(7)))),
            }))),
        })));
        assert_eq!(Solution::is_balanced(tree), true);
    }
}
