use crate::Solution;
use crate::structure::TreeNode;
use std::rc::Rc;
use std::cell::RefCell;

impl Solution {
    /// [111.二叉树的最小深度](https://leetcode-cn.com/problems/minimum-depth-of-binary-tree/)
    ///
    /// 2022-02-09 17:11:54
    /// 给定一个二叉树，找出其最小深度。
    ///
    /// 最小深度是从根节点到最近叶子节点的最短路径上的节点数量。
    ///
    /// + **说明：** 叶子节点是指没有子节点的节点。
    /// + **示例 1：**
    ///     + ![](https://assets.leetcode.com/uploads/2020/10/12/ex_depth.jpg)
    ///     + **输入：** root = \[3,9,20,null,null,15,7\]
    ///     + **输出：** 2
    /// + **示例 2：**
    ///     + **输入：** root = \[2,null,3,null,4,null,5,null,6\]
    ///     + **输出：** 5
    /// + **提示：**
    ///     * 树中节点数的范围在 `[0, 105]` 内
    ///     * `-1000 <= Node.val <= 1000`
    /// + Related Topics
    ///     * 树
    ///     * 深度优先搜索
    ///     * 广度优先搜索
    ///     * 二叉树
    /// * 👍 666
    /// * 👎 0
    pub fn min_depth(root: Option<Rc<RefCell<TreeNode>>>) -> i32 {
        match root {
            Some(node) => match node.borrow_mut() {
                mut p => if p.left.is_none() {
                    Self::min_depth(p.right.take()) + 1
                } else if p.right.is_none() {
                    Self::min_depth(p.left.take()) + 1
                } else {
                    Self::min_depth(p.left.take()).min(Self::min_depth(p.right.take())) + 1
                }
            }
            _ => 0
        }
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;
    use crate::structure::TreeNode;
    use std::rc::Rc;
    use std::cell::RefCell;

    #[test]
    fn test_q0111() {
        let tree = Some(Rc::new(RefCell::new(TreeNode {
            val: 4,
            left: Some(Rc::new(RefCell::new(TreeNode::new(9)))),
            right: Some(Rc::new(RefCell::new(TreeNode {
                val: 10,
                left: Some(Rc::new(RefCell::new(TreeNode::new(15)))),
                right: Some(Rc::new(RefCell::new(TreeNode::new(7)))),
            }))),
        })));
        assert_eq!(Solution::min_depth(tree), 2);
    }
}
