use crate::Solution;


impl Solution {
    /// 118.杨辉三角
    ///
    /// [原题链接](https://leetcode-cn.com/problems/pascals-triangle/)
    ///
    /// 2021-07-15 22:23:34
    ///
    /// 给定一个非负整数 numRows，生成杨辉三角的前 numRows 行。
    ///
    /// 在杨辉三角中，每个数是它左上方和右上方的数的和。
    ///
    /// + 示例:
    ///     - 输入: 5
    ///     - 输出:
    /// ```json
    ///[
    ///     [1],
    ///    [1,1],
    ///   [1,2,1],
    ///  [1,3,3,1],
    /// [1,4,6,4,1]
    ///]
    /// ```
    /// Related Topics 数组 动态规划
    ///
    /// 👍 530 👎 0
    pub fn generate(num_rows: i32) -> Vec<Vec<i32>> {
        let n = num_rows as usize;
        let mut ret = Vec::<Vec<i32>>::with_capacity(n);
        for i in 0..num_rows as usize {
            let mut row = vec![1; i + 1];
            for j in 1..row.len() - 1 {
                row[j] = ret[i - 1][j - 1] + ret[i - 1][j];
            }
            ret.push(row);
        }
        ret
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0118() {
        let tri = vec![
            vec![1],
            vec![1, 1],
            vec![1, 2, 1],
            vec![1, 3, 3, 1],
            vec![1, 4, 6, 4, 1]
        ];
        let ans = Solution::generate(5);
        assert_eq!(ans, tri);
    }
}
