use crate::Solution;

impl Solution {
    /// 119.杨辉三角 II
    ///
    /// [原题链接](https://leetcode-cn.com/problems/pascals-triangle-ii/)
    ///
    /// 2021-07-15 22:39:00
    ///
    /// 给定一个非负索引 `k`，其中 `k ≤ 33`，返回杨辉三角的第 `k` 行。
    ///
    /// 在杨辉三角中，每个数是它左上方和右上方的数的和。
    ///
    /// + 示例:
    ///     - 输入: `3`
    ///     - 输出: `[1,3,3,1]`
    ///
    /// 进阶：你可以优化你的算法到 `O(k)` 空间复杂度吗？
    ///
    /// Related Topics 数组 动态规划
    ///
    /// 👍 304 👎 0
    pub fn get_row(row_index: i32) -> Vec<i32> {
        let n = row_index as usize + 1;
        let mut ret = vec![1i32; n];
        for i in 1..n {
            ret[i] = (ret[i - 1] as usize * (n - i) / i) as i32;
        }
        ret
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0119() {
        let ans = Solution::get_row(3);
        assert_eq!(ans, vec![1, 3, 3, 1]);
    }
}
