use crate::Solution;

impl Solution {
    /// 121.买卖股票的最佳时机
    ///
    /// [原题链接](https://leetcode-cn.com/problems/best-time-to-buy-and-sell-stock/)
    ///
    /// 2021-07-15 22:06:01
    ///
    /// 给定一个数组 prices ，它的第 i 个元素 `prices[i]` 表示一支给定股票第 i 天的价格。
    ///
    /// 你只能选择 某一天 买入这只股票，并选择在 未来的某一个不同的日子 卖出该股票。设计一个算法来计算你所能获取的最大利润。
    ///
    /// 返回你可以从这笔交易中获取的最大利润。如果你不能获取任何利润，返回 0 。
    ///
    /// + 示例 1：
    ///     - 输入：`[7,1,5,3,6,4]`
    ///     - 输出：`5`
    ///     - 解释：在第 `2` 天（股票价格 = `1`）的时候买入，在第 `5` 天（股票价格 = `6`）的时候卖出，最大利润 = `6-1 = 5` 。
    ///     注意利润不能是 `7-1 = 6`, 因为卖出价格需要大于买入价格；同时，你不能在买入前卖出股票。
    /// + 示例 2：
    ///     - 输入：`prices = [7,6,4,3,1]`
    ///     - 输出：`0`
    ///     - 解释：在这种情况下, 没有交易完成, 所以最大利润为 `0`。
    /// + 提示：
    ///     - `1 <= prices.length <= 105`
    ///     - `0 <= prices[i] <= 104`
    ///
    /// Related Topics 数组 动态规划
    ///
    /// 👍 1714 👎 0
    pub fn max_profit(prices: Vec<i32>) -> i32 {
        let mut min_price = i32::MAX;
        let mut max_profit = 0;
        for p in prices {
            max_profit = max_profit.max(p - min_price);
            min_price = p.min(min_price);
        }
        max_profit
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0121() {
        let prices = vec![7, 1, 5, 3, 6, 4];
        let ans = Solution::max_profit(prices);
        assert_eq!(ans, 5);
    }
}
