use crate::Solution;

impl Solution {
    /// [125.验证回文串](https://leetcode-cn.com/problems/valid-palindrome/)
    ///
    /// 2022-02-18 16:24:51
    ///
    /// 给定一个字符串，验证它是否是回文串，只考虑字母和数字字符，可以忽略字母的大小写。
    ///
    /// + **说明：** 本题中，我们将空字符串定义为有效的回文串。
    /// + **示例 1:**
    ///     + **输入：** "A man, a plan, a canal: Panama"
    ///     + **输出：** true
    ///     + **解释：** "amanaplanacanalpanama" 是回文串
    /// + **示例 2:**
    ///     + **输入：** "race a car"
    ///     + **输出：** false
    ///     + **解释：** "raceacar" 不是回文串
    /// + **提示：**
    ///     * `1 <= s.length <= 2 * 105`
    ///     * 字符串 `s` 由 ASCII 字符组成
    /// + Related Topics
    ///     * 双指针
    ///     * 字符串
    /// * 👍 472
    /// * 👎 0
    /// 1. 双指针
    ///
    ///     头尾双指针遍历
    ///     ```rust
    ///     pub fn is_palindrome1(s: String) -> bool {
    ///         if s.len() <= 1 {
    ///             return true;
    ///         }
    ///         let s = s.into_bytes();
    ///         let (mut i, mut j) = (0usize, s.len() - 1);
    ///         while i < j {
    ///             while i < j && !s[i].is_ascii_alphanumeric() {
    ///                 i += 1;
    ///             }
    ///             while i < j && !s[j].is_ascii_alphanumeric() {
    ///                 j -= 1;
    ///             }
    ///             if i < j {
    ///                 if s[i].to_ascii_lowercase() != s[j].to_ascii_lowercase() {
    ///                     return false;
    ///                 }
    ///                 i += 1;
    ///                 j -= 1;
    ///             }
    ///         }
    ///         true
    ///     }
    ///     ```
    /// 2. 筛选
    ///
    ///     实现见源码
    pub fn is_palindrome1(s: String) -> bool {
        let a = s.to_ascii_lowercase().into_bytes().into_iter().filter(|c| c.is_ascii_alphanumeric()).collect::<Vec<u8>>();
        let mut b = a.clone();
        b.reverse();
        a == b
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0125() {
        assert_eq!(Solution::is_palindrome1("A man, a plan, a canal: Panama".to_string()), true);
    }
}
