use crate::Solution;

impl Solution {
    /// 137.只出现一次的数字 II
    ///
    /// [原题链接](https://leetcode-cn.com/problems/single-number-ii/)
    ///
    /// 2021-04-30 09:06:01
    ///
    /// 给你一个整数数组 `nums` ，除某个元素仅出现 一次 外，其余每个元素都恰出现 三次 。请你找出并返回那个只出现了一次的元素。
    ///
    /// + 示例 1：
    ///     - 输入：`nums = [2,2,3,2]`
    ///     - 输出：`3`
    /// + 示例 2：
    ///     - 输入：`nums = [0,1,0,1,0,1,99]`
    ///     - 输出：`99`
    /// + 提示：
    ///     - `1 <= nums.length <= 3 * 104`
    ///     - `-231 <= nums[i] <= 231 - 1`
    ///     - `nums` 中，除某个元素仅出现 一次 外，其余每个元素都恰出现 三次
    ///
    /// 进阶：你的算法应该具有线性时间复杂度。 你可以不使用额外空间来实现吗？
    ///
    /// Related Topics 位运算
    ///
    /// 👍 580 👎 0
    ///
    /// 初始化(0, 0), 循环遍历异或掩码运算
    pub fn single_number2(nums: Vec<i32>) -> i32 {
        nums.iter().fold((0, 0), |mut acc, &s| {
            acc.0 = !acc.1 & (acc.0 ^ s);
            acc.1 = !acc.0 & (acc.1 ^ s);
            acc
        }).0
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0137() {
        let nums = vec![0, 1, 0, 1, 0, 1, 99];
        let ans = Solution::single_number2(nums);
        assert_eq!(ans, 99);
    }
}
