use crate::Solution;
use crate::structure::TreeNode;
use std::rc::Rc;
use std::cell::RefCell;


impl Solution {
    /// [144.二叉树的前序遍历](https://leetcode-cn.com/problems/binary-tree-preorder-traversal/)
    ///
    /// 2021-11-15 15:34:19
    ///
    /// 给你二叉树的根节点 `root` ，返回它节点值的 **前序**  遍历。
    ///
    /// * **示例 1：**
    ///     + ![](https://assets.leetcode.com/uploads/2020/09/15/inorder_1.jpg)
    ///     + **输入：** root = \[1,null,2,3\]
    ///     + **输出：** \[1,2,3\]
    /// * **示例 2：**
    ///     + **输入：** root = \[\]
    ///     + **输出：** \[\]
    /// * **示例 3：**
    ///     + **输入：** root = \[1\]
    ///     + **输出：** \[1\]
    /// * **示例 4：**
    ///     + ![](https://assets.leetcode.com/uploads/2020/09/15/inorder_5.jpg)
    ///     + **输入：** root = \[1,2\]
    ///     + **输出：** \[1,2\]
    /// * **示例 5：**
    ///     + ![](https://assets.leetcode.com/uploads/2020/09/15/inorder_4.jpg)
    ///     + **输入：** root = \[1,null,2\]
    ///     + **输出：** \[1,2\]
    /// * **提示：**
    ///     * 树中节点数目在范围 `[0, 100]` 内
    ///     * `-100 <= Node.val <= 100`
    /// * **进阶：** 递归算法很简单，你可以通过迭代算法完成吗？
    /// * Related Topics
    ///     + 栈
    ///     + 树
    ///     + 深度优先搜索
    ///     + 二叉树
    /// * 👍 678
    /// * 👎 0
    ///
    /// # 方法1 递归
    /// # 方法2 栈
    /// # 方法3 Morris遍历
    pub fn preorder_traversal(root: Option<Rc<RefCell<TreeNode>>>) -> Vec<i32> {
        /*fn preorder(ret: &mut Vec<i32>, root: Option<Rc<RefCell<TreeNode>>>) {
            if let Some(r) = root {
                ret.push(r.borrow().val);
                preorder(ret, r.borrow_mut().left.take());
                preorder(ret, r.borrow_mut().right.take());
            }
        }
        let mut ret = vec![];
        preorder(&mut ret, root);
        ret*/
        let mut ret = vec![];
        if let Some(r) = root {
            ret.push(r.borrow().val);
            ret.extend(Solution::preorder_traversal(r.borrow_mut().left.take()));
            ret.extend(Solution::preorder_traversal(r.borrow_mut().right.take()));
        }
        ret
        /*let mut stack = vec![root];
        let mut ret = vec![];
        while let Some(n) = stack.pop() {
            if let Some(n) = n {
                ret.push(n.borrow().val);
                stack.push(n.borrow_mut().right.take());
                stack.push(n.borrow_mut().left.take());
            }
        }
        ret*/
        /*let mut res = vec![];
        if root.is_none() {
            return res;
        }

        let mut p1 = root;
        let mut p2;

        while p1.is_some() {
            p2 = p1.unwrap().borrow_mut().left.take();
            if p2.is_some() {
                while p2.unwrap().borrow().right.is_some() && p2.unwrap().borrow().right != p1 {
                    p2 = p2.unwrap().borrow_mut().right.take();
                }
                if p2.unwrap().borrow().right.is_none() {
                    res.push(p1.unwrap().borrow().val);
                    p2.unwrap().borrow().right = p1.take();
                    // todo
                } else {
                    p2.unwrap().borrow_mut().right = None;
                }
            } else {
                res.push(p1.unwrap().borrow().val);
            }
            p1 = p1.unwrap().borrow_mut().right.take();
        }
        unimplemented!()*/
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;
    use crate::structure::TreeNode;
    use std::rc::Rc;
    use std::cell::RefCell;

    #[test]
    fn test_q0144() {
        let tree = Some(Rc::new(RefCell::new(TreeNode {
            val: 1,
            left: None,
            right: Some(Rc::new(RefCell::new(TreeNode {
                val: 2,
                left: Some(Rc::new(RefCell::new(TreeNode {
                    val: 3,
                    left: None,
                    right: None,
                }))),
                right: None,
            }))),
        })));

        assert_eq!(Solution::preorder_traversal(tree), vec![1, 2, 3]);
    }
}
