use crate::Solution;


impl Solution {
    /// 152.乘积最大子数组
    ///
    /// [原题链接](https://leetcode-cn.com/problems/maximum-product-subarray/)
    ///
    /// 2021-07-18 07:54:35
    ///
    /// 给你一个整数数组 `nums` ，请你找出数组中乘积最大的连续子数组（该子数组中至少包含一个数字），并返回该子数组所对应的乘积。
    ///
    /// + 示例 1:
    ///     - 输入: `[2,3,-2,4]`
    ///     - 输出: `6`
    ///     - 解释: 子数组 `[2,3]` 有最大乘积 `6`。
    /// + 示例 2:
    ///     - 输入: `[-2,0,-1]`
    ///     - 输出: `0`
    ///     - 解释: 结果不能为 `2`, 因为 `[-2,-1]` 不是子数组。
    ///
    /// Related Topics 数组 动态规划
    ///
    /// 👍 1184 👎 0
    pub fn max_product(nums: Vec<i32>) -> i32 {
        let (mut max_f, mut min_f, mut ans) = (nums[0], nums[0], nums[0]);
        for i in 1..nums.len() {
            let (mx, mn) = (max_f, min_f);
            max_f = (mx * nums[i]).max(nums[i].max(mn * nums[i]));
            min_f = (mn * nums[i]).min(nums[i].min(mx * nums[i]));
            ans = ans.max(max_f);
        }
        ans
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0152() {
        let nums = vec![2, 3, -2, 4];
        let ans = Solution::max_product(nums);
        assert_eq!(ans, 6);
    }
}
