use crate::Solution;

impl Solution {
    /// [168.Excel表列名称](https://leetcode-cn.com/problems/excel-sheet-column-title/)
    ///
    /// 2022-02-18 16:31:25
    ///
    /// 给你一个整数 `columnNumber` ，返回它在 Excel 表中相对应的列名称。
    ///
    /// 例如：
    /// ``` txt
    /// A -> 1
    /// B -> 2
    /// C -> 3
    /// ...
    /// Z -> 26
    /// AA -> 27
    /// AB -> 28
    /// ...
    /// ```
    /// + **示例 1：**
    ///     + **输入：** columnNumber = 1
    ///     + **输出：** "A"
    /// + **示例 2：**
    ///     + **输入：** columnNumber = 28
    ///     + **输出：** "AB"
    /// + **示例 3：**
    ///     + **输入：** columnNumber = 701
    ///     + **输出：** "ZY"
    /// + **示例 4：**
    ///     + **输入：** columnNumber = 2147483647
    ///     + **输出：** "FXSHRXW"
    /// + **提示：**
    ///     * `1 <= columnNumber <= 231 - 1`
    /// + Related Topics
    ///     * 数学
    ///     * 字符串
    /// * 👍 496
    /// * 👎 0
    pub fn convert_to_title(mut column_number: i32) -> String {
        let mut s = String::with_capacity(8);
        while column_number != 0 {
            let c = (((column_number - 1) % 26) as u8 + b'A') as char;
            s.insert(0, c);
            column_number = (column_number - 1) / 26;
        }
        s
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0168() {
        assert_eq!(Solution::convert_to_title(2147483647), "FXSHRXW".to_string());
    }
}
