use crate::Solution;

impl Solution {
    /// [169.多数元素](https://leetcode-cn.com/problems/majority-element/)
    ///
    /// 2022-02-18 16:37:41
    ///
    /// 给定一个大小为 _n_ 的数组，找到其中的多数元素。多数元素是指在数组中出现次数 **大于** `⌊ n/2 ⌋` 的元素。
    ///
    /// 你可以假设数组是非空的，并且给定的数组总是存在多数元素。
    ///
    /// + **示例 1：**
    ///     + **输入：** \[3,2,3\]
    ///     + **输出：** 3
    /// + **示例 2：**
    ///     + **输入：** \[2,2,1,1,1,2,2\]
    ///     + **输出：** 2
    /// + **进阶：**
    ///     * 尝试设计时间复杂度为 O(n)、空间复杂度为 O(1) 的算法解决此问题。
    /// + Related Topics
    ///     * 数组
    ///     * 哈希表
    ///     * 分治
    ///     * 计数
    ///     * 排序
    /// * 👍 1305
    /// * 👎 0
    pub fn majority_element(nums: Vec<i32>) -> i32 {
        nums.iter().fold((0, -1), |mut acc, &num| {
            if acc.0 == 0 { acc.1 = num }
            acc.0 += if acc.1 == num { 1 } else { -1 };
            acc
        }).1
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0169() {
        assert_eq!(Solution::majority_element(vec![3, 2, 3]), 3);
    }
}
