use crate::Solution;

impl Solution {
    /// [171.Excel 表列序号](https://leetcode-cn.com/problems/excel-sheet-column-number/)
    ///
    /// 2022-02-18 16:42:37
    ///
    /// 给你一个字符串 `columnTitle` ，表示 Excel 表格中的列名称。返回 _该列名称对应的列序号_ 。
    ///
    /// 例如：
    ///
    /// ``` txt
    /// A -> 1
    /// B -> 2
    /// C -> 3
    /// ...
    /// Z -> 26
    /// AA -> 27
    /// AB -> 28
    /// ...
    /// ```
    ///
    /// + **示例 1:**
    ///     + **输入:** columnTitle = "A"
    ///     + **输出:** 1
    /// + **示例 2:**
    ///     + **输入:** columnTitle = "AB"
    ///     + **输出:** 28
    /// + **示例 3:**
    ///     + **输入:** columnTitle = "ZY"
    ///     + **输出:** 701
    /// + **提示：**
    ///     * `1 <= columnTitle.length <= 7`
    ///     * `columnTitle` 仅由大写英文组成
    ///     * `columnTitle` 在范围 `["A", "FXSHRXW"]` 内
    /// + Related Topics
    ///     * 数学
    ///     * 字符串
    /// *   👍 313
    /// *   👎 0
    pub fn title_to_number(column_title: String) -> i32 {
        column_title.chars().fold(0, |col, c| col * 26 + c as i32 - 64)
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0171() {
        assert_eq!(Solution::title_to_number("ZY".to_string()), 701);
    }
}
