use crate::Solution;
use std::fmt::Debug;


impl Solution {
    /// 179.最大数
    ///
    /// [原题链接](https://leetcode-cn.com/problems/largest-number/)
    ///
    /// 2021-04-12 08:30:29
    ///
    /// 给定一组非负整数 nums，重新排列每个数的顺序（每个数不可拆分）使之组成一个最大的整数。
    ///
    /// 注意：输出结果可能非常大，所以你需要返回一个字符串而不是整数。
    ///
    /// + 示例 1：
    ///     - 输入：`nums = [10,2]`
    ///     - 输出："210"
    /// + 示例 2：
    ///     - 输入：`nums = [3,30,34,5,9]`
    ///     - 输出："9534330"
    /// + 示例 3：
    ///     - 输入：`nums = [1]`
    ///     - 输出："1"
    /// + 示例 4：
    ///     - 输入：`nums = [10]`
    ///     - 输出："10"
    /// + 提示：
    ///     - `1 <= nums.length <= 100`
    ///     - `0 <= nums[i] <= 109`
    ///
    /// Related Topics 排序
    ///
    /// 👍 524 👎 0
    pub fn largest_number(mut nums: Vec<i32>) -> String {
        nums.sort_by(|x, y| {
            let (mut sx, mut sy) = (10i64, 10i64);
            let (x, y) = (*x as i64, *y as i64);
            while sx <= x {
                sx *= 10;
            }
            while sy <= y {
                sy *= 10;
            }
            (sx * y + x).cmp(&(sy * x + y))
        });
        if nums[0] == 0 {
            return 0.to_string();
        }
        nums.into_iter().map(|n| n.to_string()).collect::<Vec<String>>().concat()
    }

    /// 见 [`largest_number`](#method.largest_number)
    pub fn largest_number1(mut nums: Vec<i32>) -> String {
        let mut s = nums.into_iter()
            .map(|n| n.to_string())
            .collect::<Vec<String>>();
        s.sort_by(|s1, s2| {
            (s2.clone() + &s1).cmp(&(s1.clone() + &s2))
        });
        let ret: String = s.concat();
        if ret.starts_with('0') {
            0.to_string()
        } else {
            ret
        }
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0179() {
        let nums = vec![3,30,34,5,9];
        let s = Solution::largest_number(nums);
        assert_eq!(s, "9534330");
    }
}
