use crate::Solution;


impl Solution {
    /// [189.轮转数组](https://leetcode-cn.com/problems/rotate-array/)
    ///
    /// 2021-11-11 10:03:34
    ///
    /// 给你一个数组，将数组中的元素向右轮转 `k`个位置，其中 `k`是非负数。
    ///
    /// * **示例 1:**
    ///     + **输入:** nums = \[1,2,3,4,5,6,7\], k = 3
    ///     + **输出:** `[5,6,7,1,2,3,4]`
    ///     + **解释:**
    ///         - 向右轮转 1 步: `[7,1,2,3,4,5,6]`
    ///         - 向右轮转 2 步: `[6,7,1,2,3,4,5]` 向右轮转 3 步: `[5,6,7,1,2,3,4]`
    /// * **示例 2:**
    ///     + **输入：** nums = \[-1,-100,3,99\], k = 2
    ///     + **输出：** \[3,99,-1,-100\]
    ///     + **解释:**
    ///         - 向右轮转 1 步: \[99,-1,-100,3\]
    ///         - 向右轮转 2 步: \[3,99,-1,-100\]
    /// * **提示：**
    ///     * `1 <= nums.length <= 105`
    ///     * `-231 <= nums[i] <= 231 - 1`
    ///     * `0 <= k <= 105`
    /// * **进阶：**
    ///     * 尽可能想出更多的解决方案，至少有 **三种** 不同的方法可以解决这个问题。
    ///     * 你可以使用空间复杂度为 `O(1)` 的 **原地** 算法解决这个问题吗？
    /// * Related Topics
    ///     + 数组
    ///     + 数学
    ///     + 双指针
    ///
    /// * 👍 1190
    /// * 👎 0
    ///
    /// # 方法1 暴力模拟法
    /// ```rust
    /// pub fn rotate(nums: &mut Vec<i32>, k: i32) {
    ///     for _ in 0..(k as usize % nums.len()) {
    ///         let n = nums.pop().unwrap();
    ///         nums.insert(0, n);
    ///     }
    /// }
    /// ```
    /// # 方法2 环状替换
    /// ```rust
    /// pub fn rotate(nums: &mut Vec<i32>, k: i32) {
    ///     let k = k as usize % nums.len();
    ///     if nums.len() <= 1 || k == 0 {
    ///         return;
    ///     }
    ///     let mut start_idx = 0usize;
    ///     let mut idx = start_idx;
    ///     let mut tmp = nums[idx];
    ///     for _ in 0..nums.len() {
    ///         idx = (idx + k) % nums.len();
    ///         let new_tmp = nums[idx];
    ///         nums[idx] = tmp;
    ///         tmp = new_tmp;
    ///         if idx == start_idx {
    ///             start_idx += 1;
    ///             idx = start_idx;
    ///             tmp = nums[idx];
    ///         }
    ///     }
    /// }
    /// ```
    /// # 方法3 数组翻转
    /// ```rust
    /// pub fn rotate(nums: &mut Vec<i32>, k: i32) {
    ///     let k = k as usize % nums.len();
    ///     let n = nums.len();
    ///     nums.reverse();
    ///     nums[0..k].reverse();
    ///     nums[k..n].reverse();
    /// }
    /// ```
    /// # 方法4 内置方法
    /// ```rust
    /// pub fn rotate(nums: &mut Vec<i32>, k: i32) {
    ///     let k = k as usize % nums.len();
    ///     nums.rotate_right(k);
    /// }
    /// ```
    pub fn rotate(nums: &mut Vec<i32>, k: i32) {
        let k = k as usize % nums.len();
        nums.rotate_right(k);
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0189() {
        let mut nums = vec![1, 2, 3, 4, 5, 6, 7];
        let k = 3;
        Solution::rotate(&mut nums, k);
        //println!("{:?}", nums);
        assert_eq!(nums, vec![5, 6, 7, 1, 2, 3, 4]);
    }
}
