use crate::Solution;

impl Solution {
    /// [201.数字范围按位与](https://leetcode-cn.com/problems/bitwise-and-of-numbers-range/)
    ///
    /// 2022-02-18 17:00:11
    ///
    /// 给你两个整数 `left` 和 `right` ，表示区间 `[left, right]` ，返回此区间内所有数字 **按位与** 的结果（包含 `left` 、`right` 端点）。
    ///
    /// + **示例 1：**
    ///     + **输入：** left = 5, right = 7
    ///     + **输出：** 4
    /// + **示例 2：**
    ///     + **输入：** left = 0, right = 0
    ///     + **输出：** 0
    /// + **示例 3：**
    ///     + **输入：** left = 1, right = 2147483647
    ///     + **输出：** 0
    /// + **提示：**
    ///     * `0 <= left <= right <= 231 - 1`
    /// + Related Topics
    ///     * 位运算
    /// * 👍 361
    /// * 👎 0
    ///
    /// 1. 每次循环得到前缀掩码左移一位，直到前缀相同。
    ///     ```rust
    ///     let mut mask = -1i32;
    ///     while ((m ^ n) & mask) != 0 {
    ///         mask <<= 1;
    ///     }
    ///     m & mask
    ///     ```
    ///
    /// 2. 循环消去较大值的末尾1，直到前缀相同。
    ///     ```rust
    ///     while n > m {
    ///         n = n & (n - 1);
    ///     }
    ///     n
    ///     ```
    ///
    /// 3. 两数异或后将其最高位1后的位全部置为1，再取反码得到前缀掩码。
    ///
    ///     时间复杂度近似O(1)。空间复杂度O(1)，只用到了一个掩码。
    ///
    ///     ```rust
    ///     if m == n {
    ///         return m;
    ///     }
    ///     let mut mask = m ^ n;
    ///     mask |= (mask >> 1);
    ///     mask |= (mask >> 2);
    ///     mask |= (mask >> 4);
    ///     mask |= (mask >> 8);
    ///     mask |= (mask >> 16);
    ///     m & (!mask)
    ///     ```
    pub fn range_bitwise_and(left: i32, right: i32) -> i32 {
        if left == right {
            return left;
        }

        let mut mask = left ^ right;

        mask |= (mask >> 1);
        mask |= (mask >> 2);
        mask |= (mask >> 4);
        mask |= (mask >> 8);
        mask |= (mask >> 16);

        left & (!mask)
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0201() {
        assert_eq!(Solution::range_bitwise_and(5, 7), 4);
    }
}
