use crate::Solution;

impl Solution {
    /// [205.同构字符串](https://leetcode.cn/problems/isomorphic-strings/)
    ///
    /// 2022-08-19 14:25:56
    ///
    /// 给定两个字符串 `s` 和 `t` ，判断它们是否是同构的。
    ///
    /// 如果 `s` 中的字符可以按某种映射关系替换得到 `t` ，那么这两个字符串是同构的。
    ///
    /// 每个出现的字符都应当映射到另一个字符，同时不改变字符的顺序。不同字符不能映射到同一个字符上，相同字符只能映射到同一个字符上，字符可以映射到自己本身。
    ///
    /// + **示例 1:**
    ///     + **输入：** s = `"egg",` t = `"add"`
    ///     + **输出：** true
    /// + **示例 2：**
    ///     + **输入：** s = `"foo",` t = `"bar"`
    ///     + **输出：** false
    /// + **示例 3：**
    ///     + **输入：** s = `"paper",` t = `"title"`
    ///     + **输出：** true
    /// + **提示：**
    ///     * `1 <= s.length <= 5 * 104`
    ///     * `t.length == s.length`
    ///     * `s` 和 `t` 由任意有效的 ASCII 字符组成
    /// + Related Topics
    ///     * 哈希表
    ///     * 字符串
    pub fn is_isomorphic(s: String, t: String) -> bool {
        let mut m1 = std::collections::HashMap::<u8, u8>::new();
        let mut m2 = std::collections::HashMap::<u8, u8>::new();
        for (k, v) in s.into_bytes().into_iter().zip(t.into_bytes().into_iter()) {
            // m2.entry(v).or_insert(k)
            if v != *m1.entry(k).or_insert(v) {
                return false;
            }
        }
        true
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0205() {
        assert_eq!(Solution::is_isomorphic("egg".to_owned(), "add".to_owned()), true);
        assert_eq!(Solution::is_isomorphic("foo".to_owned(), "bar".to_owned()), false);
        assert_eq!(Solution::is_isomorphic("paper".to_owned(), "title".to_owned()), true);
        assert_eq!(Solution::is_isomorphic("badc".to_owned(), "baba".to_owned()), false);
    }
}
