use crate::Solution;
use crate::structure::ListNode;


impl Solution {
    /// 206.反转链表
    ///
    /// [原题链接](https://leetcode-cn.com/problems/reverse-linked-list/)
    ///
    /// 2021-07-31 16:06:58
    ///
    /// 给你单链表的头节点 head ，请你反转链表，并返回反转后的链表。
    ///
    /// + 示例 1：
    ///     - 输入：`head = [1,2,3,4,5]`
    ///     - 输出：`[5,4,3,2,1]`
    /// + 示例 2：
    ///     - 输入：`head = [1,2]`
    ///     - 输出：`[2,1]`
    /// + 示例 3：
    ///     - 输入：`head = []`
    ///     - 输出：`[]`
    /// + 提示：
    ///     - 链表中节点的数目范围是 `[0, 5000]`
    ///     - `-5000 <= Node.val <= 5000`
    ///
    /// 进阶：链表可以选用迭代或递归方式完成反转。你能否用两种方法解决这道题？
    ///
    /// Related Topics 递归 链表
    ///
    /// 👍 1871 👎 0
    pub fn reverse_list(head: Option<Box<ListNode>>) -> Option<Box<ListNode>> {
        if head.is_none() {
            return None;
        }
        let mut prev = None;
        let mut curr = head;
        while curr.is_some() {
            let mut node = curr.take()?;
            curr = node.next.take();
            node.next = prev;
            prev = Some(node);
        }
        prev
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;
    use crate::structure::ListNode;

    #[test]
    fn test_q0206() {
        let t1 = ListNode::from_vec(vec![1, 2, 3, 4, 5]);
        let t2 = Solution::reverse_list(t1);
        let ans = ListNode::from_vec(vec![5, 4, 3, 2, 1]);
        assert_eq!(t2, ans)
    }
}
