use crate::Solution;


impl Solution {
    /// 213.打家劫舍 II
    ///
    /// [原题链接](https://leetcode-cn.com/problems/house-robber-ii/)
    ///
    /// 2021-04-15 07:53:35
    ///
    /// 你是一个专业的小偷，计划偷窃沿街的房屋，每间房内都藏有一定的现金。这个地方所有的房屋都 围成一圈 ，这意味着第一个房屋和最后一个房屋是紧挨着的。同时，相邻的
    /// 房屋装有相互连通的防盗系统，如果两间相邻的房屋在同一晚上被小偷闯入，系统会自动报警 。
    ///
    /// 给定一个代表每个房屋存放金额的非负整数数组，计算你 在不触动警报装置的情况下 ，能够偷窃到的最高金额。
    ///
    /// + 示例 1：
    ///     - 输入：`nums = [2,3,2]`
    ///     - 输出：3
    ///     - 解释：你不能先偷窃 1 号房屋（金额 = 2），然后偷窃 3 号房屋（金额 = 2）, 因为他们是相邻的。
    /// + 示例 2：
    ///     - 输入：`nums = [1,2,3,1]`
    ///     - 输出：4
    ///     - 解释：你可以先偷窃 1 号房屋（金额 = 1），然后偷窃 3 号房屋（金额 = 3）。偷窃到的最高金额 = 1 + 3 = 4 。
    /// + 示例 3：
    ///     - 输入：`nums = [0]`
    ///     - 输出：0
    /// + 提示：
    ///     - `1 <= nums.length <= 100`
    ///     - `0 <= nums[i] <= 1000`
    ///
    /// Related Topics 动态规划
    ///
    /// 👍 529 👎 0
    pub fn rob2(nums: Vec<i32>) -> i32 {
        nums[0..(nums.len() - 1)].iter().fold((0, 0), |(a, b), &x| (b, b.max(a + x))).1.max(nums[1..nums.len()].iter().fold((0, 0), |(a, b), &x| (b, b.max(a + x))).1).max(nums[0])
    }
    /*pub fn rob2(nums: Vec<i32>) -> i32 {
        let rob_range = |nums: &Vec<i32>, start: usize, end: usize| -> i32 {
            nums[start..end].iter().fold((0, 0), |(a, b), &x| (b, b.max(a + x))).1
        };
        rob_range(&nums, 0, nums.len() - 1).max(rob_range(&nums, 1, nums.len())).max(nums[0])
    }*/
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0213() {
        let nums = vec![1, 2, 3, 1];
        let ans = Solution::rob2(nums);
        assert_eq!(ans, 4);
    }
}
