use crate::Solution;


impl Solution {
    /// 220.存在重复元素 III
    ///
    /// [原题链接](https:///leetcode-cn.com/problems/contains-duplicate-iii/)
    ///
    /// 2021-04-17 09:31:09
    ///
    /// 给你一个整数数组 nums 和两个整数 k 和 t 。请你判断是否存在两个下标 i 和 j，使得 `abs(nums[i] - nums[j]) <= t` ，
    /// 同时又满足 abs(i - j) <= k 。
    ///
    /// 如果存在则返回 `true`，不存在返回 `false`。
    /// + 示例 1：
    ///     - 输入：`nums = [1,2,3,1], k = 3, t = 0`
    ///     - 输出：`true`
    /// + 示例 2：
    ///     - 输入：`nums = [1,0,1,1], k = 1, t = 2`
    ///     - 输出：`true`
    /// + 示例 3：
    ///     - 输入：`nums = [1,5,9,1,5,9], k = 2, t = 3`
    ///     - 输出：`false`
    /// + 提示：
    ///     - `0 <= nums.length <= 2 * 104`
    ///     - `-231 <= nums[i] <= 231 - 1`
    ///     - `0 <= k <= 104`
    ///     - `0 <= t <= 231 - 1`
    /// Related Topics 排序 Ordered Map
    ///
    /// 👍 335 👎 0
    pub fn contains_nearby_almost_duplicate(nums: Vec<i32>, k: i32, t: i32) -> bool {
        let mut mp = std::collections::hash_map::HashMap::<i64, i64>::new();
        let k = k as usize;
        let t = t as i64;
        let n = nums.len();
        let get_id = |x: i64, w: i64| {
            if x < 0 {
                (x as i64 + 1) / w - 1
            } else {
                x as i64 / w
            }
        };
        for i in 0..n {
            let x = nums[i] as i64;
            let id = get_id(x, t + 1);
            if mp.contains_key(&id) {
                return true;
            }
            if mp.contains_key(&(id - 1)) && (x - mp.get(&(id - 1)).unwrap()).abs() <= t {
                return true;
            }
            if mp.contains_key(&(id + 1)) && (x - mp.get(&(id + 1)).unwrap()).abs() <= t {
                return true;
            }
            mp.insert(id, x);
            if i >= k {
                mp.remove(&get_id(nums[i - k] as i64, t + 1));
            }
        }
        false
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0220() {
        let nums = vec![2147483647, -1, 2147483647];
        let k = 1;
        let t = 2147483647;
        let ans = Solution::contains_nearby_almost_duplicate(nums, k, t);
        assert_eq!(ans, false);
    }
}
