use crate::Solution;

impl Solution {
    /// [224.基本计算器](https://leetcode-cn.com/problems/basic-calculator/)
    ///
    /// 2022-02-18 17:12:40
    ///
    /// 给你一个字符串表达式 `s` ，请你实现一个基本计算器来计算并返回它的值。
    ///
    /// 注意:不允许使用任何将字符串作为数学表达式计算的内置函数，比如 `eval()` 。
    ///
    /// + **示例 1：**
    ///     + **输入：** s = "1 + 1"
    ///     + **输出：** 2
    /// + **示例 2：**
    ///     + **输入：** s = " 2-1 + 2 "
    ///     + **输出：** 3
    /// + **示例 3：**
    ///     + **输入：** s = "(1+(4+5+2)-3)+(6+8)"
    ///     + **输出：** 23
    /// + **提示：**
    ///     * `1 <= s.length <= 3 * 105`
    ///     * `s` 由数字、`'+'`、`'-'`、`'('`、`')'`、和 `' '` 组成
    ///     * `s` 表示一个有效的表达式
    ///     * '+' 不能用作一元运算(例如， "+1" 和 `"+(2 + 3)"` 无效)
    ///     * '-' 可以用作一元运算(即 "-1" 和 `"-(2 + 3)"` 是有效的)
    ///     * 输入中不存在两个连续的操作符
    ///     * 每个数字和运行的计算将适合于一个有符号的 32位 整数
    /// + Related Topics
    ///     * 栈
    ///     * 递归
    ///     * 数学
    ///     * 字符串
    /// * 👍 709
    /// * 👎 0
    pub fn calculate(s: String) -> i32 {
        let mut stack = Vec::<i32>::new();
        let mut operand = 0;
        let mut result = 0;
        let mut sign = 1;

        let s = s.into_bytes();

        for i in 0..s.len() {
            let ch = s[i];
            ch.is_ascii_digit();
            match ch {
                b'0'..=b'9' => operand = 10 * operand + (ch - b'0') as i32,
                b'+' => {
                    result += sign * operand;
                    sign = 1;
                    operand = 0;
                }
                b'-' => {
                    result += sign * operand;
                    sign = -1;
                    operand = 0;
                }
                b'(' => {
                    stack.push(result);
                    stack.push(sign);
                    sign = 1;
                    result = 0;
                }
                b')' => {
                    result += sign * operand;
                    result *= stack.pop().unwrap();
                    result += stack.pop().unwrap();
                    operand = 0;
                }
                _ => {}
            }
        }

        result + (sign * operand)
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0224() {
        assert_eq!(Solution::calculate("(1+(4+5+2)-3)+(6+8)".to_string()), 23);
    }
}
