use crate::Solution;

impl Solution {
    /// [228.汇总区间](https://leetcode-cn.com/problems/summary-ranges/)
    ///
    /// 2022-02-18 17:16:43
    ///
    /// 给定一个  **无重复元素** 的 **有序** 整数数组 `nums` 。
    ///
    /// 返回 _**恰好覆盖数组中所有数字** 的 **最小有序** 区间范围列表 _。也就是说，`nums` 的每个元素都恰好被某个区间范围所覆盖，并且不存在属于某个范围但不属于 `nums` 的数字 `x` 。
    ///
    /// 列表中的每个区间范围 `[a,b]` 应该按如下格式输出：
    ///
    /// * `"a->b"` ，如果 `a != b`
    /// * `"a"` ，如果 `a == b`
    /// + **示例 1：**
    ///     + **输入：** nums = \[0,1,2,4,5,7\]
    ///     + **输出：** \["0->2","4->5","7"\]
    ///     + **解释：** 区间范围是：
    ///
    ///         \[0,2\] --> "0->2"
    ///
    ///         \[4,5\] --> "4->5"
    ///
    ///         \[7,7\] --> "7"
    ///
    /// + **示例 2：**
    ///     + **输入：** nums = \[0,2,3,4,6,8,9\]
    ///     + **输出：** \["0","2->4","6","8->9"\]
    ///     + **解释：** 区间范围是：
    ///
    ///         \[0,0\] --> "0"
    ///
    ///         \[2,4\] --> "2->4"
    ///
    ///         \[6,6\] --> "6"
    ///
    ///         \[8,9\] --> "8->9"
    ///
    /// + **提示：**
    ///     * `0 <= nums.length <= 20`
    ///     * `-231 <= nums[i] <= 231 - 1`
    ///     * `nums` 中的所有值都 **互不相同**
    ///     * `nums` 按升序排列
    /// Related Topics
    ///     * 数组
    /// * 👍 201
    /// * 👎 0
    pub fn summary_ranges(nums: Vec<i32>) -> Vec<String> {
        if nums.is_empty() {
            return Vec::new();
        }
        let mut ret = Vec::<String>::new();
        let mut s = nums[0];
        for i in 1..=nums.len() {
            if i == nums.len() || nums[i] - nums[i - 1] != 1 {
                if nums[i - 1] - s > 0 {
                    ret.push(format!("{}->{}", s, nums[i - 1]));
                } else {
                    ret.push(format!("{}", s));
                }
                if i < nums.len() {
                    s = nums[i];
                }
            }
        }
        ret
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0228() {
        assert_eq!(Solution::summary_ranges(vec![0, 2, 3, 4, 6, 8, 9]), vec!["0".to_string(), "2->4".to_string(), "6".to_string(), "8->9".to_string()]);
    }
}
