use crate::Solution;

impl Solution {
    /// 231.2 的幂
    ///
    /// [原题链接](https://leetcode-cn.com/problems/power-of-two/)
    ///
    /// 2021-05-31 16:59:06
    ///
    /// 给你一个整数 n，请你判断该整数是否是 2 的幂次方。如果是，返回 true ；否则，返回 false 。
    ///
    /// 如果存在一个整数 x 使得 n == 2x ，则认为 n 是 2 的幂次方。
    ///
    /// + 示例 1：
    ///     - 输入：n = 1
    ///     - 输出：true
    ///     - 解释：2^0 = 1
    /// + 示例 2：
    ///     - 输入：n = 16
    ///     - 输出：true
    ///     - 解释：2^4 = 16
    /// + 示例 3：
    ///     - 输入：n = 3
    ///     - 输出：false
    /// + 示例 4：
    ///     - 输入：n = 4
    ///     - 输出：true
    /// + 示例 5：
    ///     - 输入：n = 5
    ///     - 输出：false
    /// + 提示：
    ///     - -231 <= n <= 231 - 1
    ///
    /// 进阶：你能够不使用循环/递归解决此问题吗？
    ///
    /// Related Topics 位运算 数学
    ///
    /// 👍 368 👎 0
    pub fn is_power_of_two(n: i32) -> bool {
        n > 0 && n & (n - 1) == 0
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0231() {
        assert_eq!(Solution::is_power_of_two(64), true);
    }
}
