use crate::Solution;
use crate::structure::TreeNode;
use std::rc::Rc;
use std::cell::RefCell;

impl Solution {
    /// [257.二叉树的所有路径](https://leetcode-cn.com/problems/binary-tree-paths/)
    ///
    /// 2022-02-11 10:10:27
    ///
    /// 给你一个二叉树的根节点 `root` ，按 **任意顺序** ，返回所有从根节点到叶子节点的路径。
    ///
    /// > **叶子节点** 是指没有子节点的节点。
    ///
    /// + **示例 1：**
    ///     + ![](https://assets.leetcode.com/uploads/2021/03/12/paths-tree.jpg)
    ///     + **输入：** root = \[1,2,3,null,5\]
    ///     + **输出：** \["1->2->5","1->3"\]
    /// + **示例 2：**
    ///     + **输入：** root = \[1\]
    ///     + **输出：** \["1"\]
    /// + **提示：**
    ///     * 树中节点的数目在范围 `[1, 100]` 内
    ///     * `-100 <= Node.val <= 100`
    /// + Related Topics
    ///     * 树
    ///     * 深度优先搜索
    ///     * 字符串
    ///     * 回溯
    ///     * 二叉树
    /// * 👍 644
    /// * 👎 0
    pub fn binary_tree_paths(root: Option<Rc<RefCell<TreeNode>>>) -> Vec<String> {
        fn helper(root: &Option<Rc<RefCell<TreeNode>>>, mut path: Vec<i32>, ans: &mut Vec<String>) {
            if let Some(node) = root {
                match node.borrow() {
                    p => {
                        path.push(p.val);
                        if p.left.is_none() && p.right.is_none() {
                            ans.push(path.into_iter().map(|val| val.to_string()).collect::<Vec<String>>().join("->"));
                        } else {
                            if p.left.is_some() { helper(&p.left, path.clone(), ans); }
                            if p.right.is_some() { helper(&p.right, path.clone(), ans); }
                        }
                    }
                }
            }
        }
        let mut ans = Vec::<String>::new();
        helper(&root, Vec::<i32>::new(), &mut ans);
        ans
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;
    use crate::structure::TreeNode;
    use std::rc::Rc;
    use std::cell::RefCell;

    #[test]
    fn test_q0257() {
        let tree = Some(Rc::new(RefCell::new(TreeNode {
            val: 1,
            left: Some(Rc::new(RefCell::new(TreeNode {
                val: 2,
                left: None,
                right: Some(Rc::new(RefCell::new(TreeNode::new(5)))),
            }))),
            right: Some(Rc::new(RefCell::new(TreeNode::new(3)))),
        })));
        let ans = vec!["1->2->5".to_string(), "1->3".to_string()];
        assert_eq!(Solution::binary_tree_paths(tree), ans);
    }
}
