use crate::Solution;

impl Solution {
    /// [260.只出现一次的数字 III](https://leetcode-cn.com/problems/single-number-iii/)
    ///
    /// 2022-02-18 17:22:33
    ///
    /// 给定一个整数数组 `nums`，其中恰好有两个元素只出现一次，其余所有元素均出现两次。 找出只出现一次的那两个元素。你可以按 **任意顺序** 返回答案。
    ///
    /// + **进阶：**你的算法应该具有线性时间复杂度。你能否仅使用常数空间复杂度来实现？
    /// + **示例 1：**
    ///     + **输入：** nums = \[1,2,1,3,2,5\]
    ///     + **输出：** \[3,5\]
    ///     + **解释：** \[5, 3\] 也是有效的答案。
    /// + **示例 2：**
    ///     + **输入：** nums = \[-1,0\]
    ///     + **输出：** \[-1,0\]
    /// + **示例 3：**
    ///     + **输入：** nums = \[0,1\]
    ///     + **输出：** \[1,0\]
    /// + **提示：**
    ///     * `2 <= nums.length <= 3 * 104`
    ///     * `-231 <= nums[i] <= 231 - 1`
    ///     * 除两个只出现一次的整数外，`nums` 中的其他数字都出现两次
    /// + Related Topics
    ///     * 位运算
    ///     * 数组
    /// * 👍 570
    /// * 👎 0
    pub fn single_number3(nums: Vec<i32>) -> Vec<i32> {
        let mask = nums.iter().fold(0, |acc, &s| s ^ acc);
        let diff = mask & (-mask);
        let d = nums.iter().fold(0, |mut acc, &num| {
            if (num & diff) != 0 { acc ^= num; }
            acc
        });
        vec![d, mask ^ d]
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0260() {
        assert_eq!(Solution::single_number3(vec![1, 2, 1, 3, 2, 5]), vec![3, 5]);
    }
}
