use crate::Solution;

impl Solution {
    /// 263.丑数
    ///
    /// [原题链接](https://leetcode-cn.com/problems/ugly-number/)
    ///
    /// 2021-04-10 09:10:42
    ///
    /// 给你一个整数 n ，请你判断 n 是否为 丑数 。如果是，返回 true ；否则，返回 false 。
    ///
    /// 丑数 就是只包含质因数 2、3 和/或 5 的正整数。
    ///
    /// + 示例 1：
    ///     - 输入：n = 6
    ///     - 输出：true
    ///     - 解释：6 = 2 × 3
    /// + 示例 2：
    ///     - 输入：n = 8
    ///     - 输出：true
    ///     - 解释：8 = 2 × 2 × 2
    /// + 示例 3：
    ///     - 输入：n = 14
    ///     - 输出：false
    ///     - 解释：14 不是丑数，因为它包含了另外一个质因数 7 。
    /// + 示例 4：
    ///     - 输入：n = 1
    ///     - 输出：true
    ///     - 解释：1 通常被视为丑数。
    /// + 提示：
    ///     - -231 <= n <= 231 - 1
    ///
    /// Related Topics 数学
    ///
    /// 👍 201 👎 0
    pub fn is_ugly(mut n: i32) -> bool {
        if n <= 0 {
            return false
        }
        for f in vec![2, 3, 5] {
            while n % f == 0 {
                n /= f;
            }
        }
        n == 1
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0263() {
        let n = 14;
        let ans = Solution::is_ugly(n);
        assert_eq!(ans, false);
    }
}
