use crate::Solution;

impl Solution {
    /// 264.丑数 II
    ///
    /// [原题链接](https://leetcode-cn.com/problems/ugly-number-ii/)
    ///
    /// 2021-04-11 10:38:29
    ///
    /// 给你一个整数 n ，请你找出并返回第 n 个 丑数 。
    ///
    /// 丑数 就是只包含质因数 2、3 和/或 5 的正整数。
    ///
    /// + 示例 1：
    ///     - 输入：n = 10
    ///     - 输出：12
    ///     - 解释：`[1, 2, 3, 4, 5, 6, 8, 9, 10, 12]` 是由前 10 个丑数组成的序列。
    /// + 示例 2：
    ///     - 输入：n = 1
    ///     - 输出：1
    ///     - 解释：1 通常被视为丑数。
    /// + 提示：
    ///     - 1 <= n <= 1690
    ///
    /// Related Topics 堆 数学 动态规划
    /// 👍 542 👎 0
    pub fn nth_ugly_number(n: i32) -> i32 {
        if n <= 0 {
            return 0;
        }
        let n = n as usize;
        let mut dp = vec![0; n];
        dp[0] = 1;
        let (mut p2, mut p3, mut p5) = (0, 0, 0);
        for i in 1..n {
            let (num2, num3, num5) = (dp[p2] * 2, dp[p3] * 3, dp[p5] * 5);
            dp[i] = num2.min(num3).min(num5);
            if dp[i] == num2 {
                p2 += 1;
            }
            if dp[i] == num3 {
                p3 += 1;
            }
            if dp[i] == num5 {
                p5 += 1;
            }
        }
        dp[n - 1]
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0264() {
        let ans = Solution::nth_ugly_number(10);
        assert_eq!(ans, 12);
    }
}
