use crate::Solution;


impl Solution {
    /// [278.第一个错误的版本](https://leetcode-cn.com/problems/first-bad-version/)
    ///
    /// 2021-07-19 14:54:04
    ///
    /// 你是产品经理，目前正在带领一个团队开发新的产品。不幸的是，你的产品的最新版本没有通过质量检测。由于每个版本都是基于之前的版本开发的，所以错误的版本之后的所有版本都是错的。
    ///
    /// 假设你有 `n` 个版本 `[1, 2, ..., n]`，你想找出导致之后所有版本出错的第一个错误的版本。
    ///
    /// 你可以通过调用 `bool isBadVersion(version)` 接口来判断版本号 `version` 是否在单元测试中出错。实现一个函数来查找第一个错误的版本。你应该尽量减少对调用 `API` 的次数。
    ///
    /// + 示例 1：
    ///     - 输入：`n = 5, bad = 4`
    ///     - 输出：`4`
    ///     - 解释：
    ///         * 调用 `isBadVersion(3) -> false`
    ///         * 调用 `isBadVersion(5) -> true`
    ///         * 调用 `isBadVersion(4) -> true`
    ///         * 所以，`4` 是第一个错误的版本。
    /// + 示例 2：
    ///     - 输入：`n = 1, bad = 1`
    ///     - 输出：`1`
    /// + 提示：
    ///     - `1 <= bad <= n <= 231 - 1`
    ///
    /// Related Topics 二分查找 交互
    ///
    /// 👍 351 👎 0
    ///
    /// The API isBadVersion is defined for you.
    /// isBadVersion(versions:i32)-> bool;
    /// to call it use self.isBadVersion(versions)
    pub fn first_bad_version(&self, n: i32) -> i32 {
        let mut good: i64 = 0;
        let mut bad: i64 = n as i64;
        while bad - good > 1 {
            let mid = (good + bad + 1) / 2;
            if self.isBadVersion(mid as i32) {
                bad = mid;
            } else {
                good = mid;
            }
        }
        bad as i32
    }

    #[allow(non_snake_case)]
    fn isBadVersion(&self, versions: i32) -> bool {
        versions >= 4
    }
}
