use crate::Solution;

impl Solution {
    /// [287.寻找重复数](https://leetcode-cn.com/problems/find-the-duplicate-number/)
    ///
    /// 2022-02-18 17:28:10
    ///
    /// 给定一个包含 `n + 1` 个整数的数组 `nums` ，其数字都在 `[1, n]` 范围内（包括 `1` 和 `n`），可知至少存在一个重复的整数。
    ///
    /// 假设 `nums` 只有 **一个重复的整数** ，返回 **这个重复的数** 。
    ///
    /// 你设计的解决方案必须 **不修改** 数组 `nums` 且只用常量级 `O(1)` 的额外空间。
    ///
    /// + **示例 1：**
    ///     + **输入：** nums = \[1,3,4,2,2\]
    ///     + **输出：** 2
    /// + **示例 2：**
    ///     + **输入：** nums = \[3,1,3,4,2\]
    ///     + **输出：** 3
    /// + **提示：**
    ///     * `1 <= n <= 105`
    ///     * `nums.length == n + 1`
    ///     * `1 <= nums[i] <= n`
    ///     * `nums` 中 **只有一个整数** 出现 **两次或多次** ，其余整数均只出现 **一次**
    /// + **进阶：**
    ///     * 如何证明 `nums` 中至少存在一个重复的数字?
    ///     * 你可以设计一个线性级时间复杂度 `O(n)` 的解决方案吗？
    /// + Related Topics
    ///     * 位运算
    ///     * 数组
    ///     * 双指针
    ///     * 二分查找
    /// * 👍 1580
    /// * 👎 0
    ///
    /// 1. 排序
    ///
    ///     ```rust
    ///     pub fn find_duplicate(mut nums: Vec<i32>) -> i32 {
    ///         nums.sort();
    ///         for (idx, &n) in nums.iter().enumerate() {
    ///             if n == nums[idx + 1] {
    ///                 return n;
    ///             }
    ///         }
    ///         0
    ///     }
    ///     ```
    ///
    /// 2. 查表
    ///
    ///     ```rust
    ///     pub fn find_duplicate(nums: Vec<i32>) -> i32 {
    ///         let mut num_look = vec![0; nums.len()];
    ///         let mut idx = 0usize;
    ///         for n in nums {
    ///             idx = (n - 1) as usize;
    ///             if n == num_look[idx] {
    ///                 return n;
    ///             }
    ///             num_look[idx] = n;
    ///         }
    ///         0
    ///     }
    ///     ```
    ///
    /// 3. 二分查找
    ///
    /// 4. 二进制
    ///
    /// 5. 快慢指针
    pub fn find_duplicate(nums: Vec<i32>) -> i32 {
        let mut num_look = vec![0; nums.len()];
        let mut idx = 0usize;
        for n in nums {
            idx = (n - 1) as usize;
            if n == num_look[idx] {
                return n;
            }
            num_look[idx] = n;
        }
        0
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0287() {
        assert_eq!(Solution::find_duplicate(vec![1, 3, 4, 2, 2]), 2);
    }
}
