use crate::Solution;

impl Solution {
    /// [338.比特位计数](https://leetcode-cn.com/problems/counting-bits/)
    ///
    /// 2022-02-21 10:03:17
    ///
    /// 给你一个整数 `n` ，对于 `0 <= i <= n` 中的每个 `i` ，计算其二进制表示中 **`1` 的个数** ，返回一个长度为 `n + 1` 的数组 `ans` 作为答案。
    ///
    /// + **示例 1：**
    ///     + **输入：** n = 2
    ///     + **输出：** \[0,1,1\]
    ///     + **解释：**
    ///         0 --> 0
    ///         1 --> 1
    ///         2 --> 10
    /// + **示例 2：**
    ///     + **输入：** n = 5
    ///     + **输出：** \[0,1,1,2,1,2\]
    ///     + **解释：**
    ///         0 --> 0
    ///         1 --> 1
    ///         2 --> 10
    ///         3 --> 11
    ///         4 --> 100
    ///         5 --> 101
    /// + **提示：**
    ///     * `0 <= n <= 105`
    /// + **进阶：**
    ///     * 很容易就能实现时间复杂度为 `O(n log n)` 的解决方案，你可以在线性时间复杂度 `O(n)` 内用一趟扫描解决此问题吗？
    ///     * 你能不使用任何内置函数解决此问题吗？（如，C++ 中的 `__builtin_popcount` ）
    /// + Related Topics
    ///     * 位运算
    ///     * 动态规划
    /// * 👍 894
    /// * 👎 0
    ///
    /// 动态规划 状态转移 `v[i] = v[i >> 1] + (i & 1) || v[i] = v[i & (i - 1)] + 1`
    pub fn count_bits(n: i32) -> Vec<i32> {
        /*let mut v = Vec::with_capacity((num + 1) as usize);
        v.push(0);
        for i in 1..=(num as usize) {
            v.push(&v[i & (i - 1)] + 1)
        }
        v*/
        let mut v = Vec::with_capacity((n + 1) as usize);
        v.push(0);
        (1..=(n as usize)).for_each(|i| { v.push(&v[i >> 1] + (i & 1) as i32) });
        v
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0338() {
        assert_eq!(Solution::count_bits(5), vec![0, 1, 1, 2, 1, 2]);
    }
}
