use crate::Solution;

impl Solution {
    /// [345.反转字符串中的元音字母](https://leetcode.cn/problems/reverse-vowels-of-a-string/)
    ///
    /// 2022-08-19 13:19:18
    ///
    /// 给你一个字符串 `s` ，仅反转字符串中的所有元音字母，并返回结果字符串。
    ///
    /// 元音字母包括 `'a'`、`'e'`、`'i'`、`'o'`、`'u'`，且可能以大小写两种形式出现。
    ///
    /// + **示例 1：**
    ///     + **输入：** s = "hello"
    ///     + **输出：** "holle"
    /// + **示例 2：**
    ///     + **输入：** s = "leetcode"
    ///     + **输出：** "leotcede"
    /// + **提示：**
    ///     * `1 <= s.length <= 3 * 105`
    ///     * `s` 由 **可打印的 ASCII** 字符组成
    /// + Related Topics
    ///     * 双指针
    ///     * 字符串
    pub fn reverse_vowels(s: String) -> String {
        let mut b = s.into_bytes();
        let (mut i, mut j) = (0usize, b.len() - 1);
        while i < j {
            match b[i] {
                b'a' | b'e' | b'i' | b'o' | b'u' | b'A' | b'E' | b'I' | b'O' | b'U' => {
                    while i < j && !matches!(b[j], b'a' | b'e' | b'i' | b'o' | b'u' | b'A' | b'E' | b'I' | b'O' | b'U') {
                        j -= 1;
                    }
                    if i < j {
                        b.swap(i, j);
                        j -= 1;
                        i += 1;
                    }
                }
                _ => i += 1
            }
        }
        String::from_utf8(b).unwrap()
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0345() {
        assert_eq!(Solution::reverse_vowels("hello".to_owned()), "holle".to_owned());
        assert_eq!(Solution::reverse_vowels("leetcode".to_owned()), "leotcede".to_owned());
        assert_eq!(Solution::reverse_vowels("Aa".to_owned()), "aA".to_owned());
        assert_eq!(Solution::reverse_vowels("race car".to_owned()), "race car".to_owned());
    }
}
