use crate::Solution;

impl Solution {
    /// [349.两个数组的交集](https://leetcode.cn/problems/intersection-of-two-arrays/)
    ///
    /// 2022-08-19 12:55:08
    ///
    /// 给定两个数组 `nums1` 和 `nums2` ，返回 _它们的交集_ 。输出结果中的每个元素一定是 **唯一** 的。我们可以 **不考虑输出结果的顺序** 。
    ///
    /// + **示例 1：**
    ///     + **输入：** nums1 = \[1,2,2,1\], nums2 = \[2,2\]
    ///     + **输出：** \[2\]
    /// + **示例 2：**
    ///     + **输入：** nums1 = \[4,9,5\], nums2 = \[9,4,9,8,4\]
    ///     + **输出：** \[9,4\]
    ///     + **解释：** \[4,9\] 也是可通过的
    /// + **提示：**
    ///     * `1 <= nums1.length, nums2.length <= 1000`
    ///     * `0 <= nums1[i], nums2[i] <= 1000`
    /// + Related Topics
    ///     * 数组
    ///     * 哈希表
    ///     * 双指针
    ///     * 二分查找
    ///     * 排序
    pub fn intersection(nums1: Vec<i32>, nums2: Vec<i32>) -> Vec<i32> {
        let mut s1 = nums1.into_iter().collect::<std::collections::hash_set::HashSet<i32>>();
        let mut s2 = nums2.into_iter().collect::<std::collections::hash_set::HashSet<i32>>();
        if s1.len() > s2.len() {
            std::mem::swap(&mut s1, &mut s2);
        }
        s1.into_iter().filter(|v| s2.contains(v)).collect()
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0349() {
        assert_eq!(Solution::intersection(vec![1, 2, 2, 1], vec![2, 2]), vec![2]);
        assert_eq!(Solution::intersection(vec![4, 9, 5], vec![9, 4, 9, 8, 4]), vec![4, 9]);
    }
}
