use crate::Solution;

impl Solution {
    /// 363.矩形区域不超过 K 的最大数值和
    ///
    /// [原题链接](https://leetcode-cn.com/problems/max-sum-of-rectangle-no-larger-than-k/)
    ///
    /// 2021-04-22 08:27:56
    ///
    /// 给你一个 m x n 的矩阵 matrix 和一个整数 k ，找出并返回矩阵内部矩形区域的不超过 k 的最大数值和。
    ///
    /// 题目数据保证总会存在一个数值和不超过 k 的矩形区域。
    ///
    /// + 示例 1：
    ///     - 输入：`matrix = [[1,0,1],[0,-2,3]], k = 2`
    ///     - 输出：2
    ///     - 解释：蓝色边框圈出来的矩形区域 `[[0, 1], [-2, 3]]` 的数值和是 2，且 2 是不超过 k 的最大数字（k = 2）。
    /// + 示例 2：
    ///     - 输入：`matrix = [[2,2,-1]], k = 3`
    ///     - 输出：3
    /// + 提示：
    ///     - `m == matrix.length`
    ///     - `n == matrix[i].length`
    ///     - `1 <= m, n <= 100`
    ///     - `-100 <= matrix[i][j] <= 100`
    ///     - `-105 <= k <= 105`
    ///
    /// 进阶：如果行数远大于列数，该如何设计解决方案？
    ///
    /// Related Topics 队列 二分查找 动态规划
    ///
    /// 👍 186 👎 0
    pub fn max_sum_submatrix(matrix: Vec<Vec<i32>>, k: i32) -> i32 {
        let mut ans = i32::MIN;
        let n = matrix[0].len();
        for i in 0..matrix.len() {
            let mut sum = vec![0; n];
            for j in i..matrix.len() {
                for c in 0..n {
                    sum[c] += matrix[j][c];
                }
                let mut sum_set = std::collections::btree_set::BTreeSet::<i32>::new();
                sum_set.insert(0);
                let mut s = 0;
                for &v in &sum {
                    s += v;
                    if let Some(&c) = sum_set.iter().find(|&&a| a >= (s - k)) {
                        ans = ans.max(s - c);
                    }
                    sum_set.insert(s);
                }
            }
        }
        ans
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0363() {
        let matrix = vec![vec![1, 0, 1], vec![0, -2, 3]];
        let k = 2;
        let ans = Solution::max_sum_submatrix(matrix, k);
        assert_eq!(ans, 2);
    }
}
