use crate::Solution;

impl Solution {
    /// 368.最大整除子集
    ///
    /// [原题链接](https://leetcode-cn.com/problems/largest-divisible-subset/)
    ///
    /// 2021-04-23 08:38:40
    ///
    /// 给你一个由 无重复 正整数组成的集合 nums ，请你找出并返回其中最大的整除子集 answer ，子集中每一元素对 `(answer[i], answer[j])` 都应当满足：
    ///
    /// `answer[i] % answer[j] == 0` ，或 `answer[j] % answer[i] == 0`
    ///
    /// 如果存在多个有效解子集，返回其中任何一个均可。
    ///
    /// + 示例 1：
    ///     - 输入：`nums = [1,2,3]`
    ///     - 输出：`[1,2]`
    ///     - 解释：`[1,3]` 也会被视为正确答案。
    /// + 示例 2：
    ///     - 输入：`nums = [1,2,4,8]`
    ///     - 输出：`[1,2,4,8]`
    /// + 提示：
    ///     - `1 <= nums.length <= 1000`
    ///     - `1 <= nums[i] <= 2 * 109`
    ///     - nums 中的所有整数 互不相同
    ///
    /// Related Topics 数学 动态规划
    ///
    /// 👍 229 👎 0
    pub fn largest_divisible_subset(mut nums: Vec<i32>) -> Vec<i32> {
        let len = nums.len();
        nums.sort();
        let mut dp = vec![1; len];
        let mut max_size = 1;
        let mut max_val = dp[0];
        for i in 1..len {
            for j in 0..i {
                if nums[i] % nums[j] == 0 {
                    dp[i] = dp[i].max(dp[j] + 1);
                }
            }
            if dp[i] > max_size {
                max_size = dp[i];
                max_val = nums[i];
            }
        }
        let mut res = vec![];
        if max_size == 1 {
            res.push(nums[0]);
            return res;
        }
        for i in (0..len).rev() {
            if dp[i] == max_size && max_val % nums[i] == 0 {
                res.push(nums[i]);
                max_val = nums[i];
                max_size -= 1;
            }
            if max_val <= 0 {
                break;
            }
        }
        res.sort();
        res
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0368() {
        let nums = vec![1, 2, 4, 8];
        let ans = Solution::largest_divisible_subset(nums);
        assert_eq!(ans, vec![1, 2, 4, 8]);
    }
}
