use crate::Solution;

impl Solution {
    /// [371.两整数之和](https://leetcode-cn.com/problems/sum-of-two-integers/)
    ///
    /// 2022-02-21 10:22:25
    ///
    /// 给你两个整数 `a` 和 `b` ，**不使用** 运算符 `+` 和 `-` ，计算并返回两整数之和。
    ///
    /// + **示例 1：**
    ///     + **输入：** a = 1, b = 2
    ///     + **输出：** 3
    /// + **示例 2：**
    ///     + **输入：** a = 2, b = 3
    ///     + **输出：** 5
    /// + **提示：**
    ///     * `-1000 <= a, b <= 1000`
    /// + Related Topics
    ///     * 位运算
    ///     * 数学
    /// * 👍 586
    /// * 👎 0
    ///
    /// 1. 加法器
    ///     ```rust
    ///     pub fn get_sum(mut a: i32, mut b: i32) -> i32 {
    ///         let mut sum = a;
    ///         while b != 0 {
    ///             sum = a ^ b;
    ///             b = (a & b) << 1;
    ///             a = sum;
    ///         }
    ///         sum
    ///     }
    ///     ```
    /// 2. 内置接口
    ///
    ///     实现见代码
    pub fn get_sum(a: i32, b: i32) -> i32 {
        std::ops::Add::<i32>::add(a, b)
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0371() {
        assert_eq!(Solution::get_sum(12, 13), 25);
    }
}
