use crate::Solution;

impl Solution {
    /// [387.字符串中的第一个唯一字符](https://leetcode-cn.com/problems/first-unique-character-in-a-string/)
    ///
    /// 2022-02-21 10:29:57
    ///
    /// 给定一个字符串 `s` ，找到 _它的第一个不重复的字符，并返回它的索引_ 。如果不存在，则返回 `-1` 。
    ///
    /// + **示例 1：**
    ///     + **输入:** s = "leetcode"
    ///     + **输出:** 0
    /// + **示例 2:**
    ///     + **输入:** s = "loveleetcode"
    ///     + **输出:** 2
    /// + **示例 3:**
    ///     + **输入:** s = "aabb"
    ///     + **输出:** -1
    /// + **提示:**
    ///     * `1 <= s.length <= 105`
    ///     * `s` 只包含小写字母
    /// + Related Topics
    ///     * 队列
    ///     * 哈希表
    ///     * 字符串
    ///     * 计数
    /// * 👍 505
    /// * 👎 0
    pub fn first_uniq_char(s: String) -> i32 {
        let mut dup_lookup = vec![false; 26];
        let mut idx_lookup = vec![s.len(); 26];
        let s = s.into_bytes();
        let mut idx = 0usize;
        for i in 0..s.len() {
            idx = (s[i] - 'a' as u8) as usize;
            if idx_lookup[idx] == s.len() {
                idx_lookup[idx] = i;
            } else {
                dup_lookup[idx] = true;
            }
        }
        let mut ret = s.len();
        for i in 0..dup_lookup.len() {
            if !dup_lookup[i] && idx_lookup[i] != s.len() && idx_lookup[i] < ret {
                ret = idx_lookup[i];
            }
        }
        if ret == s.len() {
            -1
        } else {
            ret as i32
        }
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0387() {
        assert_eq!(Solution::first_uniq_char( "leetcode".to_string()), 0);
    }
}
