use crate::Solution;


impl Solution {
    /// 392.判断子序列
    ///
    /// [原题链接](https://leetcode-cn.com/problems/is-subsequence/)
    ///
    /// 2021-07-15 23:01:52
    ///
    /// 给定字符串 s 和 t ，判断 s 是否为 t 的子序列。
    ///
    /// 字符串的一个子序列是原始字符串删除一些（也可以不删除）字符而不改变剩余字符相对位置形成的新字符串。（例如，"ace"是"abcde"的一个子序列，而"aec"不是）。
    ///
    /// 进阶：
    ///
    /// 如果有大量输入的 S，称作 S1, S2, ... , Sk 其中 k >= 10亿，你需要依次检查它们是否为 T 的子序列。在这种情况下，你会怎样改变代码？
    ///
    /// 致谢：
    ///
    /// 特别感谢 @pbrother 添加此问题并且创建所有测试用例。
    ///
    /// + 示例 1：
    ///     - 输入：s = "abc", t = "ahbgdc"
    ///     - 输出：true
    /// + 示例 2：
    ///     - 输入：s = "axc", t = "ahbgdc"
    ///     - 输出：false
    /// + 提示：
    ///     - `0 <= s.length <= 100`
    ///     - `0 <= t.length <= 10^4`
    ///     - 两个字符串都只由小写字符组成。
    ///
    /// Related Topics 双指针 字符串 动态规划
    ///
    /// 👍 472 👎 0
    ///
    /// # 方法1 双指针
    /// 实现见源码
    /// # 方法2 动态规划
    /// [解题思路](https://leetcode-cn.com/problems/is-subsequence/solution/pan-duan-zi-xu-lie-by-leetcode-solution/)
    pub fn is_subsequence(s: String, t: String) -> bool {
        if s.len() == 0 {
            return true;
        }
        if s.len() > t.len() {
            return false;
        }
        let s = s.into_bytes();
        let t = t.into_bytes();
        let mut s_idx = 0usize;
        for idx in 0..t.len() {
            if t[idx] == s[s_idx] {
                s_idx += 1usize;
            }
            if s_idx == s.len() {
                return true;
            }
        }
        s_idx == s.len()
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0392() {
        let (s, t) = ("axc".to_string(), "ahbgdc".to_string());
        let ans = Solution::is_subsequence(s, t);
        assert_eq!(ans, false);
    }
}
