use crate::Solution;
use crate::structure::TreeNode;
use std::rc::Rc;
use std::cell::RefCell;

impl Solution {
    /// [404.左叶子之和](https://leetcode-cn.com/problems/sum-of-left-leaves/)
    ///
    /// 2022-02-09 17:40:54
    ///
    /// 计算给定二叉树的所有左叶子之和。
    ///
    /// **示例：**
    ///
    /// ```txt
    ///     3
    ///    / \
    ///   9  20
    ///     /  \
    ///    15   7
    /// ```
    /// 在这个二叉树中，有两个左叶子，分别是 9 和 15，所以返回 24
    ///
    /// + Related Topics
    ///     * 树
    ///     * 深度优先搜索
    ///     * 广度优先搜索
    ///     * 二叉树
    /// * 👍 392
    /// * 👎 0
    pub fn sum_of_left_leaves(root: Option<Rc<RefCell<TreeNode>>>) -> i32 {
        let is_leaf_node = |node: &Option<Rc<RefCell<TreeNode>>>| -> bool { match node.as_ref().unwrap().borrow() { n => n.left.is_none() && n.right.is_none() } };
        let mut ans = 0;
        if let Some(node) = root {
            match node.borrow_mut() {
                mut p => {
                    if p.left.is_some() {
                        ans += match is_leaf_node(&p.left) {
                            true => p.left.as_ref().unwrap().borrow().val,
                            _ => Self::sum_of_left_leaves(p.left.take())
                        }
                    }
                    if p.right.is_some() && !is_leaf_node(&p.right) {
                        ans += Self::sum_of_left_leaves(p.right.take());
                    }
                }
            }
        }
        ans
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;
    use crate::structure::TreeNode;
    use std::rc::Rc;
    use std::cell::RefCell;

    #[test]
    fn test_q0404() {
        let tree = Some(Rc::new(RefCell::new(TreeNode {
            val: 3,
            left: Some(Rc::new(RefCell::new(TreeNode::new(9)))),
            right: Some(Rc::new(RefCell::new(TreeNode {
                val: 21,
                left: Some(Rc::new(RefCell::new(TreeNode::new(15)))),
                right: Some(Rc::new(RefCell::new(TreeNode::new(7)))),
            }))),
        })));
        assert_eq!(Solution::sum_of_left_leaves(tree), 24);
    }
}
