use crate::Solution;


impl Solution {
    //noinspection RsSelfConvention
    /// [405.数字转换为十六进制数](https://leetcode-cn.com/problems/convert-a-number-to-hexadecimal/)
    ///
    /// 2021-11-15 11:21:06
    ///
    /// 给定一个整数，编写一个算法将这个数转换为十六进制数。对于负整数，我们通常使用 [补码运算](https://baike.baidu.com/item/%E8%A1%A5%E7%A0%81/6854613?fr=aladdin) 方法。
    ///
    /// * **注意:**
    ///     1. 十六进制中所有字母\(`a-f`\)都必须是小写。
    ///     2. 十六进制字符串中不能包含多余的前导零。如果要转化的数为0，那么以单个字符`'0'`来表示；对于其他情况，十六进制字符串中的第一个字符将不会是0字符。
    ///     3. 给定的数确保在32位有符号整数范围内。
    ///     4. **不能使用任何由库提供的将数字直接转换或格式化为十六进制的方法。**
    /// * **示例 1：**
    ///     + 输入:  26
    ///     + 输出: "1a"
    /// * **示例 2：**
    ///     + 输入: -1
    ///     + 输出: "ffffffff"
    /// * Related Topics
    ///     + 位运算
    ///     + 数学
    /// * 👍 210
    /// * 👎 0
    pub fn to_hex(num: i32) -> String {
        /*const LOOKUP: [u8; 16] = [b'0', b'1', b'2', b'3', b'4', b'5', b'6', b'7', b'8', b'9', b'a', b'b', b'c', b'd', b'e', b'f'];
        let mut num = num as usize & 0xffffffff;
        let mut hex = Vec::with_capacity(8);
        while num != 0 {
            hex.push(LOOKUP[num & 0xf]);
            num >>= 4;
        }
        hex.reverse();
        if hex.is_empty() {
            hex.push(b'0');
        }
        String::from_utf8(hex).unwrap()*/
        format!("{:x}", num)
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0405() {
        assert_eq!(Solution::to_hex(-1), "ffffffff".to_string());
    }
}
