use crate::Solution;


impl Solution {
    /// [407.接雨水 II](https://leetcode-cn.com/problems/trapping-rain-water-ii/)
    ///
    /// 2021-11-03 21:20:44
    ///
    /// 给你一个 `m x n` 的矩阵，其中的值均为非负整数，代表二维高度图每个单元的高度，请计算图中形状最多能接多少体积的雨水。
    ///
    /// **示例 1:**
    ///
    /// ![](https://assets.leetcode.com/uploads/2021/04/08/trap1-3d.jpg)
    ///
    /// **输入:** heightMap = \[\[1,4,3,1,3,2\],\[3,2,1,3,2,4\],\[2,3,3,2,3,1\]\]
    ///
    /// **输出:** 4
    ///
    /// **解释:** 下雨后，雨水将会被上图蓝色的方块中。总的接雨水量为1+2+1=4。
    ///
    /// **示例 2:**
    ///
    /// ![](https://assets.leetcode.com/uploads/2021/04/08/trap2-3d.jpg)
    ///
    /// **输入:** heightMap = \[\[3,3,3,3,3\],\[3,2,2,2,3\],\[3,2,1,2,3\],\[3,2,2,2,3\],\[3,3,3,3,3\]\]
    ///
    /// **输出:** 10
    ///
    /// **提示:**
    ///
    /// * `m == heightMap.length`
    /// * `n == heightMap[i].length`
    /// * `1 <= m, n <= 200`
    /// * `0 <= heightMap[i][j] <= 2 * 104`
    ///
    /// Related Topics
    ///
    /// + 广度优先搜索
    /// + 数组
    /// + 矩阵
    /// + 堆（优先队列）
    ///
    /// * 👍 501
    /// * 👎 0
    pub fn trap_rain_water(height_map: Vec<Vec<i32>>) -> i32 {
        if height_map.len() <= 2 || height_map[0].len() <= 2 {
            return 0;
        }

        #[derive(PartialEq, Eq)]
        struct Item(i32, usize);
        impl PartialOrd for Item {
            fn partial_cmp(&self, o: &Self) -> Option<std::cmp::Ordering> {
                o.0.partial_cmp(&self.0)
            }
        }
        impl Ord for Item {
            fn cmp(&self, o: &Self) -> std::cmp::Ordering {
                o.0.cmp(&self.0)
            }
        }

        let m = height_map.len();
        let n = height_map[0].len();
        let mut q = std::collections::BinaryHeap::<Item>::new();
        let mut v = vec![vec![false; n]; m];
        for i in 0..m {
            for j in 0..n {
                if i == 0 || i == m - 1 || j == 0 || j == n - 1 {
                    q.push(Item(height_map[i][j], i * n + j));
                    v[i][j] = true;
                }
            }
        }
        let mut ret = 0;
        let dirs: [i32; 5] = [-1, 0, 1, 0, -1];
        while !q.is_empty() {
            let c = q.pop().unwrap();
            for k in 0..4 {
                let nx = ((c.1 / n) as i32 + dirs[k]) as usize;
                let ny = ((c.1 % n) as i32 + dirs[k + 1]) as usize;
                if (nx < m) && (ny < n) && (!v[nx][ny]) {
                    if c.0 > height_map[nx][ny] {
                        ret += c.0 - height_map[nx][ny];
                    }
                    v[nx][ny] = true;
                    q.push(Item(c.0.max(height_map[nx][ny]), nx * n + ny));
                }
            }
        }
        ret
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0407() {
        let height_map = vec![vec![1, 4, 3, 1, 3, 2], vec![3, 2, 1, 3, 2, 4], vec![2, 3, 3, 2, 3, 1]];
        let water = Solution::trap_rain_water(height_map);
        assert_eq!(water, 4);
    }
}
