use crate::Solution;

impl Solution {
    /// [415.字符串相加](https://leetcode-cn.com/problems/add-strings/)
    ///
    /// 2022-02-21 10:47:24
    ///
    /// 给定两个字符串形式的非负整数 `num1` 和`num2` ，计算它们的和并同样以字符串形式返回。
    ///
    /// 你不能使用任何內建的用于处理大整数的库（比如 `BigInteger`）， 也不能直接将输入的字符串转换为整数形式。
    ///
    /// + **示例 1：**
    ///     + **输入：** num1 = "11", num2 = "123"
    ///     + **输出：** "134"
    /// + **示例 2：**
    ///     + **输入：** num1 = "456", num2 = "77"
    ///     + **输出：** "533"
    /// + **示例 3：**
    ///     + **输入：** num1 = "0", num2 = "0"
    ///     + **输出：** "0"
    /// + **提示：**
    ///     * `1 <= num1.length, num2.length <= 104`
    ///     * `num1` 和`num2` 都只包含数字 `0-9`
    ///     * `num1` 和`num2` 都不包含任何前导零
    /// + Related Topics
    ///     * 数学
    ///     * 字符串
    ///     * 模拟
    /// * 👍 507
    /// * 👎 0
    pub fn add_strings(mut num1: String, mut num2: String) -> String {
        let mut res = String::new();
        let mut carry = 0u8;
        loop {
            if num1.is_empty() && num2.is_empty() && carry == 0 { break; }
            if let Some(n1) = num1.pop() { carry += n1 as u8 - b'0'; }
            if let Some(n2) = num2.pop() { carry += n2 as u8 - b'0'; }
            res.insert(0, ((carry % 10) + b'0') as char);
            carry /= 10;
        }
        res
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0415() {
        assert_eq!(Solution::add_strings("11".to_string(), "123".to_string()), "134".to_string());
    }
}
