use crate::Solution;

impl Solution {
    /// [424.替换后的最长重复字符](https://leetcode-cn.com/problems/longest-repeating-character-replacement/)
    ///
    /// 2022-02-21 10:52:05
    ///
    /// 给你一个字符串 `s` 和一个整数 `k` 。你可以选择字符串中的任一字符，并将其更改为任何其他大写英文字符。该操作最多可执行 `k` 次。
    ///
    /// 在执行上述操作后，返回包含相同字母的最长子字符串的长度。
    ///
    /// + **示例 1：**
    ///     + **输入：** s = "ABAB", k = 2
    ///     + **输出：** 4
    ///     + **解释：** 用两个'A'替换为两个'B',反之亦然。
    /// + **示例 2：**
    ///     + **输入：** s = "AABABBA", k = 1
    ///     + **输出：** 4
    ///     + **解释：**
    ///         - 将中间的一个'A'替换为'B',字符串变为 "AABBBBA"。
    ///         - 子串 "BBBB" 有最长重复字母, 答案为 4。
    /// + **提示：**
    ///     * `1 <= s.length <= 105`
    ///     * `s` 仅由大写英文字母组成
    ///     * `0 <= k <= s.length`
    /// + Related Topics
    ///     * 哈希表
    ///     * 字符串
    ///     * 滑动窗口
    /// * 👍 553
    /// * 👎 0
    pub fn character_replacement(s: String, k: i32) -> i32 {
        let mut num = vec![0; 26];
        let s = s.into_bytes();
        let n = s.len();
        let (mut max_n, mut left, mut right, k) = (0usize, 0usize, 0usize, k as usize);
        while right < n {
            num[(s[right] - b'A') as usize] += 1;
            max_n = max_n.max(num[(s[right] - b'A') as usize]);
            if right - left + 1 - max_n > k {
                num[(s[left] - b'A') as usize] -= 1;
                left += 1;
            }
            right += 1;
        }
        (right - left) as i32
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0424() {
        assert_eq!(Solution::character_replacement("AABABBA".to_string(), 1), 4);
    }
}
