use crate::Solution;

impl Solution {
    /// [435.无重叠区间](https://leetcode-cn.com/problems/non-overlapping-intervals/)
    ///
    /// 2022-02-21 10:56:06
    ///
    /// 给定一个区间的集合 `intervals` ，其中 `intervals[i] = [starti, endi]` 。返回 _需要移除区间的最小数量，使剩余区间互不重叠 _。
    ///
    /// + **示例 1:**
    ///     + **输入:** intervals = \[\[1,2\],\[2,3\],\[3,4\],\[1,3\]\]
    ///     + **输出:** 1
    ///     + **解释:** 移除 \[1,3\] 后，剩下的区间没有重叠。
    /// + **示例 2:**
    ///     + **输入:** intervals = \[ \[1,2\], \[1,2\], \[1,2\] \]
    ///     + **输出:** 2
    ///     + **解释:** 你需要移除两个 \[1,2\] 来使剩下的区间没有重叠。
    /// + **示例 3:**
    ///     + **输入:** intervals = \[ \[1,2\], \[2,3\] \]
    ///     + **输出:** 0
    ///     + **解释:** 你不需要移除任何区间，因为它们已经是无重叠的了。
    /// + **提示:**
    ///     * `1 <= intervals.length <= 105`
    ///     * `intervals[i].length == 2`
    ///     * `-5 * 104 <= starti < endi <= 5 * 104`
    /// + Related Topics
    ///     * 贪心
    ///     * 数组
    ///     * 动态规划
    ///     * 排序
    /// * 👍 605
    /// * 👎 0
    pub fn erase_overlap_intervals(mut intervals: Vec<Vec<i32>>) -> i32 {
        if intervals.len() == 0 {
            return 0;
        }
        intervals.sort_by(|a, b| a[1].cmp(&b[1]));
        let mut last = &intervals[0];
        let mut count = 0;
        for i in 1..intervals.len() {
            let cur = &intervals[i];
            if cur[0] < last[1] {
                count += 1;
            } else {
                last = &intervals[i];
            }
        }
        count
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0435() {
        assert_eq!(Solution::erase_overlap_intervals(vec![vec![0, 2], vec![1, 3], vec![2, 4], vec![3, 5], vec![4, 6]]), 2);
    }
}
