use crate::Solution;

impl Solution {
    /// [448.找到所有数组中消失的数字](https://leetcode-cn.com/problems/find-all-numbers-disappeared-in-an-array/)
    ///
    /// 2022-02-21 11:00:15
    ///
    /// 给你一个含 `n` 个整数的数组 `nums` ，其中 `nums[i]` 在区间 `[1, n]` 内。请你找出所有在 `[1, n]` 范围内但没有出现在 `nums` 中的数字，并以数组的形式返回结果。
    ///
    /// + **示例 1：**
    ///     + **输入：** nums = \[4,3,2,7,8,2,3,1\]
    ///     + **输出：** \[5,6\]
    /// + **示例 2：**
    ///     + **输入：** nums = \[1,1\]
    ///     + **输出：** \[2\]
    /// + **提示：**
    ///     * `n == nums.length`
    ///     * `1 <= n <= 105`
    ///     * `1 <= nums[i] <= n`
    /// + **进阶：**
    ///     你能在不使用额外空间且时间复杂度为  `O(n)`  的情况下解决这个问题吗? 你可以假定返回的数组不算在额外空间内。
    /// + Related Topics
    ///     * 数组
    ///     * 哈希表
    /// * 👍 897
    /// * 👎 0
    ///
    /// 1. 哈希表
    /// 2. 原地修改
    ///     遍历数组，将数组元素中对应的索引位置的元素取反，二次遍历时大于零的元素没有被修改过，即缺少索引对应的元素。实现见源码。
    pub fn find_disappeared_numbers(mut nums: Vec<i32>) -> Vec<i32> {
        let mut ret = Vec::<i32>::new();
        let mut idx = 0usize;
        for i in 0..nums.len() {
            idx = (nums[i].abs() - 1) as usize;
            if nums[idx] > 0 {
                nums[idx] *= -1;
            }
        }
        for i in 0..nums.len() {
            if nums[i] > 0 {
                ret.push(i as i32 + 1);
            }
        }
        ret
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0448() {
        assert_eq!(Solution::find_disappeared_numbers(vec![4, 3, 2, 7, 8, 2, 3, 1]), vec![5, 6]);
    }
}
