use crate::Solution;

impl Solution {
    /// 461.汉明距离
    ///
    /// [原题链接](https://leetcode-cn.com/problems/hamming-distance/)
    ///
    /// 2021-05-31 17:14:30
    ///
    /// 两个整数之间的 汉明距离 指的是这两个数字对应二进制位不同的位置的数目。
    ///
    /// 给你两个整数 x 和 y，计算并返回它们之间的汉明距离。
    ///
    /// + 示例 1：
    ///     - 输入：x = 1, y = 4
    ///     - 输出：2
    ///     - 解释：
    ///         * 1   (0 0 0 1)
    ///         * 4   (0 1 0 0)
    ///         *         ↑   ↑
    ///         * 上面的箭头指出了对应二进制位不同的位置。
    /// + 示例 2：
    ///     - 输入：x = 3, y = 1
    ///     - 输出：1
    /// + 提示：
    ///     - 0 <= x, y <= 231 - 1
    ///
    /// Related Topics 位运算
    ///
    /// 👍 482 👎 0
    /// # 方法1
    /// 内置位计数
    /// ```rust
    /// pub fn hamming_distance(x: i32, y: i32) -> i32 {
    ///     (x ^ y).count_ones() as i32
    /// }
    /// ```
    /// # 方法2
    /// 异或运算求汉明权重，见源码
    pub fn hamming_distance(x: i32, y: i32) -> i32 {
        let mut xo = x ^ y;
        let mut d = 0;
        while xo != 0 {
            d += 1;
            xo &= xo - 1;
        }
        d
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0461() {
        assert_eq!(Solution::hamming_distance(1, 4), 2);
    }
}
