use crate::Solution;

impl Solution {
    /// 477.汉明距离总和
    ///
    /// [原题链接](https://leetcode-cn.com/problems/total-hamming-distance/)
    ///
    /// 2021-05-31 17:03:24
    ///
    /// 两个整数的 汉明距离 指的是这两个数字的二进制数对应位不同的数量。
    ///
    /// 给你一个整数数组 nums，请你计算并返回 nums 中任意两个数之间汉明距离的总和。
    ///
    /// + 示例 1：
    ///     - 输入：`nums = [4,14,2]`
    ///     - 输出：6
    ///     - 解释：在二进制表示中，4 表示为 0100 ，14 表示为 1110 ，2表示为 0010 。（这样表示是为了体现后四位之间关系）
    ///     - 所以答案为：HammingDistance(4, 14) + HammingDistance(4, 2) + HammingDistance(14, 2) = 2 + 2 + 2 = 6
    /// + 示例 2：
    ///     - 输入：`nums = [4,14,4]`
    ///     - 输出：4
    /// + 提示：
    ///     - `1 <= nums.length <= 105`
    ///     - `0 <= nums[i] <= 109`
    ///
    /// Related Topics 位运算
    ///
    /// 👍 218 👎 0
    pub fn total_hamming_distance(nums: Vec<i32>) -> i32 {
        let (mut ans, n) = (0, nums.len() as i32);
        for i in 0..30 {
            let mut c = 0;
            for &v in &nums {
                c += (v >> i) & 1;
            }
            ans += c * (n - c);
        }
        ans
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0477() {
        let nums = vec![4, 14, 2];
        let ans = Solution::total_hamming_distance(nums);
        assert_eq!(ans, 6);
    }
}
