use crate::Solution;

impl Solution {
    /// [500.键盘行](https://leetcode.cn/problems/keyboard-row/)
    ///
    /// 2022-08-19 13:50:31
    ///
    /// 给你一个字符串数组 `words` ，只返回可以使用在 **美式键盘** 同一行的字母打印出来的单词。键盘如下图所示。
    ///
    /// + **美式键盘** 中：
    ///
    ///     * 第一行由字符 `"qwertyuiop"` 组成。
    ///     * 第二行由字符 `"asdfghjkl"` 组成。
    ///     * 第三行由字符 `"zxcvbnm"` 组成。
    ///
    /// ![American keyboard](https://assets.leetcode-cn.com/aliyun-lc-upload/uploads/2018/10/12/keyboard.png)
    ///
    /// + **示例 1：**
    ///     + **输入：** words = \["Hello","Alaska","Dad","Peace"\]
    ///     + **输出：** \["Alaska","Dad"\]
    /// + **示例 2：**
    ///     + **输入：** words = \["omk"\]
    ///     + **输出：** \[\]
    /// + **示例 3：**
    ///     + **输入：** words = \["adsdf","sfd"\]
    ///     + **输出：** \["adsdf","sfd"\]
    /// + **提示：**
    ///     * `1 <= words.length <= 20`
    ///     * `1 <= words[i].length <= 100`
    ///     * `words[i]` 由英文字母（小写和大写字母）组成
    /// + Related Topics
    ///     * 数组
    ///     * 哈希表
    ///     * 字符串
    ///
    /// ```
    /// fn build_lookup() {
    ///     let row1 = "qwertyuiop".to_owned();
    ///     let row2 = "asdfghjkl".to_owned();
    ///     let mut lookup = vec![];
    ///     for c in 'a'..='z' {
    ///         if row1.find(c).is_some() {
    ///             lookup.push(1);
    ///         } else if row2.find(c).is_some() {
    ///             lookup.push(2);
    ///         } else {
    ///             lookup.push(3);
    ///         }
    ///     }
    ///     println!("{:?}", lookup);
    /// }
    /// ```
    pub fn find_words(words: Vec<String>) -> Vec<String> {
        const ROW_LOOKUP: [i32; 26] = [2, 3, 3, 2, 1, 2, 2, 2, 1, 2, 2, 2, 3, 3, 1, 1, 1, 1, 2, 1, 1, 3, 1, 3, 1, 3];
        let mut result = vec![];
        for word in words {
            let bytes = word.as_bytes();
            let mut flag = true;
            let row = ROW_LOOKUP[(bytes[0].to_ascii_lowercase() - b'a') as usize];
            for i in 1..bytes.len() {
                if row != ROW_LOOKUP[(bytes[i].to_ascii_lowercase() - b'a') as usize] {
                    flag = false;
                    break;
                }
            }
            if flag {
                result.push(word);
            }
        }
        result
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0500() {
        assert_eq!(Solution::find_words(vec!["Hello".to_owned(), "Alaska".to_owned(), "Dad".to_owned(), "Peace".to_owned()]), vec!["Alaska".to_owned(), "Dad".to_owned()]);
        assert_eq!(Solution::find_words(vec!["omk".to_owned()]), Vec::<String>::new());
        assert_eq!(Solution::find_words(vec!["adsdf".to_owned(), "sfd".to_owned()]), vec!["adsdf".to_owned(), "sfd".to_owned()]);
    }
}
