use crate::Solution;

impl Solution {
    /// [504.七进制数](https://leetcode.cn/problems/base-7/)
    ///
    /// 2022-08-19 13:38:50
    ///
    /// 给定一个整数 `num`，将其转化为 **7 进制**，并以字符串形式输出。
    ///
    /// + **示例 1:**
    ///     + **输入:** num = 100
    ///     + **输出:** "202"
    /// + **示例 2:**
    ///     + **输入:** num = -7
    ///     + **输出:** "-10"
    /// + **提示：**
    ///     * `-107 <= num <= 107`
    /// + Related Topics
    ///     * 数学
    pub fn convert_to_base7(num: i32) -> String {
        if num == 0 {
            return "0".to_owned();
        }
        let mut v = Vec::<u8>::new();
        let b = num.is_negative();
        let mut num = num.abs();
        while num != 0 {
            v.push((num % 7) as u8 + b'0');
            num /= 7;
        }
        if b {
            v.push(b'-');
        }
        v.reverse();
        String::from_utf8(v).unwrap()
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0504() {
        assert_eq!(Solution::convert_to_base7(100), "202".to_owned());
        assert_eq!(Solution::convert_to_base7(-7), "-10");
        assert_eq!(Solution::convert_to_base7(0), "0");
    }
}
