use crate::Solution;


impl Solution {
    /// [509.斐波那契数](https://leetcode-cn.com/problems/fibonacci-number/)
    ///
    /// 2021-11-12 16:09:26
    ///
    /// [类似题目链接1](https://leetcode-cn.com/problems/fei-bo-na-qi-shu-lie-lcof/)
    /// [类似题目链接2](https://leetcode-cn.com/problems/climbing-stairs/)
    ///
    /// **斐波那契数**，通常用 `F(n)` 表示，形成的序列称为 **斐波那契数列** 。该数列由 `0` 和 `1` 开始，后面的每一项数字都是前面两项数字的和。也就是：
    ///
    /// F\(0\) = 0，F\(1\) = 1
    ///
    /// F\(n\) = F\(n - 1\) + F\(n - 2\)，其中 n > 1
    ///
    /// 给你 `n` ，请计算 `F(n)` 。
    ///
    /// * **示例 1：**
    ///     + **输入：**2
    ///     + **输出：**1
    ///     + **解释：**F\(2\) = F\(1\) + F\(0\) = 1 + 0 = 1
    /// * **示例 2：**
    ///     + **输入：**3
    ///     + **输出：**2
    ///     + **解释：**F\(3\) = F\(2\) + F\(1\) = 1 + 1 = 2
    /// * **示例 3：**
    ///     + **输入：**4
    ///     + **输出：**3
    ///     + **解释：**F\(4\) = F\(3\) + F\(2\) = 2 + 1 = 3
    /// * **提示：**
    ///     * `0 <= n <= 30`
    /// * Related Topics
    ///     + 递归
    ///     + 记忆化搜索
    ///     + 数学
    ///     + 动态规划
    /// * 👍 343
    /// * 👎 0
    ///
    /// # 方法1 动态规划
    /// ```rust
    /// pub fn fib(n: i32) -> i32 {
    ///     (0..n).fold((0u64, 1), |(p1, p2), _| (p2, p1 + p2)).0 as i32
    /// }
    /// ```
    /// # 方法2 通项公式
    /// ```rust
    /// pub fn fib(n: i32) -> i32 {
    ///     let t = 5.0f64.sqrt();
    ///     (((1.0f64 / t) * (((1.0f64 + t) / 2.0f64).powi(n) - ((1.0f64 - t) / 2.0f64).powi(n))) + 1e-10) as i32
    /// }
    /// ```
    /// # 方法3 递归
    /// ```rust
    /// pub fn fib(n: i32) -> i32 {
    ///     if n == 0 {
    ///         0
    ///     }else if n==1 {
    ///         1
    ///     }else if n==2 {
    ///         1
    ///     }else {
    ///         fib(n-1)+fib(n-2)
    ///     }
    /// }
    /// ```
    /// # 方法4 查表
    /// ```rust
    /// pub fn fib(n: i32) -> i32 {
    ///     let lookup = vec![0, 1, 1, 2, 3, 5, 8, 13, 21, 34, 55, 89, 144, 233, 377, 610, 987, 1597, 2584, 4181, 6765, 10946, 17711, 28657, 46368, 75025, 121393, 196418, 317811, 514229, 832040];
    ///     lookup[(n % 31) as usize]
    /// }
    /// ```
    pub fn fib(n: i32) -> i32 {
        let t = 5.0f64.sqrt();
        ((1.0 / t) * (((1.0 + t) / 2.0).powi(n) - ((1.0 - t) / 2.0).powi(n))).round() as i32
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0509() {
        let n = 30;
        let an = Solution::fib(n);
        //println!("{}", an);
        assert_eq!(an, 832040);
    }
}
