use crate::Solution;

impl Solution {
    /// 554.砖墙
    ///
    /// [原题链接](https://leetcode-cn.com/problems/brick-wall/)
    ///
    /// 2021-05-02 20:29:46
    ///
    /// 你的面前有一堵矩形的、由 n 行砖块组成的砖墙。这些砖块高度相同（也就是一个单位高）但是宽度不同。每一行砖块的宽度之和应该相等。
    ///
    /// 你现在要画一条 自顶向下 的、穿过 最少 砖块的垂线。如果你画的线只是从砖块的边缘经过，就不算穿过这块砖。你不能沿着墙的两个垂直边缘之一画线，这样显然是没
    /// 有穿过一块砖的。
    ///
    /// 给你一个二维数组 wall ，该数组包含这堵墙的相关信息。其中，`wall[i]` 是一个代表从左至右每块砖的宽度的数组。你需要找出怎样画才能使这条线 穿过的
    /// 砖块数量最少 ，并且返回 穿过的砖块数量 。
    ///
    /// + 示例 1：
    ///     - ![img](https://assets.leetcode.com/uploads/2021/04/24/cutwall-grid.jpg)
    ///     - 输入：`wall = [[1,2,2,1],[3,1,2],[1,3,2],[2,4],[3,1,2],[1,3,1,1]]`
    ///     - 输出：2
    /// + 示例 2：
    ///     - 输入：`wall = [[1],[1],[1]]`
    ///     - 输出：3
    /// + 提示：
    ///     - `n == wall.length`
    ///     - `1 <= n <= 104`
    ///     - `1 <= wall[i].length <= 104`
    ///     - `1 <= sum(wall[i].length) <= 2 * 104`
    ///     - 对于每一行 `i` ，`sum(wall[i])` 应当是相同的
    ///     - `1 <= wall[i][j] <= 231 - 1`
    ///
    /// Related Topics 哈希表
    ///
    /// 👍 195 👎 0
    pub fn least_bricks(mut wall: Vec<Vec<i32>>) -> i32 {
        /*let mut cnt = std::collections::hash_map::HashMap::<i32, i32>::new();
        wall.iter().for_each(|widths| {
            (1..widths.len()).fold(widths[0], |sum, i|{
                *cnt.entry(sum).or_insert(0) += 1;
                sum + widths[i]
            });
        });
        wall.len() as i32 - cnt.iter().fold(0, |mut max_cnt, (_, &c)| max_cnt.max(c))*/
        /*wall.len() as i32 - wall.iter().fold(std::collections::hash_map::HashMap::<i32, i32>::new(), |mut cnt, widths| {
            (1..widths.len()).fold(widths[0], |sum, i| {
                *cnt.entry(sum).or_insert(0) += 1;
                sum + widths[i]
            });
            cnt
        }).values().max().unwrap_or(&0)*/
        -wall.iter().flat_map(|w| w[..w.len() - 1].iter().scan(0, |s, &b| {
            Some(*s += b).map(|_| *s)
            //Some(*s)
        })).fold(std::collections::hash_map::HashMap::new(), |mut c, t| {
            *c.entry(t).or_insert(0) += 1;
            c
        }).values().max().unwrap_or(&0) + wall.len() as i32
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0554() {
        let wall = vec![vec![1, 2, 2, 1], vec![3, 1, 2], vec![1, 3, 2], vec![2, 4], vec![3, 1, 2], vec![1, 3, 1, 1]];
        let ans = Solution::least_bricks(wall);
        assert_eq!(ans, 2);
    }
}
