use crate::Solution;

impl Solution {
    /// [605.种花问题](https://leetcode-cn.com/problems/can-place-flowers/)
    ///
    /// 2022-02-21 11:16:45
    ///
    /// 假设有一个很长的花坛，一部分地块种植了花，另一部分却没有。可是，花不能种植在相邻的地块上，它们会争夺水源，两者都会死去。
    ///
    /// 给你一个整数数组 `flowerbed` 表示花坛，由若干 `0` 和 `1` 组成，其中 `0` 表示没种植花，`1` 表示种植了花。另有一个数 `n`  ，能否在不打破种植规则的情况下种入 `n`  朵花？能则返回 `true` ，不能则返回 `false`。
    ///
    /// + **示例 1：**
    ///     + **输入：** flowerbed = \[1,0,0,0,1\], n = 1
    ///     + **输出：** true
    /// + **示例 2：**
    ///     + **输入：** flowerbed = \[1,0,0,0,1\], n = 2
    ///     + **输出：** false
    /// + **提示：**
    ///     * `1 <= flowerbed.length <= 2 * 104`
    ///     * `flowerbed[i]` 为 `0` 或 `1`
    ///     * `flowerbed` 中不存在相邻的两朵花
    ///     * `0 <= n <= flowerbed.length`
    /// + Related Topics
    ///     * 贪心
    ///     * 数组
    /// * 👍 429
    /// * 👎 0
    pub fn can_place_flowers(flowerbed: Vec<i32>, n: i32) -> bool {
        let mut count = 0i32;
        let m = flowerbed.len();
        let mut prev = -1i32;
        for i in 0..m {
            if flowerbed[i] == 1 {
                if prev < 0 {
                    count += (i / 2) as i32;
                } else {
                    count += (i as i32 - prev - 2) / 2;
                }
                if count >= n {
                    return true;
                }
                prev = i as i32;
            }
        }
        if prev < 0 {
            count += (m as i32 + 1) / 2;
        } else {
            count += (m as i32 - prev - 1) / 2;
        }
        return count >= n;
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0605() {
        assert_eq!(Solution::can_place_flowers(vec![1, 0, 0, 0, 1], 1), true);
    }
}
