use crate::Solution;
use crate::structure::TreeNode;
use std::rc::Rc;
use std::cell::RefCell;

impl Solution {
    /// 617.合并二叉树
    ///
    /// [原题链接](https://leetcode-cn.com/problems/merge-two-binary-trees/)
    ///
    /// 2021-07-15 17:28:40
    ///
    /// 给定两个二叉树，想象当你将它们中的一个覆盖到另一个上时，两个二叉树的一些节点便会重叠。
    ///
    /// 你需要将他们合并为一个新的二叉树。合并的规则是如果两个节点重叠，那么将他们的值相加作为节点合并后的新值，否则不为 NULL 的节点将直接作为新二叉树的节点。
    ///
    /// + 示例 1:
    ///     - 输入:
    ///         ```txt
    ///         Tree 1                     Tree 2
    ///                  1                         2
    ///                 / \                       / \
    ///                3   2                     1   3
    ///               /                           \   \
    ///              5                             4   7
    ///         ```
    ///     - 输出: 合并后的树:
    ///         ```txt
    ///              3
    ///             / \
    ///            4   5
    ///           / \   \
    ///          5   4   7
    ///         ```
    ///
    /// 注意: 合并必须从两个树的根节点开始。
    ///
    /// Related Topics 树 深度优先搜索 广度优先搜索 二叉树
    ///
    /// 👍 724 👎 0
    pub fn merge_trees(root1: Option<Rc<RefCell<TreeNode>>>, root2: Option<Rc<RefCell<TreeNode>>>) -> Option<Rc<RefCell<TreeNode>>> {
        match (root1, root2) {
            (Some(t1), Some(t2)) => match (t1.borrow_mut(), t2.borrow_mut()) {
                (mut t1, mut t2) => Some(Rc::new(RefCell::new(TreeNode {
                    val: t1.val + t2.val,
                    left: Self::merge_trees(t1.left.take(), t2.left.take()),
                    right: Self::merge_trees(t1.right.take(), t2.right.take()),
                })))
            }
            (None, None) => None,
            (None, some) => some,
            (some, None) => some
        }
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0617() {
        unimplemented!()
    }
}
