use crate::Solution;

impl Solution {
    /// [628.三个数的最大乘积](https://leetcode-cn.com/problems/maximum-product-of-three-numbers/)
    ///
    /// 2022-02-21 11:21:05
    ///
    /// 给你一个整型数组 `nums` ，在数组中找出由三个数组成的最大乘积，并输出这个乘积。
    ///
    /// + **示例 1：**
    ///     + **输入：** nums = \[1,2,3\]
    ///     + **输出：** 6
    /// + **示例 2：**
    ///     + **输入：** nums = \[1,2,3,4\]
    ///     + **输出：** 24
    /// + **示例 3：**
    ///     + **输入：** nums = \[-1,-2,-3\]
    ///     + **输出：** \-6
    /// + **提示：**
    ///     * `3 <= nums.length <= 104`
    ///     * `-1000 <= nums[i] <= 1000`
    /// + Related Topics
    ///     * 数组
    ///     * 数学
    ///     * 排序
    /// * 👍 355
    /// * 👎 0
    pub fn maximum_product(nums: Vec<i32>) -> i32 {
        let (mut min1, mut min2) = (i32::MAX, i32::MAX);
        let (mut max1, mut max2, mut max3) = (i32::MIN, i32::MIN, i32::MIN);
        for x in nums {
            if x < min1 {
                min2 = min1;
                min1 = x;
            } else if x < min2 {
                min2 = x;
            }

            if x > max1 {
                max3 = max2;
                max2 = max1;
                max1 = x;
            } else if x > max2 {
                max3 = max2;
                max2 = x;
            } else if x > max3 {
                max3 = x;
            }
        }
        (min1 * min2 * max1).max(max1 * max2 * max3)
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0628() {
        assert_eq!(Solution::maximum_product(vec![1, 2, 3]), 6);
    }
}
