use crate::Solution;

impl Solution {
    /// 633.平方数之和
    ///
    /// [原题链接](https://leetcode-cn.com/problems/sum-of-square-numbers/)
    ///
    /// 2021-04-28 21:11:57
    ///
    /// 给定一个非负整数 `c` ，你要判断是否存在两个整数 `a` 和 `b`，使得 `a2 + b2 = c` 。
    ///
    /// + 示例 1：
    ///     - 输入：`c = 5`
    ///     - 输出：`true`
    ///     - 解释：`1 * 1 + 2 * 2 = 5`
    /// + 示例 2：
    ///     - 输入：`c = 3`
    ///     - 输出：`false`
    /// + 示例 3：
    ///     - 输入：`c = 4`
    ///     - 输出：`true`
    /// + 示例 4：
    ///     - 输入：`c = 2`
    ///     - 输出：`true`
    /// + 示例 5：
    ///     - 输入：`c = 1`
    ///     - 输出：`true`
    /// + 提示：
    /// `0 <= c <= 231 - 1`
    ///
    /// Related Topics 数学
    ///
    /// 👍 252 👎 0
    pub fn judge_square_sum(mut c: i32) -> bool {
        for base in 2..=((c as f32).sqrt().floor() as i32) {
            if c % base != 0 {
                continue;
            }
            let mut exp = 0;
            while c % base == 0 {
                c /= base;
                exp += 1;
            }
            if base % 4 == 3 && exp % 2 != 0 {
                return false;
            }
        }
        c % 4 != 3
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0633() {
        let ans = Solution::judge_square_sum(12);
        assert_eq!(ans, false);
    }
}
