use crate::Solution;

impl Solution {
    /// [643.子数组最大平均数 I](https://leetcode-cn.com/problems/maximum-average-subarray-i/)
    ///
    /// 2022-02-21 11:24:27
    ///
    /// 给你一个由 `n` 个元素组成的整数数组 `nums` 和一个整数 `k` 。
    ///
    /// 请你找出平均数最大且 **长度为 `k`** 的连续子数组，并输出该最大平均数。
    ///
    /// 任何误差小于 `10-5` 的答案都将被视为正确答案。
    ///
    /// + **示例 1：**
    ///     + **输入：** nums = \[1,12,-5,-6,50,3\], k = 4
    ///     + **输出：** 12.75
    ///     + **解释：** 最大平均数 (12-5-6+50)/4 = 51/4 = 12.75
    /// + **示例 2：**
    ///     + **输入：** nums = \[5\], k = 1
    ///     + **输出：** 5.00000
    /// + **提示：**
    ///     * `n == nums.length`
    ///     * `1 <= k <= n <= 105`
    ///     * `-104 <= nums[i] <= 104`
    /// + Related Topics
    ///     * 数组
    ///     * 滑动窗口
    /// * 👍 223
    /// * 👎 0
    pub fn find_max_average(nums: Vec<i32>, k: i32) -> f64 {
        let k = k as usize;
        let mut sum = 0;
        for i in 0..k {
            sum += nums[i];
        }
        let mut max_sum = sum;
        for i in k..nums.len() {
            sum += nums[i];
            sum -= nums[i - k];
            if max_sum < sum {
                max_sum = sum;
            }
        }
        max_sum as f64 / k as f64
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0643() {
        assert_eq!(Solution::find_max_average(vec![1, 12, -5, -6, 50, 3], 4), 12.75);
    }
}
