use crate::Solution;

struct Employee {
    id: i32,
    importance: i32,
    subordinates: Vec<i32>,
}


impl Solution {
    //noinspection RsSelfConvention
    /// [690.员工的重要性](https://leetcode-cn.com/problems/employee-importance/)
    ///
    /// 2021-05-01 08:43:10
    ///
    /// 给定一个保存员工信息的数据结构，它包含了员工 唯一的 id ，重要度 和 直系下属的 id 。
    ///
    /// 比如，员工 1 是员工 2 的领导，员工 2 是员工 3 的领导。他们相应的重要度为 15 , 10 , 5 。那么员工 1 的数据结构是 `[1, 15,[2]]` ，
    /// 员工 2的 数据结构是 `[2, 10, [3]]` ，员工 3 的数据结构是 `[3, 5, []]` 。注意虽然员工 3 也是员工 1 的一个下属，但是由于并不是直系
    /// 下属，因此没有体现在员工 1 的数据结构中。
    ///
    /// 现在输入一个公司的所有员工信息，以及单个员工 id ，返回这个员工和他所有下属的重要度之和。
    ///
    /// + 示例：
    ///     - 输入：`[[1, 5, [2, 3]], [2, 3, []], [3, 3, []]], 1`
    ///     - 输出：`11`
    ///     - 解释：员工 1 自身的重要度是 5 ，他有两个直系下属 2 和 3 ，而且 2 和 3 的重要度均为 3 。因此员工 1 的总重要度是 `5 + 3 + 3 = 11` 。
    /// + 提示：
    ///     - 一个员工最多有一个 直系 领导，但是可以有多个 直系 下属
    ///     - 员工数量不超过 2000 。
    ///
    /// Related Topics 深度优先搜索 广度优先搜索 哈希表
    ///
    /// 👍 146 👎 0
    fn get_importance(employees: Vec<Employee>, id: i32) -> i32 {
        let mut map = std::collections::HashMap::<i32, Employee>::new();
        for e in employees {
            map.insert(e.id, e);
        }
        fn dfs(id: i32, map: &std::collections::HashMap::<i32, Employee>) -> i32 {
            let e = map.get(&id).unwrap();
            let mut t = e.importance;
            for s in &e.subordinates {
                t += dfs(*s, map);
            }
            t
        }
        dfs(id, &map)
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;
    use crate::implements::q0690::Employee;

    #[test]
    fn test_q0690() {
        assert_eq!(11, Solution::get_importance(vec![Employee { id: 1, importance: 5, subordinates: vec![2, 3] },
                                                     Employee { id: 2, importance: 3, subordinates: vec![] },
                                                     Employee { id: 3, importance: 3, subordinates: vec![] }], 1));
    }
}