use crate::Solution;


impl Solution {
    /// [695.岛屿的最大面积](https://leetcode-cn.com/problems/max-area-of-island/)
    ///
    /// 2021-11-17 13:12:58
    ///
    /// 给你一个大小为 `m x n` 的二进制矩阵 `grid` 。
    ///
    /// **岛屿** 是由一些相邻的 `1` \(代表土地\) 构成的组合，这里的「相邻」要求两个 `1` 必须在 **水平或者竖直的四个方向上** 相邻。你可以假设 `grid` 的四个边缘都被 `0`（代表水）包围着。
    ///
    /// 岛屿的面积是岛上值为 `1` 的单元格的数目。
    ///
    /// 计算并返回 `grid` 中最大的岛屿面积。如果没有岛屿，则返回面积为 `0` 。
    ///
    /// * **示例 1：**
    ///     + ![](https://assets.leetcode.com/uploads/2021/05/01/maxarea1-grid.jpg)
    ///     + **输入：** grid = \[\[0,0,1,0,0,0,0,1,0,0,0,0,0\],\[0,0,0,0,0,0,0,1,1,1,0,0,0\],\[0,1,1,0,1,0,0,0,0,0,0,0,0\],\[0,1,0,0,1,1,0,0,1,0,1,0,0\],\[0,1,0,0,1,1,0,0,1,1,1,0,0\],\[0,0,0,0,0,0,0,0,0,0,1,0,0\],\[0,0,0,0,0,0,0,1,1,1,0,0,0\],\[0,0,0,0,0,0,0,1,1,0,0,0,0\]\]
    ///     + **输出：** 6
    ///     + **解释：** 答案不应该是 `11` ，因为岛屿只能包含水平或垂直这四个方向上的 `1` 。
    /// * **示例 2：**
    ///     + **输入：** grid = \[\[0,0,0,0,0,0,0,0\]\]
    ///     + **输出：** 0
    /// * **提示：**
    ///     * `m == grid.length`
    ///     * `n == grid[i].length`
    ///     * `1 <= m, n <= 50`
    ///     * `grid[i][j]` 为 `0` 或 `1`
    /// * Related Topics
    ///     + 深度优先搜索
    ///     + 广度优先搜索
    ///     + 并查集
    ///     + 数组
    ///     + 矩阵
    /// * 👍 595
    /// * 👎 0
    pub fn max_area_of_island(mut grid: Vec<Vec<i32>>) -> i32 {
        fn dfs(grid: &mut Vec<Vec<i32>>, i: usize, j: usize) -> i32 {
            if grid[i][j] == 0 {
                return 0;
            }
            grid[i][j] = 0;
            let mut ans = 1;
            if i > 0 {
                ans += dfs(grid, i - 1, j);
            }
            if i < grid.len() - 1 {
                ans += dfs(grid, i + 1, j);
            }
            if j > 0 {
                ans += dfs(grid, i, j - 1);
            }
            if j < grid[0].len() - 1 {
                ans += dfs(grid, i, j + 1);
            }
            ans
        }
        let mut ans = 0;
        for i in 0..grid.len() {
            for j in 0..grid[i].len() {
                ans = ans.max(dfs(&mut grid, i, j));
            }
        }
        ans
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0695() {
        let grid = vec![
            vec![0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0],
            vec![0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0],
            vec![0, 1, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0],
            vec![0, 1, 0, 0, 1, 1, 0, 0, 1, 0, 1, 0, 0],
            vec![0, 1, 0, 0, 1, 1, 0, 0, 1, 1, 1, 0, 0],
            vec![0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0],
            vec![0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0],
            vec![0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0],
        ];
        assert_eq!(Solution::max_area_of_island(grid), 6);
    }
}
