use crate::Solution;


impl Solution {
    /// 704.二分查找
    ///
    /// [原题链接](https://leetcode-cn.com/problems/binary-search/)
    ///
    /// 2021-07-19 14:15:29
    ///
    /// 给定一个 `n` 个元素有序的（升序）整型数组 `nums` 和一个目标值 `target` ，写一个函数搜索 `nums` 中的 `target`，如果目标值存在返回下标，否则返回 `-1`。
    ///
    /// + 示例 1:
    ///     - 输入: `nums = [-1,0,3,5,9,12], target = 9`
    ///     - 输出: `4`
    ///     - 解释: `9` 出现在 `nums` 中并且下标为 `4`
    /// + 示例 2:
    ///     - 输入: `nums = [-1,0,3,5,9,12], target = 2`
    ///     - 输出: `-1`
    ///     - 解释: `2` 不存在 `nums` 中因此返回 `-1`
    /// + 提示：
    ///     - 你可以假设 `nums` 中的所有元素是不重复的。
    ///     - `n` 将在 `[1, 10000]`之间。
    ///     - `nums` 的每个元素都将在 `[-9999, 9999]`之间。
    ///
    /// Related Topics 数组 二分查找
    ///
    /// 👍 276 👎 0
    pub fn search1(nums: Vec<i32>, target: i32) -> i32 {
        /*match nums.binary_search(&target) {
            Ok(n) => n as i32,
            _ => -1
        }*/
        let mut l: i32 = 0;
        let mut r: i32 = nums.len() as i32 - 1;
        while l <= r {
            let mut m = (l + (r - l) / 2);
            if nums[m as usize] == target {
                return m;
            } else if target <= nums[m as usize] {
                r = m - 1;
            } else {
                l = m + 1;
            }
        }
        if (l as usize) < nums.len() && nums[l as usize] == target {
            l
        } else {
            -1
        }
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0704() {
        let nums = vec![-1, 0, 3, 5, 9, 12];
        let ans = Solution::search1(nums, 9);
        assert_eq!(ans, 4);
    }
}
