use crate::Solution;

impl Solution {
    /// 740.删除并获得点数
    ///
    /// [原题链接](https://leetcode-cn.com/problems/delete-and-earn/)
    ///
    /// 2021-05-05 09:26:17
    ///
    /// 给你一个整数数组 nums ，你可以对它进行一些操作。
    ///
    /// 每次操作中，选择任意一个 `nums[i]` ，删除它并获得 `nums[i]` 的点数。之后，你必须删除每个等于 `nums[i] - 1` 或 `nums[i] + 1` 的元素。
    ///
    /// 开始你拥有 0 个点数。返回你能通过这些操作获得的最大点数。
    ///
    /// + 示例 1：
    ///     - 输入：`nums = [3,4,2]`
    ///     - 输出：6
    ///     - 解释：
    ///         * 删除 4 获得 4 个点数，因此 3 也被删除。
    ///         * 之后，删除 2 获得 2 个点数。总共获得 6 个点数。
    /// + 示例 2：
    ///     - 输入：`nums = [2,2,3,3,3,4]`
    ///     - 输出：9
    ///     - 解释：
    ///         * 删除 3 获得 3 个点数，接着要删除两个 2 和 4 。
    ///         * 之后，再次删除 3 获得 3 个点数，再次删除 3 获得 3 个点数。
    ///         * 总共获得 9 个点数。
    /// + 提示：
    ///     - `1 <= nums.length <= 2 * 104`
    ///     - `1 <= nums[i] <= 104`
    ///
    /// Related Topics 动态规划
    ///
    /// 👍 259 👎 0
    pub fn delete_and_earn(mut nums: Vec<i32>) -> i32 {
        /*nums.sort();
        let rob = |nums: &Vec<i32>| -> i32 {
            if nums.len() == 1 {
                nums[0]
            } else {
                nums[2..].iter().fold((nums[0], nums[0].max(nums[1])), |(f, s), &x| (s, s.max(f + x))).1
            }
        };
        let mut ans = 0;
        let mut sum = vec![nums[0]];
        for i in 1..nums.len() {
            let val = nums[i];
            if val == nums[i - 1] {
                *sum.last_mut().unwrap() += val;
            } else if val == nums[i - 1] + 1 {
                sum.push(val);
            } else {
                ans += rob(&sum);
                sum.clear();
                sum.push(val);
            }
        }
        ans += rob(&sum);
        ans*/
        /*nums.sort_unstable();
        let rob = |a: &Vec<i32>| -> i32 { (a.len() == 1).then(|| a[0]).unwrap_or(a[2..].iter().fold((a[0], a[0].max(a[1])), |(f, s), &x| (s, s.max(f + x))).1) };
        let mut sum = vec![nums[0]];
        (1..nums.len()).fold(0, |mut a, i| {
            (nums[i] == nums[i - 1]).then(|| *sum.last_mut().unwrap() += nums[i]).or((nums[i] == nums[i - 1] + 1).then(|| sum.push(nums[i]))).unwrap_or_else(|| {
                a += rob(&sum);
                sum = vec![nums[i]];
            });
            a
        }) + rob(&sum)*/
        /*let mut sum = vec![0; *nums.iter().max().unwrap() as usize + 1];
        for val in nums {
            sum[val as usize] += val;
        }
        let (mut first, mut second) = (sum[0], sum[0].max(sum[1]));
        for i in 2..sum.len() {
            let t = second;
            second = second.max(first + sum[i]);
            first = t;
        }
        second*/
        /*let mut sum = vec![0; *nums.iter().max().unwrap() as usize + 1];
        nums.iter().for_each(|&val| sum[val as usize] += val);
        sum.iter().fold((0, 0), |(f, s), x| (s, s.max(f + x))).1*/
        nums.iter().fold(vec![0; *nums.iter().max().unwrap() as usize + 1], |mut s, &v| {
            s[v as usize] += v;
            s
        }).into_iter().fold((0, 0), |(f, s), x| (s, s.max(f + x))).1
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0740() {
        let nums = vec![2, 2, 3, 3, 3, 4];
        let ans = Solution::delete_and_earn(nums);
        assert_eq!(ans, 9);
    }
}
