use crate::Solution;

impl Solution {
    /// [768.最多能完成排序的块 II](https://leetcode.cn/problems/max-chunks-to-make-sorted-ii/)
    ///
    /// 2022-08-17 16:39:36
    ///
    /// _这个问题和“最多能完成排序的块”相似，但给定数组中的元素可以重复，输入数组最大长度为`2000`，其中的元素最大为`10**8`。_
    ///
    /// `arr`是一个可能包含**重复元素**的整数数组，我们将这个数组分割成几个“块”，并将这些块分别进行排序。之后再连接起来，使得连接的结果和按升序排序后的原数组相同。
    ///
    /// 我们最多能将数组分成多少块？
    ///
    /// + **示例 1:**
    ///     + **输入:** arr = \[5,4,3,2,1\]
    ///     + **输出:** 1
    ///     + **解释:**
    ///         + 将数组分成2块或者更多块，都无法得到所需的结果。
    ///         + 例如，分成 \[5, 4\], \[3, 2, 1\] 的结果是 \[4, 5, 1, 2, 3\]，这不是有序的数组。
    /// + **示例 2:**
    ///     + **输入:** arr = \[2,1,3,4,4\]
    ///     + **输出:** 4
    ///     + **解释:**
    ///         + 我们可以把它分成两块，例如 \[2, 1\], \[3, 4, 4\]。
    ///         + 然而，分成 \[2, 1\], \[3\], \[4\], \[4\] 可以得到最多的块数。
    /// + **注意:**
    ///     * `arr`的长度在`[1, 2000]`之间。
    ///     * `arr[i]`的大小在`[0, 10**8]`之间。
    /// + Related Topics
    ///     * 栈
    ///     * 贪心
    ///     * 数组
    ///     * 排序
    ///     * 单调栈
    pub fn max_chunks_to_sorted(arr: Vec<i32>) -> i32 {
        let (mut max_vec, mut min_vec) = (vec![0; arr.len()], vec![0; arr.len()]);
        let (mut max, mut min, mut ret) = (i32::MIN, i32::MAX, 1);
        for i in 0..arr.len() {
            let j = arr.len() - i - 1;
            max = max.max(arr[i]);
            min = min.min(arr[j]);
            max_vec[i] = max;
            min_vec[j] = min;
        }
        for i in 1..arr.len() {
            if max_vec[i - 1] <= min_vec[i] {
                ret += 1;
            }
        }
        ret
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0768() {
        assert_eq!(Solution::max_chunks_to_sorted(vec![5, 4, 3, 2, 1]), 1);
        assert_eq!(Solution::max_chunks_to_sorted(vec![2, 1, 3, 4, 4]), 4);
        assert_eq!(Solution::max_chunks_to_sorted(vec![5, 4, 3, 2, 1, 2, 3, 4, 5, 6, 7, 8, 9, 0, 10, 11]), 3);
        assert_eq!(Solution::max_chunks_to_sorted(vec![0, 0, 1, 1, 1]), 5);
        assert_eq!(Solution::max_chunks_to_sorted(vec![1, 0, 1, 3, 2]), 3);
    }
}
