use crate::Solution;
use std::rc::Rc;
use std::cell::RefCell;
use crate::structure::TreeNode;

impl Solution {
    /// 783.二叉搜索树节点最小距离
    ///
    /// [原题链接](https://leetcode-cn.com/problems/minimum-distance-between-bst-nodes/)
    /// [原题链接](https://leetcode-cn.com/problems/minimum-absolute-difference-in-bs)
    ///
    /// 2021-04-13 07:31:17
    ///
    /// 给你一个二叉搜索树的根节点 root ，返回 树中任意两不同节点值之间的最小差值 。
    ///
    /// + 示例 1：
    ///     - 输入：`root = [4,2,6,1,3]`
    ///     - 输出：1
    /// + 示例 2：
    ///     - 输入：`root = [1,0,48,null,null,12,49]`
    ///     - 输出：1
    /// + 提示：
    ///     - 树中节点数目在范围 `[2, 100]` 内
    ///     - `0 <= Node.val <= 105`
    ///
    /// Related Topics 树 深度优先搜索 递归
    ///
    /// 👍 120 👎 0
    pub fn min_diff_in_bst(root: Option<Rc<RefCell<TreeNode>>>) -> i32 {
        fn dfs(root: &Option<Rc<RefCell<TreeNode>>>, pre: &mut i32, ans: &mut i32) {
            if let Some(r) = root {
                dfs(&r.borrow().left, pre, ans);
                if *pre != -1 {
                    *ans = (*ans).min(r.borrow().val - *pre);
                }
                *pre = r.borrow().val;
                dfs(&r.borrow().right, pre, ans);
            }
        }
        let (mut ans, mut pre) = (i32::MAX, -1);
        dfs(&root, &mut pre, &mut ans);
        ans
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0783() {
        todo!()
    }
}
