use crate::Solution;

impl Solution {
    /// [839.相似字符串组](https://leetcode-cn.com/problems/similar-string-groups/)
    ///
    /// 2022-02-21 17:29:36
    ///
    /// 如果交换字符串 `X` 中的两个不同位置的字母，使得它和字符串 `Y` 相等，那么称 `X` 和 `Y` 两个字符串相似。如果这两个字符串本身是相等的，那它们也是相似的。
    ///
    /// 例如，`"tars"` 和 `"rats"` 是相似的 (交换 `0` 与 `2` 的位置)； `"rats"` 和 `"arts"` 也是相似的，但是 `"star"` 不与 `"tars"`，`"rats"`，或 `"arts"` 相似。
    ///
    /// 总之，它们通过相似性形成了两个关联组：`{"tars", "rats", "arts"}` 和 `{"star"}`。注意，`"tars"` 和 `"arts"` 是在同一组中，即使它们并不相似。形式上，对每个组而言，要确定一个单词在组中，只需要这个词和该组中至少一个单词相似。
    ///
    /// 给你一个字符串列表 `strs`。列表中的每个字符串都是 `strs` 中其它所有字符串的一个字母异位词。请问 `strs` 中有多少个相似字符串组？
    ///
    /// + **示例 1：**
    ///     + **输入：** strs = \["tars","rats","arts","star"\]
    ///     + **输出：** 2
    /// + **示例 2：**
    ///     + **输入：** strs = \["omv","ovm"\]
    ///     + **输出：** 1
    /// + **提示：**
    ///     * `1 <= strs.length <= 300`
    ///     * `1 <= strs[i].length <= 300`
    ///     * `strs[i]` 只包含小写字母。
    ///     * `strs` 中的所有单词都具有相同的长度，且是彼此的字母异位词。
    /// + Related Topics
    ///     * 深度优先搜索
    ///     * 广度优先搜索
    ///     * 并查集
    ///     * 字符串
    /// * 👍 139
    /// * 👎 0
    pub fn num_similar_groups(strs: Vec<String>) -> i32 {
        fn find(parent: &mut Vec<usize>, x: usize) -> usize {
            if parent[x] == x {
                x
            } else {
                parent[x] = find(parent, parent[x]);
                parent[x]
            }
        }
        fn check(a: &Vec<u8>, b: &Vec<u8>, len: usize) -> bool {
            let mut num = 0;
            for i in 0..len {
                if a[i] != b[i] {
                    num += 1;
                    if num > 2 { return false; }
                }
            }
            true
        }
        let (n, m) = (strs.len(), strs[0].len());
        let mut parent = (0..n).collect::<Vec<usize>>();
        let bytes_arr = strs.into_iter().map(|s| s.into_bytes()).collect::<Vec<Vec<u8>>>();
        for i in 0..n {
            for j in i + 1..n {
                let (fi, fj) = (find(&mut parent, i), find(&mut parent, j));
                if fi == fj { continue; }
                if check(&bytes_arr[i], &bytes_arr[j], m) {
                    parent[fi] = fj;
                }
            }
        }
        parent.into_iter().enumerate().filter(|(i, n)| *i == *n).count() as i32
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0839() {
        assert_eq!(Solution::num_similar_groups(vec!["tars".to_string(), "rats".to_string(), "arts".to_string(), "star".to_string()]), 2);
    }
}
