use crate::Solution;
use crate::structure::TreeNode;
use std::rc::Rc;
use std::cell::RefCell;

impl Solution {
    /// 872.叶子相似的树
    ///
    /// [原题链接](https://leetcode-cn.com/problems/leaf-similar-trees/)
    ///
    /// 2021-05-10 21:52:06
    ///
    /// 请考虑一棵二叉树上所有的叶子，这些叶子的值按从左到右的顺序排列形成一个 叶值序列 。
    ///
    /// ![img](https://s3-lc-upload.s3.amazonaws.com/uploads/2018/07/16/tree.png)
    ///
    /// 举个例子，如上图所示，给定一棵叶值序列为 `(6, 7, 4, 9, 8)` 的树。
    ///
    /// 如果有两棵二叉树的叶值序列是相同，那么我们就认为它们是 叶相似 的。
    ///
    /// 如果给定的两个根结点分别为 `root1` 和 `root2` 的树是叶相似的，则返回 `true`；否则返回 `false` 。
    ///
    /// + 示例 1：
    ///     - ![img2](https://assets.leetcode.com/uploads/2020/09/03/leaf-similar-1.jpg)
    ///     - 输入：`root1 = [3,5,1,6,2,9,8,null,null,7,4], root2 = [3,5,1,6,7,4,2,null,null,null,null,null,null,9,8]`
    ///     - 输出：`true`
    /// + 示例 2：
    ///     - 输入：`root1 = [1], root2 = [1]`
    ///     - 输出：`true`
    /// + 示例 3：
    ///     - 输入：`root1 = [1], root2 = [2]`
    ///     - 输出：`false`
    /// + 示例 4：
    ///     - 输入：`root1 = [1,2], root2 = [2,2]`
    ///     - 输出：`true`
    /// + 示例 5：
    ///     - 输入：`root1 = [1,2,3], root2 = [1,3,2]`
    ///     - 输出：`false`
    /// + 提示：
    ///     - 给定的两棵树可能会有 `1` 到 `200` 个结点。
    ///     - 给定的两棵树上的值介于 `0` 到 `200` 之间。
    ///
    /// Related Topics 树 深度优先搜索
    ///
    /// 👍 143 👎 0
    pub fn leaf_similar(root1: Option<Rc<RefCell<TreeNode>>>, root2: Option<Rc<RefCell<TreeNode>>>) -> bool {
        fn dfs(root: &Option<Rc<RefCell<TreeNode>>>, seq: &mut Vec<i32>) {
            if let Some(node) = root {
                if node.borrow().left.is_none() && node.borrow().right.is_none() {
                    seq.push(node.borrow().val);
                } else {
                    dfs(&node.borrow().left, seq);
                    dfs(&node.borrow().right, seq);
                }
            }
        }
        let mut seq1 = vec![];
        dfs(&root1, &mut seq1);
        let mut seq2 = vec![];
        dfs(&root2, &mut seq2);
        seq1 == seq2
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;
    use crate::structure::TreeNode;
    use std::rc::Rc;
    use std::cell::RefCell;

    #[test]
    fn test_q0872() {
        let root1 = Some(Rc::new(RefCell::new(TreeNode::new(3))));
        let root2 = Some(Rc::new(RefCell::new(TreeNode::new(3))));
        assert_eq!(Solution::leaf_similar(root1, root2), true);
    }
}
