use crate::Solution;

impl Solution {
    /// [888.公平的糖果交换](https://leetcode-cn.com/problems/fair-candy-swap/)
    ///
    /// 2022-02-21 17:30:15
    ///
    /// 爱丽丝和鲍勃拥有不同总数量的糖果。给你两个数组 `aliceSizes` 和 `bobSizes` ，`aliceSizes[i]` 是爱丽丝拥有的第 `i` 盒糖果中的糖果数量，`bobSizes[j]` 是鲍勃拥有的第 `j` 盒糖果中的糖果数量。
    ///
    /// 两人想要互相交换一盒糖果，这样在交换之后，他们就可以拥有相同总数量的糖果。一个人拥有的糖果总数量是他们每盒糖果数量的总和。
    ///
    /// 返回一个整数数组 `answer`，其中 `answer[0]` 是爱丽丝必须交换的糖果盒中的糖果的数目，`answer[1]` 是鲍勃必须交换的糖果盒中的糖果的数目。如果存在多个答案，你可以返回其中 **任何一个** 。题目测试用例保证存在与输入对应的答案。
    ///
    /// + **示例 1：**
    ///     + **输入：** aliceSizes = \[1,1\], bobSizes = \[2,2\]
    ///     + **输出：** \[1,2\]
    /// + **示例 2：**
    ///     + **输入：** aliceSizes = \[1,2\], bobSizes = \[2,3\]
    ///     + **输出：** \[1,2\]
    /// + **示例 3：**
    ///     + **输入：** aliceSizes = \[2\], bobSizes = \[1,3\]
    ///     + **输出：** \[2,3\]
    /// + **示例 4：**
    ///     + **输入：** aliceSizes = \[1,2,5\], bobSizes = \[2,4\]
    ///     + **输出：** \[5,4\]
    /// + **提示：**
    ///     * `1 <= aliceSizes.length, bobSizes.length <= 104`
    ///     * `1 <= aliceSizes[i], bobSizes[j] <= 105`
    ///     * 爱丽丝和鲍勃的糖果总数量不同。
    ///     * 题目数据保证对于给定的输入至少存在一个有效答案。
    /// + Related Topics
    ///     * 数组
    ///     * 哈希表
    ///     * 二分查找
    ///     * 排序
    /// * 👍 189
    /// * 👎 0
    pub fn fair_candy_swap(alice_sizes: Vec<i32>, bob_sizes: Vec<i32>) -> Vec<i32> {
        use std::iter::FromIterator;
        let delta = (alice_sizes.iter().sum::<i32>() - bob_sizes.iter().sum::<i32>()) / 2;
        let set = std::collections::HashSet::<i32>::from_iter(alice_sizes.into_iter());
        let mut ans = vec![];
        for y in bob_sizes {
            let x = y + delta;
            if set.contains(&x) {
                ans = vec![x, y];
                break;
            }
        }
        ans
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0888() {
        assert_eq!(Solution::fair_candy_swap(vec![1, 2], vec![2, 3]), vec![1, 2]);
    }
}
