use crate::Solution;
use crate::structure::TreeNode;
use std::rc::Rc;
use std::cell::RefCell;

impl Solution {
    /// [897.递增顺序搜索树](https://leetcode-cn.com/problems/increasing-order-search-tree/)
    ///
    /// 2021-04-25 09:47:45
    ///
    /// 给你一棵二叉搜索树，请你 按中序遍历 将其重新排列为一棵递增顺序搜索树，使树中最左边的节点成为树的根节点，并且每个节点没有左子节点，只有一个右子节点。
    ///
    /// + 示例 1：
    ///     - ![img](https://assets.leetcode.com/uploads/2020/11/17/ex1.jpg)
    ///     - 输入：`root = [5,3,6,2,4,null,8,1,null,null,null,7,9]`
    ///     - 输出：`[1,null,2,null,3,null,4,null,5,null,6,null,7,null,8,null,9]`
    /// + 示例 2：
    ///     - ![img](https://assets.leetcode.com/uploads/2020/11/17/ex2.jpg)
    ///     - 输入：`root = [5,1,7]`
    ///     - 输出：`[1,null,5,null,7]`
    /// + 提示：
    ///     - 树中节点数的取值范围是 `[1, 100]`
    ///     - `0 <= Node.val <= 1000`
    ///
    /// Related Topics 树 深度优先搜索 递归
    ///
    /// 👍 166 👎 0
    pub fn increasing_bst(root: Option<Rc<RefCell<TreeNode>>>) -> Option<Rc<RefCell<TreeNode>>> {
        fn inorder(root: &Option<Rc<RefCell<TreeNode>>>, ret: &mut Vec<i32>) {
            if let Some(r) = root {
                inorder(&r.borrow().left, ret);
                ret.push(r.borrow().val);
                inorder(&r.borrow().right, ret);
            }
        }
        fn make_tree(res: &Vec<i32>, idx: usize) -> Option<Rc<RefCell<TreeNode>>> {
            if idx >= res.len() { return None; }
            Some(Rc::new(RefCell::new(TreeNode { val: res[idx], left: None, right: make_tree(res, idx + 1) })))
        }
        let mut res = Vec::<i32>::new();
        inorder(&root, &mut res);
        make_tree(&res, 0)
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;
    use crate::structure::TreeNode;
    use std::rc::Rc;
    use std::cell::RefCell;

    #[test]
    fn test_q0897() {
        let root = Some(Rc::new(RefCell::new(TreeNode{
            val:5,
            left:Some(Rc::new(RefCell::new(TreeNode::new(1)))),
            right:Some(Rc::new(RefCell::new(TreeNode::new(7))))
        })));
        let ans = Some(Rc::new(RefCell::new(TreeNode{
            val:1,
            left:None,
            right:Some(Rc::new(RefCell::new(TreeNode{
                val:5,
                left:None,
                right:Some(Rc::new(RefCell::new(TreeNode::new(7))))
            }))),
        })));
        assert_eq!(Solution::increasing_bst(root), ans);
    }
}
