use std::io::Read;
use crate::Solution;

impl Solution {
    /// [899.有序队列](https://leetcode-cn.com/problems/orderly-queue/)
    ///
    /// 2022-08-03 10:32:04
    ///
    /// 给定一个字符串 `s` 和一个整数 `k` 。你可以从 `s` 的前 `k` 个字母中选择一个，并把它加到字符串的末尾。
    ///
    /// 返回 _在应用上述步骤的任意数量的移动后，字典上最小的字符串_。
    ///
    /// + **示例 1：**
    ///     - **输入：** s = "cba", k = 1
    ///     - **输出：** "acb"
    ///     - **解释：**
    ///         - 在第一步中，我们将第一个字符（“c”）移动到最后，获得字符串 “bac”。
    ///         - 在第二步中，我们将第一个字符（“b”）移动到最后，获得最终结果 “acb”。
    /// + **示例 2：**
    ///     - **输入：** s = "baaca", k = 3
    ///     - **输出：** "aaabc"
    ///     - **解释：**
    ///         - 在第一步中，我们将第一个字符（“b”）移动到最后，获得字符串 “aacab”。
    ///         - 在第二步中，我们将第三个字符（“c”）移动到最后，获得最终结果 “aaabc”。
    /// + **提示：**
    ///     * `1 <= k <= S.length <= 1000`
    ///     * `s` 只由小写字母组成。
    /// + Related Topics
    ///     * 数学
    ///     * 字符串
    ///     * 排序
    /// *   👍 100
    /// *   👎 0
    pub fn orderly_queue(s: String, k: i32) -> String {
        match k {
            1 => s.chars().chain(s.chars()).collect::<Vec<_>>().windows(s.len()).min().unwrap().iter().collect(),
            _ => s.chars().collect::<std::collections::BinaryHeap<_>>().into_sorted_vec().iter().collect()
        }
        /*let mut result = s.into_bytes();
        if k == 1 {
            let mut bytes = result.clone();
            for i in 1..result.len() {
                let c = bytes.remove(0);
                bytes.push(c);
                if bytes.lt(&result) {
                    result = bytes.clone();
                }
            }
            String::from_utf8(result).unwrap()
        } else {
            result.sort();
            String::from_utf8(result).unwrap()
        }*/
        //unimplemented!()
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0899() {
        assert_eq!(Solution::orderly_queue("cba".to_owned(), 1), "acb".to_owned());
        assert_eq!(Solution::orderly_queue("baaca".to_owned(), 3), "aaabc".to_owned());
        assert_eq!(Solution::orderly_queue("nhtq".to_owned(),1), "htqn".to_owned());
        assert_eq!(Solution::orderly_queue("gxzv".to_owned(), 4), "gvxz".to_owned());
    }
}
