use crate::Solution;


impl Solution {
    /// 918.环形子数组的最大和
    ///
    /// [原题链接](https://leetcode-cn.com/problems/maximum-sum-circular-subarray/)
    ///
    /// 2021-07-16 07:30:21
    ///
    /// 给定一个由整数数组 `A` 表示的环形数组 `C`，求 `C` 的非空子数组的最大可能和。
    ///
    /// 在此处，环形数组意味着数组的末端将会与开头相连呈环状。（形式上，当 `0 <= i < A.length` 时 `C[i] = A[i]`，且当 i >= 0 时 `C[i+A.length] = C[i]`）
    ///
    /// 此外，子数组最多只能包含固定缓冲区 A 中的每个元素一次。（形式上，对于子数组 `C[i], C[i+1], ..., C[j]`，不存在 `i <= k1`,
    /// `k2 <= j` 其中 `k1 % A.length = k2 % A.length`）
    ///
    /// + 示例 1：
    ///     - 输入：`[1,-2,3,-2]`
    ///     - 输出：3
    ///     - 解释：从子数组 `[3]` 得到最大和 `3`
    /// + 示例 2：
    ///     - 输入：`[5,-3,5]`
    ///     - 输出：`10`
    ///     - 解释：从子数组 `[5,5]` 得到最大和 `5 + 5 = 10`
    /// + 示例 3：
    ///     - 输入：`[3,-1,2,-1]`
    ///     - 输出：`4`
    ///     - 解释：从子数组 `[2,-1,3]` 得到最大和 `2 + (-1) + 3 = 4`
    /// + 示例 4：
    ///     - 输入：`[3,-2,2,-3]`
    ///     - 输出：`3`
    ///     - 解释：从子数组 `[3]` 和 `[3,-2,2]` 都可以得到最大和 `3`
    /// + 示例 5：
    ///     - 输入：`[-2,-3,-1]`
    ///     - 输出：`-1`
    ///     - 解释：从子数组 `[-1]` 得到最大和 `-1`
    /// + 提示：
    ///     - `-30000 <= A[i] <= 30000`
    ///     - `1 <= A.length <= 30000`
    ///
    /// Related Topics 队列 数组 分治 动态规划 单调队列
    ///
    /// 👍 173 👎 0
    pub fn max_subarray_sum_circular(nums: Vec<i32>) -> i32 {
        fn kadane(nums: &Vec<i32>, i: usize, j: usize, sign: i32) -> i32 {
            let mut ans = i32::MIN;
            let mut cur = i32::MIN;
            for k in i..j {
                cur = sign * nums[k] + cur.max(0);
                ans = ans.max(cur);
            }
            if ans == i32::MIN {
                return 0;
            }
            ans
        }
        let sum = nums.iter().sum::<i32>();
        let ans1 = kadane(&nums, 0, nums.len(), 1);
        let ans2 = sum + kadane(&nums, 1, nums.len(), -1);
        let ans3 = sum + kadane(&nums, 0, nums.len() - 1, -1);
        ans1.max(ans2.max(ans3))
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0918() {
        let nums = vec![1,-2,3,-2];
        let ans = Solution::max_subarray_sum_circular(nums);
        assert_eq!(ans, 3);
    }
}
