use crate::Solution;
use crate::structure::TreeNode;
use std::rc::Rc;
use std::cell::RefCell;

impl Solution {
    /// [938.二叉搜索树的范围和](https://leetcode-cn.com/problems/range-sum-of-bst/)
    ///
    /// 2021-04-27 08:29:20
    ///
    /// 给定二叉搜索树的根结点 `root`，返回值位于范围 `[low, high]` 之间的所有结点的值的和。
    ///
    /// + 示例 1：
    ///     - ![img](https://assets.leetcode.com/uploads/2020/11/05/bst1.jpg)
    ///     - 输入：`root = [10,5,15,3,7,null,18], low = 7, high = 15`
    ///     - 输出：32
    /// + 示例 2：
    ///     - ![img](https://assets.leetcode.com/uploads/2020/11/05/bst2.jpg)
    ///     - 输入：`root = [10,5,15,3,7,13,18,1,null,6], low = 6, high = 10`
    ///     - 输出：23
    /// + 提示：
    ///     - 树中节点数目在范围 `[1, 2 * 104]` 内
    ///     - `1 <= Node.val <= 105`
    ///     - `1 <= low <= high <= 105`
    ///     - 所有 `Node.val` 互不相同
    ///
    /// Related Topics 树 深度优先搜索 递归
    ///
    /// 👍 178 👎 0
    pub fn range_sum_bst(root: Option<Rc<RefCell<TreeNode>>>, low: i32, high: i32) -> i32 {
        match root {
            Some(node) => match node.borrow_mut() {
                mut p => match p.val {
                    v if v > high => Self::range_sum_bst(p.left.take(), low, high),
                    v if v < low => Self::range_sum_bst(p.right.take(), low, high),
                    _ => p.val + Self::range_sum_bst(p.left.take(), low, high) + Self::range_sum_bst(p.right.take(), low, high)
                }
            }
            _ => 0
        }
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;
    use crate::structure::TreeNode;
    use std::rc::Rc;
    use std::cell::RefCell;

    #[test]
    fn test_q0938() {
        let root = Some(Rc::new(RefCell::new(TreeNode{
            val:10,
            left:Some(Rc::new(RefCell::new(TreeNode{
                val:5,
                left:Some(Rc::new(RefCell::new(TreeNode::new(3)))),
                right:Some(Rc::new(RefCell::new(TreeNode::new(7))))
            }))),
            right:Some(Rc::new(RefCell::new(TreeNode{
                val:15,
                left:None,
                right:Some(Rc::new(RefCell::new(TreeNode::new(18))))
            })))
        })));
        assert_eq!(Solution::range_sum_bst(root, 7, 15), 32);
    }
}
