use crate::Solution;

impl Solution {
    /// [947.移除最多的同行或同列石头](https://leetcode-cn.com/problems/most-stones-removed-with-same-row-or-column/)
    ///
    /// 2022-02-21 17:39:09
    ///
    /// `n` 块石头放置在二维平面中的一些整数坐标点上。每个坐标点上最多只能有一块石头。
    ///
    /// 如果一块石头的 **同行或者同列** 上有其他石头存在，那么就可以移除这块石头。
    ///
    /// 给你一个长度为 `n` 的数组 `stones` ，其中 `stones[i] = [xi, yi]` 表示第 `i` 块石头的位置，返回 **可以移除的石子** 的最大数量。
    ///
    /// + **示例 1：**
    ///     + **输入：** stones = \[\[0,0\],\[0,1\],\[1,0\],\[1,2\],\[2,1\],\[2,2\]\]
    ///     + **输出：** 5
    ///     + **解释：** 一种移除 5 块石头的方法如下所示：
    ///         1. 移除石头 \[2,2\] ，因为它和 \[2,1\] 同行。
    ///         2. 移除石头 \[2,1\] ，因为它和 \[0,1\] 同列。
    ///         3. 移除石头 \[1,2\] ，因为它和 \[1,0\] 同行。
    ///         4. 移除石头 \[1,0\] ，因为它和 \[0,0\] 同列。
    ///         5. 移除石头 \[0,1\] ，因为它和 \[0,0\] 同行。
    ///
    ///         石头 \[0,0\] 不能移除，因为它没有与另一块石头同行/列。
    /// + **示例 2：**
    ///     + **输入：** stones = \[\[0,0\],\[0,2\],\[1,1\],\[2,0\],\[2,2\]\]
    ///     + **输出：** 3
    ///     + **解释：** 一种移除 3 块石头的方法如下所示：
    ///         1. 移除石头 \[2,2\] ，因为它和 \[2,0\] 同行。
    ///         2. 移除石头 \[2,0\] ，因为它和 \[0,0\] 同列。
    ///         3. 移除石头 \[0,2\] ，因为它和 \[0,0\] 同行。
    ///
    ///         石头 \[0,0\] 和 \[1,1\] 不能移除，因为它们没有与另一块石头同行/列。
    /// + **示例 3：**
    ///     + **输入：** stones = \[\[0,0\]\]
    ///     + **输出：** 0
    ///     + **解释：** \[0,0\] 是平面上唯一一块石头，所以不可以移除它。
    /// + **提示：**
    ///     * `1 <= stones.length <= 1000`
    ///     * `0 <= xi, yi <= 104`
    ///     * 不会有两块石头放在同一个坐标点上
    /// + Related Topics
    ///     * 深度优先搜索
    ///     * 并查集
    ///     * 图
    /// * 👍 256
    /// * 👎 0
    pub fn remove_stones(stones: Vec<Vec<i32>>) -> i32 {
        use std::collections::HashMap;
        let mut parent = HashMap::<usize, usize>::new();
        let mut count = 0usize;
        fn find(parent: &mut HashMap<usize, usize>, count: &mut usize, x: usize) -> usize {
            if !parent.contains_key(&x) {
                parent.insert(x, x);
                *count += 1;
            }
            if x != parent[&x] {
                let v = find(parent, count, parent[&x]);
                parent.insert(x, v);
            }
            parent[&x]
        }

        for stone in &stones {
            let root_x = find(&mut parent, &mut count, !stone[0] as usize);
            let root_y = find(&mut parent, &mut count, stone[1] as usize);
            if root_x == root_y {
                continue;
            }
            parent.insert(root_x, root_y);
            count -= 1;
        }

        (stones.len() - count) as i32
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0947() {
        let stones = vec![vec![0, 0], vec![0, 1], vec![1, 0], vec![1, 2], vec![2, 1], vec![2, 2]];
        let i = Solution::remove_stones(stones);
        //println!("{}", i);
        assert_eq!(i, 5);
    }
}
