use crate::Solution;
use crate::structure::TreeNode;
use std::rc::Rc;
use std::cell::RefCell;

impl Solution {
    /// [965.单值二叉树](https://leetcode-cn.com/problems/univalued-binary-tree/)
    ///
    /// 2022-02-15 11:27:36
    ///
    /// 如果二叉树每个节点都具有相同的值，那么该二叉树就是_单值_二叉树。
    ///
    /// 只有给定的树是单值二叉树时，才返回 `true`；否则返回 `false`。
    ///
    /// + **示例 1：**
    ///     + ![](https://assets.leetcode-cn.com/aliyun-lc-upload/uploads/2018/12/29/screen-shot-2018-12-25-at-50104-pm.png)
    ///     + **输入：**\[1,1,1,1,1,null,1\]
    ///     + **输出：**true
    /// + **示例 2：**
    ///     + ![](https://assets.leetcode-cn.com/aliyun-lc-upload/uploads/2018/12/29/screen-shot-2018-12-25-at-50050-pm.png)
    ///     + **输入：**\[2,2,2,5,2\]
    ///     + **输出：**false
    /// + **提示：**
    ///     1. 给定树的节点数范围是 `[1, 100]`。
    ///     2. 每个节点的值都是整数，范围为 `[0, 99]` 。
    /// + Related Topics
    ///     * 树
    ///     * 深度优先搜索
    ///     * 广度优先搜索
    ///     * 二叉树
    /// * 👍 100
    /// * 👎 0
    pub fn is_unival_tree(root: Option<Rc<RefCell<TreeNode>>>) -> bool {
        match root {
            Some(node) => match node.borrow_mut() {
                mut p => (p.left.is_none() || p.val == p.left.as_ref().unwrap().borrow().val) && (p.right.is_none() || p.val == p.right.as_ref().unwrap().borrow().val) && Self::is_unival_tree(p.left.take()) && Self::is_unival_tree(p.right.take())
            }
            _ => true
        }
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;
    use crate::structure::TreeNode;
    use std::rc::Rc;
    use std::cell::RefCell;

    #[test]
    fn test_q0965() {
        let root = Some(Rc::new(RefCell::new(TreeNode{
            val:1,
            left:Some(Rc::new(RefCell::new(TreeNode{
                val:1,
                left:Some(Rc::new(RefCell::new(TreeNode::new(1)))),
                right:Some(Rc::new(RefCell::new(TreeNode::new(1))))
            }))),
            right:Some(Rc::new(RefCell::new(TreeNode{
                val:1,
                left:Some(Rc::new(RefCell::new(TreeNode::new(1)))),
                right:Some(Rc::new(RefCell::new(TreeNode::new(1))))
            })))
        })));
        assert_eq!(Solution::is_unival_tree(root), true);
    }
}
