use crate::Solution;
use std::process::id;


impl Solution {
    /// 977.有序数组的平方
    ///
    /// [原题链接](https://leetcode-cn.com/problems/squares-of-a-sorted-array/)
    ///
    /// 2021-07-20 21:25:43
    ///
    /// 给你一个按 **非递减顺序** 排序的整数数组 `nums`，返回 **每个数字的平方** 组成的新数组，要求也按 **非递减顺序** 排序。
    ///
    /// + 示例 1：
    ///     - 输入：`nums = [-4,-1,0,3,10]`
    ///     - 输出：`[0,1,9,16,100]`
    ///     - 解释：平方后，数组变为 `[16,1,0,9,100]`
    ///     - 排序后，数组变为 `[0,1,9,16,100]`
    /// + 示例 2：
    ///     - 输入：`nums = [-7,-3,2,3,11]`
    ///     - 输出：`[4,9,9,49,121]`
    /// + 提示：
    ///     - `1 <= nums.length <= 104`
    ///     - `-104 <= nums[i] <= 104`
    ///     - `nums` 已按 非递减顺序 排序
    ///
    /// + 进阶：
    ///     - 请你设计时间复杂度为 `O(n)` 的算法解决本问题
    ///
    /// Related Topics 数组 双指针 排序
    ///
    /// 👍 253 👎 0
    pub fn sorted_squares(nums: Vec<i32>) -> Vec<i32> {
        let mut ans = vec![0; nums.len()];
        let (mut i, mut j, mut pos) = (0usize, nums.len(), nums.len());
        while i < j {
            pos -= 1;
            if nums[i].abs() > nums[j - 1].abs() {
                ans[pos] = nums[i] * nums[i];
                i += 1;
            } else {
                j -= 1;
                ans[pos] = nums[j] * nums[j];
            }
        }
        ans
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0977() {
        let nums = vec![-7, -3, 2, 3, 11];
        let ans = Solution::sorted_squares(nums);
        assert_eq!(ans, vec![4, 9, 9, 49, 121]);
    }
}
