use crate::Solution;

impl Solution {
    /// [986.区间列表的交集](https://leetcode.cn/problems/interval-list-intersections/)
    ///
    /// 2022-08-08 13:57:51
    ///
    /// 给定两个由一些 **闭区间** 组成的列表，`firstList` 和 `secondList` ，其中 `firstList[i] = [starti, endi]` 而 `secondList[j] = [startj, endj]` 。每个区间列表都是成对 **不相交** 的，并且 **已经排序** 。
    ///
    /// 返回这 **两个区间列表的交集** 。
    ///
    /// 形式上，**闭区间** `[a, b]`（其中 `a <= b`）表示实数 `x` 的集合，而 `a <= x <= b` 。
    ///
    /// 两个闭区间的 **交集** 是一组实数，要么为空集，要么为闭区间。例如，`[1, 3]` 和 `[2, 4]` 的交集为 `[2, 3]` 。
    ///
    /// + **示例 1：**
    ///     + ![](https://assets.leetcode.com/uploads/2019/01/30/interval1.png)
    ///     + **输入：** firstList = \[\[0,2\],\[5,10\],\[13,23\],\[24,25\]\], secondList = \[\[1,5\],\[8,12\],\[15,24\],\[25,26\]\]
    ///     + **输出：** \[\[1,2\],\[5,5\],\[8,10\],\[15,23\],\[24,24\],\[25,25\]\]
    /// + **示例 2：**
    ///     + **输入：** firstList = \[\[1,3\],\[5,9\]\], secondList = \[\]
    ///     + **输出：** \[\]
    /// + **示例 3：**
    ///     + **输入：** firstList = \[\], secondList = \[\[4,8\],\[10,12\]\]
    ///     + **输出：** \[\]
    /// + **示例 4：**
    ///     + **输入：** firstList = \[\[1,7\]\], secondList = \[\[3,10\]\]
    ///     + **输出：** \[\[3,7\]\]
    /// + **提示：**
    ///     * `0 <= firstList.length, secondList.length <= 1000`
    ///     * `firstList.length + secondList.length >= 1`
    ///     * `0 <= starti < endi <= 109`
    ///     * `endi < starti+1`
    ///     * `0 <= startj < endj <= 109`
    ///     * `endj < startj+1`
    /// + Related Topics
    ///     * 数组
    ///     * 双指针
    pub fn interval_intersection(first_list: Vec<Vec<i32>>, second_list: Vec<Vec<i32>>) -> Vec<Vec<i32>> {
        let mut ans = vec![];
        let (mut i, mut j) = (0usize, 0usize);
        while i < first_list.len() && j < second_list.len() {
            let l = first_list[i][0].max(second_list[j][0]);
            let h = first_list[i][1].min(second_list[j][1]);
            if l <= h {
                ans.push(vec![l, h]);
            }
            if first_list[i][1] < second_list[j][1] {
                i += 1;
            } else {
                j += 1;
            }
        }
        ans
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0986() {
        assert_eq!(Solution::interval_intersection(vec![vec![0, 2], vec![5, 10], vec![13, 23], vec![24, 25]], vec![vec![1, 5], vec![8, 12], vec![15, 24], vec![25, 26]]), vec![vec![1, 2], vec![5, 5], vec![8, 10], vec![15, 23], vec![24, 24], vec![25, 25]]);
    }
}
