use crate::Solution;
use crate::structure::TreeNode;
use std::rc::Rc;
use std::cell::RefCell;

impl Solution {
    /// [1022.从根到叶的二进制数之和](https://leetcode-cn.com/problems/sum-of-root-to-leaf-binary-numbers/)
    ///
    /// 2022-02-15 11:20:32
    ///
    /// 给出一棵二叉树，其上每个结点的值都是 `0` 或 `1` 。每一条从根到叶的路径都代表一个从最高有效位开始的二进制数。例如，如果路径为 `0 -> 1 -> 1 -> 0 -> 1`，那么它表示二进制数 `01101`，也就是 `13` 。
    ///
    /// 对树上的每一片叶子，我们都要找出从根到该叶子的路径所表示的数字。
    ///
    /// 返回这些数字之和。题目数据保证答案是一个 **32 位** 整数。
    ///
    /// + **示例 1：**
    ///     + ![](https://assets.leetcode.com/uploads/2019/04/04/sum-of-root-to-leaf-binary-numbers.png)
    ///     + **输入：** root = \[1,0,1,0,1,0,1\]
    ///     + **输出：** 22
    ///     + **解释：** (100) + (101) + (110) + (111) = 4 + 5 + 6 + 7 = 22
    /// + **示例 2：**
    ///     + **输入：** root = \[0\]
    ///     + **输出：** 0
    /// + **示例 3：**
    ///     + **输入：** root = \[1\]
    ///     + **输出：** 1
    /// + **示例 4：**
    ///     + **输入：** root = \[1,1\]
    ///     + **输出：** 3
    /// + **提示：**
    ///     * 树中的结点数介于 `1` 和 `1000` 之间。
    ///     * `Node.val` 为 `0` 或 `1` 。
    /// + Related Topics
    ///     * 树
    ///     * 深度优先搜索
    ///     * 二叉树
    /// * 👍 136
    /// * 👎 0
    pub fn sum_root_to_leaf(root: Option<Rc<RefCell<TreeNode>>>) -> i32 {
        fn helper(root: Option<Rc<RefCell<TreeNode>>>, val:i32) -> i32 {
            match root {
                Some(node) => match node.borrow_mut() {
                    mut p=> match p.right.is_none() && p.left.is_none() {
                        true => val | p.val,
                        _ => helper(p.left.take(), (val | p.val) << 1) + helper(p.right.take(), (val | p.val) << 1)
                    }
                }
                _ => 0
            }
        }
        helper(root, 0)
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;
    use crate::structure::TreeNode;
    use std::rc::Rc;
    use std::cell::RefCell;

    #[test]
    fn test_q1022() {
        let root = Some(Rc::new(RefCell::new(TreeNode{
            val:1,
            left:Some(Rc::new(RefCell::new(TreeNode{
                val:0,
                left:Some(Rc::new(RefCell::new(TreeNode::new(0)))),
                right:Some(Rc::new(RefCell::new(TreeNode::new(1))))
            }))),
            right:Some(Rc::new(RefCell::new(TreeNode{
                val:1,
                left:Some(Rc::new(RefCell::new(TreeNode::new(0)))),
                right:Some(Rc::new(RefCell::new(TreeNode::new(1))))
            })))
        })));
        assert_eq!(Solution::sum_root_to_leaf(root), 22);
    }
}
