use crate::Solution;

impl Solution {
    /// [1128.等价多米诺骨牌对的数量](https://leetcode-cn.com/problems/number-of-equivalent-domino-pairs/)
    ///
    /// 2022-02-21 18:06:48
    ///
    /// 给你一个由一些多米诺骨牌组成的列表 `dominoes`。
    ///
    /// 如果其中某一张多米诺骨牌可以通过旋转 `0` 度或 `180` 度得到另一张多米诺骨牌，我们就认为这两张牌是等价的。
    ///
    /// 形式上，`dominoes[i] = [a, b]` 和 `dominoes[j] = [c, d]` 等价的前提是 `a==c` 且 `b==d`，或是 `a==d` 且 `b==c`。
    ///
    /// 在 `0 <= i < j < dominoes.length` 的前提下，找出满足 `dominoes[i]` 和 `dominoes[j]` 等价的骨牌对 `(i, j)` 的数量。
    ///
    /// + **示例：**
    ///     + **输入：** dominoes = \[\[1,2\],\[2,1\],\[3,4\],\[5,6\]\]
    ///     + **输出：** 1
    /// + **提示：**
    ///     * `1 <= dominoes.length <= 40000`
    ///     * `1 <= dominoes[i][j] <= 9`
    /// + Related Topics
    ///     * 数组
    ///     * 哈希表
    ///     * 计数
    /// * 👍 136
    /// * 👎 0
    pub fn num_equiv_domino_pairs(dominoes: Vec<Vec<i32>>) -> i32 {
        let mut m = std::collections::HashMap::<i32, i32>::new();
        let mut ret = 0;
        for d in dominoes {
            let key = if d[0] < d[1] {
                d[0] * 10 + d[1]
            } else {
                d[1] * 10 + d[0]
            };
            ret += m.get(&key).unwrap_or(&0);
            *m.entry(key).or_default() += 1;
        }
        ret
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q1128() {
        assert_eq!(Solution::num_equiv_domino_pairs(vec![vec![1,2],vec![2,1],vec![3,4],vec![5,6]]), 1);
    }
}
