use crate::Solution;

impl Solution {
    /// 1137.第 N 个泰波那契数
    ///
    /// [原题链接](https://leetcode-cn.com/problems/n-th-tribonacci-number/)
    ///
    /// 2021-07-13 21:04:48
    ///
    /// 泰波那契序列 Tn 定义如下：
    /// `T0 = 0, T1 = 1, T2 = 1, 且在 n >= 0 的条件下 Tn+3 = Tn + Tn+1 + Tn+2`
    /// 给你整数 `n`，请返回第 `n` 个泰波那契数 `Tn` 的值。
    ///
    /// + 示例 1：
    ///     - 输入：`n = 4`
    ///     - 输出：`4`
    ///     - 解释：
    ///     - `T3 = 0 + 1 + 1 = 2`
    ///     - `T4 = 1 + 1 + 2 = 4`
    /// + 示例 2：
    ///     - 输入：`n = 25`
    ///     - 输出：`1389537`
    /// + 提示：
    ///     - `0 <= n <= 37`
    ///     - 答案保证是一个 `32` 位整数，即 `answer <= 2^31 - 1`。
    ///
    /// Related Topics 记忆化搜索 数学 动态规划
    ///
    /// 👍 79 👎 0
    pub fn tribonacci(n: i32) -> i32 {
        (0..n).fold((0, 1, 1), |(a, b, c), _| (b, c, a + b + c)).0
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q1137() {
        let ans = Solution::tribonacci(25);
        assert_eq!(ans, 1389537);
    }
}
