use crate::Solution;

impl Solution {
    /// 1143.最长公共子序列
    ///
    /// [原题链接](https://leetcode-cn.com/problems/longest-common-subsequence/)
    ///
    /// 2021-04-03 23:23:48
    ///
    /// 给定两个字符串 text1 和 text2，返回这两个字符串的最长 公共子序列 的长度。如果不存在 公共子序列 ，返回 0 。
    ///
    /// 一个字符串的 子序列 是指这样一个新的字符串：它是由原字符串在不改变字符的相对顺序的情况下删除某些字符（也可以不删除任何字符）后组成的新字符串。
    ///
    /// 例如，"ace" 是 "abcde" 的子序列，但 "aec" 不是 "abcde" 的子序列。
    ///
    /// 两个字符串的 公共子序列 是这两个字符串所共同拥有的子序列。
    ///
    /// + 示例 1：
    ///     - 输入：text1 = "abcde", text2 = "ace"
    ///     - 输出：3
    ///     - 解释：最长公共子序列是 "ace" ，它的长度为 3 。
    /// + 示例 2：
    ///     - 输入：text1 = "abc", text2 = "abc"
    ///     - 输出：3
    ///     - 解释：最长公共子序列是 "abc" ，它的长度为 3 。
    /// + 示例 3：
    ///
    ///     - 输入：text1 = "abc", text2 = "def"
    ///     - 输出：0
    ///     - 解释：两个字符串没有公共子序列，返回 0 。
    ///
    /// 提示：
    ///
    /// + 1 <= text1.length, text2.length <= 1000
    /// + text1 和 text2 仅由小写英文字符组成。
    ///
    /// Related Topics 动态规划
    ///
    /// 👍 483 👎 0
    pub fn longest_common_subsequence(text1: String, text2: String) -> i32 {
        let text1 = text1.as_bytes();
        let text2 = text2.as_bytes();
        let m = text1.len();
        let n = text2.len();
        let mut dp = vec![vec![0; n + 1]; m + 1];
        for i in 1..=m {
            let c1 = text1[i - 1];
            for j in 1..=n {
                let c2 = text2[j - 1];
                if c1 == c2 {
                    dp[i][j] = dp[i - 1][j - 1] + 1;
                } else {
                    dp[i][j] = dp[i - 1][j].max(dp[i][j - 1]);
                }
            }
        }
        return dp[m][n];
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q1143() {
        let text1 = "abcde".to_string();
        let text2 = "ace".to_string();
        let a = Solution::longest_common_subsequence(text1, text2);
        assert_eq!(a, 3);
    }
}