use crate::Solution;

impl Solution {
    /// 1190.反转每对括号间的子串
    ///
    /// [原题链接](https://leetcode-cn.com/problems/reverse-substrings-between-each-pair-of-parentheses/)
    ///
    /// 2021-05-31 17:23:00
    ///
    /// 给出一个字符串 s（仅含有小写英文字母和括号）。
    ///
    /// 请你按照从括号内到外的顺序，逐层反转每对匹配括号中的字符串，并返回最终的结果。
    ///
    /// 注意，您的结果中 不应 包含任何括号。
    ///
    /// + 示例 1：
    ///     - 输入：s = "(abcd)"
    ///     - 输出："dcba"
    /// + 示例 2：
    ///     - 输入：s = "(u(love)i)"
    ///     - 输出："iloveu"
    ///     - 解释：先反转子字符串 "love" ，然后反转整个字符串。
    /// + 示例 3：
    ///     - 输入：s = "(ed(et(oc))el)"
    ///     - 输出："leetcode"
    ///     - 解释：先反转子字符串 "oc" ，接着反转 "etco" ，然后反转整个字符串。
    /// + 示例 4：
    ///     - 输入：s = "a(bcdefghijkl(mno)p)q"
    ///     - 输出："apmnolkjihgfedcbq"
    /// + 提示：
    ///     - 0 <= s.length <= 2000
    ///     - s 中只有小写英文字母和括号
    ///     - 题目测试用例确保所有括号都是成对出现的
    ///
    /// Related Topics 栈
    ///
    /// 👍 179 👎 0
    pub fn reverse_parentheses(s: String) -> String {
        let s = s.into_bytes();
        let n = s.len();
        let mut pair = vec![0; n];
        let mut stack = vec![];
        for i in 0..n {
            if s[i] == b'(' {
                stack.push(i);
            } else if s[i] == b')' {
                let j = stack.pop().unwrap();
                pair[i] = j;
                pair[j] = i;
            }
        }
        let mut ret = vec![];
        let (mut idx, mut step) = (0, true);
        while idx < n {
            if s[idx] == b'(' || s[idx] == b')' {
                idx = pair[idx];
                step = !step;
            } else {
                ret.push(s[idx]);
            }
            if step {
                idx += 1;
            } else {
                idx -= 1;
            }
        }
        String::from_utf8(ret).unwrap()
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q1190() {
        let s = "(u(love)i)".to_string();
        let ans = Solution::reverse_parentheses(s);
        assert_eq!(ans, "iloveu".to_string());
    }
}
