use crate::Solution;

impl Solution {
    /// [1203.项目管理](https://leetcode-cn.com/problems/sort-items-by-groups-respecting-dependencies/)
    ///
    /// 2022-02-21 18:15:56
    ///
    /// 有 `n` 个项目，每个项目或者不属于任何小组，或者属于 `m` 个小组之一。`group[i]` 表示第 `i` 个项目所属的小组，如果第 `i` 个项目不属于任何小组，则 `group[i]` 等于 `-1`。项目和小组都是从零开始编号的。可能存在小组不负责任何项目，即没有任何项目属于这个小组。
    ///
    /// 请你帮忙按要求安排这些项目的进度，并返回排序后的项目列表：
    ///
    /// > 同一小组的项目，排序后在列表中彼此相邻。
    /// > 项目之间存在一定的依赖关系，我们用一个列表 `beforeItems` 来表示，其中 `beforeItems[i]` 表示在进行第 `i` 个项目前（位于第 `i` 个项目左侧）应该完成的所有项目。
    ///
    /// 如果存在多个解决方案，只需要返回其中任意一个即可。如果没有合适的解决方案，就请返回一个 **空列表** 。
    ///
    /// + **示例 1：**
    ///     + ![](https://assets.leetcode-cn.com/aliyun-lc-upload/uploads/2019/09/22/1359_ex1.png)
    ///     + **输入：** n = 8, m = 2, group = \[-1,-1,1,0,0,1,0,-1\], beforeItems = \[\[\],\[6\],\[5\],\[6\],\[3,6\],\[\],\[\],\[\]\]
    ///     + **输出：** \[6,3,4,1,5,2,0,7\]
    /// + **示例 2：**
    ///     + **输入：** n = 8, m = 2, group = \[-1,-1,1,0,0,1,0,-1\], beforeItems = \[\[\],\[6\],\[5\],\[6\],\[3\],\[\],\[4\],\[\]\]
    ///     + **输出：** \[\]
    ///     + **解释：** 与示例 1 大致相同，但是在排序后的列表中，4 必须放在 6 的前面。
    /// + **提示：**
    ///     * `1 <= m <= n <= 3 * 104`
    ///     * `group.length == beforeItems.length == n`
    ///     * `-1 <= group[i] <= m - 1`
    ///     * `0 <= beforeItems[i].length <= n - 1`
    ///     * `0 <= beforeItems[i][j] <= n - 1`
    ///     * `i != beforeItems[i][j]`
    ///     * `beforeItems[i]` 不含重复元素
    /// + Related Topics
    ///     * 深度优先搜索
    ///     * 广度优先搜索
    ///     * 图
    ///     * 拓扑排序
    /// * 👍 189
    /// * 👎 0
    pub fn sort_items(n: i32, m: i32, group: Vec<i32>, before_items: Vec<Vec<i32>>) -> Vec<i32> {
        fn top_sort(deg: &mut Vec<usize>, graph: &mut Vec<Vec<usize>>, items: &mut Vec<usize>) -> Vec<usize> {
            let mut q = std::collections::VecDeque::<usize>::new();
            let n = items.len();
            for item in items {
                if deg[*item] == 0 {
                    q.push_back(*item);
                }
            }
            let mut res = Vec::<usize>::new();
            while !q.is_empty() {
                let u = q.pop_front().unwrap();
                res.push(u);
                for &v in &graph[u] {
                    deg[v] -= 1;
                    if deg[v] == 0 {
                        q.push_back(v);
                    }
                }
            }
            if res.len() == n {
                res
            } else {
                Vec::new()
            }
            //unimplemented!();
        }
        let mut group_item = vec![Vec::<usize>::new(); (n + m) as usize];
        let mut group_graph = vec![Vec::<usize>::new(); (n + m) as usize];
        let mut item_graph = vec![Vec::<usize>::new(); n as usize];

        let mut group_degree = vec![0usize; (n + m) as usize];
        let mut item_degree = vec![0usize; n as usize];

        let mut id = (0..((n + m) as usize)).collect::<Vec<usize>>();
        let mut left_id = m as usize;
        let mut group = group.into_iter().map(|x| x as usize).collect::<Vec<usize>>();
        for i in 0..(n as usize) {
            if group[i] == -1i32 as usize {
                group[i] = left_id;
                left_id += 1;
            }
            group_item[group[i]].push(i);
        }

        for i in 0..(n as usize) {
            let curr_group_id = group[i];
            for &item in &before_items[i] {
                let before_group_id = group[item as usize];
                if before_group_id == curr_group_id {
                    item_degree[i] += 1;
                    item_graph[item as usize].push(i);
                } else {
                    group_degree[curr_group_id] += 1;
                    group_graph[before_group_id].push(curr_group_id);
                }
            }
        }

        let group_top_sort = top_sort(&mut group_degree, &mut group_graph, &mut id);
        if group_top_sort.is_empty() {
            return Vec::new();
        }
        let mut ans = Vec::<i32>::new();

        for curr_group_id in group_top_sort {
            //let size = group_item[curr_group_id].len();
            if group_item[curr_group_id].len() == 0 {
                continue;
            }
            let res = top_sort(&mut item_degree, &mut item_graph, &mut group_item[curr_group_id]);
            if res.is_empty() {
                return Vec::<i32>::new();
            }
            for item in res {
                ans.push(item as i32);
            }
        }
        ans
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q1203() {
        // n = 8, m = 2, group = [-1,-1,1,0,0,1,0,-1], beforeItems = [[],[6],[5],[6],[3,6],[],[],[]]
        assert_eq!(Solution::sort_items(8, 2, vec![-1, -1, 1, 0, 0, 1, 0, -1], vec![vec![], vec![6], vec![5], vec![6], vec![3, 6], vec![], vec![], vec![]]), vec![6, 3, 4, 5, 2, 0, 7, 1]);
    }
}
