use crate::Solution;


impl Solution {
    /// [1218.最长定差子序列](https://leetcode-cn.com/problems/longest-arithmetic-subsequence-of-given-difference/)
    ///
    /// 2021-11-05 20:02:22
    ///
    /// 给你一个整数数组 `arr` 和一个整数 `difference`，请你找出并返回 `arr` 中最长等差子序列的长度，该子序列中相邻元素之间的差等于 `difference` 。
    ///
    /// **子序列** 是指在不改变其余元素顺序的情况下，通过删除一些元素或不删除任何元素而从 `arr` 派生出来的序列。
    ///
    /// **示例 1：**
    ///
    ///     **输入：** arr = \[1,2,3,4\], difference = 1
    ///     **输出：** 4
    ///     **解释：** 最长的等差子序列是 \[1,2,3,4\]。
    ///
    /// **示例 2：**
    ///
    ///     **输入：** arr = \[1,3,5,7\], difference = 1
    ///     **输出：** 1
    ///     **解释：** 最长的等差子序列是任意单个元素。
    ///
    ///
    /// **示例 3：**
    ///
    ///     **输入：** arr = \[1,5,7,8,5,3,4,2,1\], difference = -2
    ///     **输出：** 4
    ///     **解释：** 最长的等差子序列是 \[7,5,3,1\]。
    ///
    ///
    /// **提示：**
    ///
    /// * `1 <= arr.length <= 105`
    /// * `-104 <= arr[i], difference <= 104`
    ///
    /// Related Topics
    ///
    /// + 数组
    /// + 哈希表
    /// + 动态规划
    ///
    /// * 👍 157
    /// * 👎 0
    pub fn longest_subsequence(arr: Vec<i32>, difference: i32) -> i32 {
        let mut dp = std::collections::HashMap::<i32, i32>::new();
        let mut ans = 0;
        for v in arr {
            //*dp.entry(v).or_default() += dp.get(&(v - difference)).unwrap_or(&0) + 1;
            dp.insert(v, dp.get(&(v - difference)).unwrap_or(&0) + 1);
            ans = ans.max(dp[&v]);
        }
        ans
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q1218() {
        let arr = vec![1, 5, 7, 8, 5, 3, 4, 2, 1];
        let d = -2;
        let ans = Solution::longest_subsequence(arr, d);
        assert_eq!(ans, 4);
    }
}
