use crate::Solution;

impl Solution {
    /// 1269.停在原地的方案数
    ///
    /// [原题链接](https://leetcode-cn.com/problems/number-of-ways-to-stay-in-the-same-place-after-some-steps/)
    ///
    /// 2021-05-13 08:49:44
    ///
    /// 有一个长度为 arrLen 的数组，开始有一个指针在索引 0 处。
    ///
    /// 每一步操作中，你可以将指针向左或向右移动 1 步，或者停在原地（指针不能被移动到数组范围外）。
    ///
    /// 给你两个整数 steps 和 arrLen ，请你计算并返回：在恰好执行 steps 次操作以后，指针仍然指向索引 0 处的方案数。
    ///
    /// 由于答案可能会很大，请返回方案数 模 10^9 + 7 后的结果。
    ///
    /// + 示例 1：
    ///     - 输入：steps = 3, arrLen = 2
    ///     - 输出：4
    ///     - 解释：
    ///         * 3 步后，总共有 4 种不同的方法可以停在索引 0 处。
    ///         * 向右，向左，不动
    ///         * 不动，向右，向左
    ///         * 向右，不动，向左
    ///         * 不动，不动，不动
    ///
    ///
    /// + 示例 2：
    ///     - 输入：steps = 2, arrLen = 4
    ///     - 输出：2
    ///     - 解释：
    ///         * 2 步后，总共有 2 种不同的方法可以停在索引 0 处。
    ///         * 向右，向左
    ///         * 不动，不动
    /// + 示例 3：
    ///     - 输入：steps = 4, arrLen = 2
    ///     - 输出：8
    /// + 提示：
    ///     - 1 <= steps <= 500
    ///     - 1 <= arrLen <= 10^6
    ///
    /// Related Topics 动态规划
    ///
    /// 👍 76 👎 0
    pub fn num_ways(steps: i32, arr_len: i32) -> i32 {
        let max_c = steps.min(arr_len - 1) as usize;
        let steps = steps as usize;
        let mut dp = vec![0; max_c + 1];
        dp[0] = 1;
        for i in 1..=steps {
            let mut dp_next = vec![0; max_c + 1];
            for j in 0..=max_c {
                dp_next[j] = dp[j];
                if j >= 1 {
                    dp_next[j] = (dp_next[j] + dp[j - 1]) % 1000000007;
                }
                if j + 1 <= max_c {
                    dp_next[j] = (dp_next[j] + dp[j + 1]) % 1000000007;
                }
            }
            dp = dp_next;
        }
        dp[0]
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q1269() {
        let steps = 4;
        let arr_len = 2;
        let ans = Solution::num_ways(steps, arr_len);
        assert_eq!(ans, 8);
    }
}
