use crate::Solution;

impl Solution {
    /// [1281.整数的各位积和之差](https://leetcode.cn/problems/subtract-the-product-and-sum-of-digits-of-an-integer/)
    ///
    /// 2022-08-09 12:28:53
    ///
    /// 给你一个整数 `n`，请你帮忙计算并返回该整数「各位数字之积」与「各位数字之和」的差。
    ///
    /// + **示例 1：**
    ///     + **输入：** n = 234
    ///     + **输出：** 15
    ///     + **解释：**
    ///         + 各位数之积 = 2 \* 3 \* 4 = 24
    ///         + 各位数之和 = 2 + 3 + 4 = 9
    ///         + 结果 = 24 - 9 = 15
    /// **示例 2：**
    ///     + **输入：** n = 4421
    ///     + **输出：** 21
    ///     + **解释：**
    ///         - 各位数之积 = 4 \* 4 \* 2 \* 1 = 32
    ///         - 各位数之和 = 4 + 4 + 2 + 1 = 11
    ///         - 结果 = 32 - 11 = 21
    /// + **提示：**
    ///     * `1 <= n <= 10^5`
    /// + Related Topics
    ///     * 数学
    pub fn subtract_product_and_sum(mut n: i32) -> i32 {
        let mut add = 0;
        let mut mul = 1;
        while n > 0 {
            let digit = n % 10;
            n /= 10;
            add += digit;
            mul *= digit;
        }
        mul - add
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q1281() {
        assert_eq!(Solution::subtract_product_and_sum(234), 15);
    }
}
