use crate::Solution;

impl Solution {
    /// [1288.删除被覆盖区间](https://leetcode.cn/problems/remove-covered-intervals/)
    ///
    /// 2022-08-08 15:13:53
    ///
    /// 给你一个区间列表，请你删除列表中被其他区间所覆盖的区间。
    ///
    /// 只有当 `c <= a` 且 `b <= d` 时，我们才认为区间 `[a,b)` 被区间 `[c,d)` 覆盖。
    ///
    /// 在完成所有删除操作后，请你返回列表中剩余区间的数目。
    ///
    /// + **示例：**
    ///     + **输入：** intervals = \[\[1,4\],\[3,6\],\[2,8\]\]
    ///     + **输出：** 2
    ///     + **解释：** 区间 \[3,6\] 被区间 \[2,8\] 覆盖，所以它被删除了。
    /// + **提示：**
    ///     * `1 <= intervals.length <= 1000`
    ///     * `0 <= intervals[i][0] < intervals[i][1] <= 10^5`
    ///     * 对于所有的 `i != j`：`intervals[i] != intervals[j]`
    /// + Related Topics
    ///     * 数组
    ///     * 排序
    pub fn remove_covered_intervals(mut intervals: Vec<Vec<i32>>) -> i32 {
        intervals.sort_unstable_by(|a, b| a[0].cmp(&b[0]).then(b[1].cmp(&a[1])));
        let (mut ans, mut r_max) = (intervals.len(), intervals[0][1]);
        for i in 1..intervals.len() {
            match intervals[i][1] <= r_max {
                true => ans -= 1,
                _ => r_max = r_max.max(intervals[i][1])
            }
        }
        ans as i32
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q1288() {
        assert_eq!(Solution::remove_covered_intervals(vec![vec![1, 4], vec![3, 6], vec![2, 8]]), 2);
    }
}
