use crate::Solution;

impl Solution {
    /// [1295.统计位数为偶数的数字](https://leetcode.cn/problems/find-numbers-with-even-number-of-digits/)
    ///
    /// 2022-08-09 12:34:55
    ///
    /// 给你一个整数数组 `nums`，请你返回其中位数为 **偶数** 的数字的个数。
    ///
    /// + **示例 1：**
    ///     + **输入：** nums = \[12,345,2,6,7896\]
    ///     + **输出：** 2
    ///     + **解释：**
    ///         - 12 是 2 位数字（位数为偶数）
    ///         - 345 是 3 位数字（位数为奇数）
    ///         - 2 是 1 位数字（位数为奇数）
    ///         - 6 是 1 位数字 位数为奇数）
    ///         - 7896 是 4 位数字（位数为偶数）
    ///         - 因此只有 12 和 7896 是位数为偶数的数字
    /// + **示例 2：**
    ///     + **输入：** nums = \[555,901,482,1771\]
    ///     + **输出：** 1
    ///     + **解释：**
    ///         - 只有 1771 是位数为偶数的数字。
    /// + **提示：**
    ///     * `1 <= nums.length <= 500`
    ///     * `1 <= nums[i] <= 10^5`
    /// + Related Topics
    ///     * 数组
    /// # 方法1 字符串长度
    /// ```rust
    /// pub fn find_numbers(nums: Vec<i32>) -> i32 {
    ///     nums.iter().fold(0, |mut acc, x| {
    ///         acc += (1usize - (x.to_string().len() & 1usize)) as i32;
    ///         acc
    ///     })
    /// }
    /// ```
    /// # 方法2 取以10为底的对数
    /// ```rust
    /// pub fn find_numbers(nums: Vec<i32>) -> i32 {
    ///     nums.iter().map(|&x| { ((x as f32).log10()) as i32 & 1 }).sum()
    /// }
    /// ```
    /// # 方法3 除10
    /// ```rust
    /// pub fn find_numbers(nums: Vec<i32>) -> i32 {
    ///     let mut res = 0;
    ///     for mut num in nums {
    ///         let mut b = 0;
    ///         while num > 9 {
    ///             num /= 10;
    ///             b += 1;
    ///         }
    ///         res += b & 1;
    ///     }
    ///     res
    /// }
    /// ```
    /// # 方法4 暴力
    pub fn find_numbers(nums: Vec<i32>) -> i32 {
        /*nums.iter().fold(0i32, |acc, &x| acc + match x {
            10..=99 | 1000..=9999 | 100000 => 1,
            _ => 0
        })*/
        /*nums.into_iter().map(|a| match a {
            10..=99 | 1000..=9999 | 100000 => 1,
            _ => 0
        }).sum()*/
        //nums.into_iter().filter(|x| x.to_string().len() & 1 == 0).count() as i32
        //nums.into_iter().filter(|&x| (((x as f32).log10() as i32) & 1) == 1).count() as i32
        nums.into_iter().filter(|&x| 9 < x && x < 100 || 999 < x && x < 10000 || x == 100000).count() as i32
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q1295() {
        assert_eq!(Solution::find_numbers(vec![12, 345, 2, 6, 7896]), 2);
    }
}
