use crate::Solution;
use crate::structure::TreeNode;

use std::rc::Rc;
use std::cell::RefCell;
impl Solution {
    /// [1302.层数最深叶子节点的和](https://leetcode.cn/problems/deepest-leaves-sum/)
    ///
    /// 2022-08-17 09:11:35
    ///
    /// 给你一棵二叉树的根节点 `root` ，请你返回 **层数最深的叶子节点的和** 。
    ///
    /// + **示例 1：**
    ///     + **![](https://assets.leetcode-cn.com/aliyun-lc-upload/uploads/2019/12/28/1483_ex1.png)**
    ///     + **输入：**root = \[1,2,3,4,5,null,6,7,null,null,null,null,8\]
    ///     + **输出：**15
    /// + **示例 2：**
    ///     + **输入：**root = \[6,7,8,2,7,1,3,9,null,1,4,null,null,null,5\]
    ///     + **输出：**19
    /// + **提示：**
    ///     * 树中节点数目在范围 `[1, 104]` 之间。
    ///     * `1 <= Node.val <= 100`
    /// + Related Topics
    ///     * 树
    ///     * 深度优先搜索
    ///     * 广度优先搜索
    ///     * 二叉树
    pub fn deepest_leaves_sum(root: Option<Rc<RefCell<TreeNode>>>) -> i32 {
        let mut v = vec![];
        match root {
            Some(n) => v.push(n),
            _ => return 0
        }
        let mut s = 0;
        while !v.is_empty() {
            s = 0;
            let mut t = vec![];
            for n in v {
                s += n.borrow().val;
                if let Some(l) = n.borrow_mut().left.take() {
                    t.push(l);
                }
                if let Some(r) = n.borrow_mut().right.take() {
                    t.push(r);
                }
            }
            v = t;
        }
        s
    }
}

#[cfg(test)]
mod test {
    use std::cell::RefCell;
    use std::rc::Rc;
    use crate::Solution;
    use crate::structure::TreeNode;

    #[test]
    fn test_q1302() {
        let tree = Some(Rc::new(RefCell::new(TreeNode {
            val: 1,
            left: Some(Rc::new(RefCell::new(TreeNode {
                val: 2,
                left: Some(Rc::new(RefCell::new(TreeNode {
                    val: 4,
                    left: None,
                    right: Some(Rc::new(RefCell::new(TreeNode {
                        val: 7,
                        left: None,
                        right: None,
                    }))),
                }))),
                right: Some(Rc::new(RefCell::new(TreeNode {
                    val: 5,
                    left: None,
                    right: None,
                }))),
            }))),
            right: Some(Rc::new(RefCell::new(TreeNode {
                val: 3,
                left: None,
                right: Some(Rc::new(RefCell::new(TreeNode {
                    val: 6,
                    left: None,
                    right: Some(Rc::new(RefCell::new(TreeNode {
                        val: 8,
                        left: None,
                        right: None,
                    }))),
                }))),
            }))),
        })));
        assert_eq!(Solution::deepest_leaves_sum(tree), 15);
    }
}
