use crate::Solution;

impl Solution {
    /// [1404.将二进制表示减到 1 的步骤数](https://leetcode.cn/problems/number-of-steps-to-reduce-a-number-in-binary-representation-to-one/)
    ///
    /// 2022-08-09 10:57:36
    ///
    /// 给你一个以二进制形式表示的数字 `s` 。请你返回按下述规则将其减少到 1 所需要的步骤数：
    ///
    /// * 如果当前数字为偶数，则将其除以 2 。
    /// * 如果当前数字为奇数，则将其加上 1 。
    ///
    /// 题目保证你总是可以按上述规则将测试用例变为 1 。
    ///
    /// + **示例 1：**
    ///     + **输入：** s = "1101"
    ///     + **输出：** 6
    ///     + **解释：** "1101" 表示十进制数 13 。
    ///         - Step 1) 13 是奇数，加 1 得到 14
    ///         - Step 2) 14 是偶数，除 2 得到 7
    ///         - Step 3) 7  是奇数，加 1 得到 8
    ///         - Step 4) 8  是偶数，除 2 得到 4
    ///         - Step 5) 4  是偶数，除 2 得到 2
    ///         - Step 6) 2  是偶数，除 2 得到 1
    /// + **示例 2：**
    ///     + **输入：** s = "10"
    ///     + **输出：** 1
    ///     + **解释：** "10" 表示十进制数 2 。
    ///         - Step 1) 2 是偶数，除 2 得到 1
    /// + **示例 3：**
    ///     + **输入：** s = "1"
    ///     + **输出：** 0
    /// + **提示：**
    ///     * `1 <= s.length <= 500`
    ///     * `s` 由字符 `'0'` 或 `'1'` 组成。
    ///     * `s[0] == '1'`
    /// + Related Topics
    ///     * 位运算
    ///     * 字符串
    pub fn num_steps(s: String) -> i32 {
        let mut result = 0;
        let mut meet1 = false;

        for (i, c) in s.chars().rev().enumerate() {
            match c {
                '0' => result += meet1.then(|| 2).unwrap_or(1),
                _ => match meet1 {
                    true => result += 1,
                    _ => {
                        result += (i != (s.len() - 1)).then(|| 2).unwrap_or(0);
                        meet1 = true;
                    }
                }
            }
            /*if c == '0' {
                result += if meet1 { 2 } else { 1 }
            } else {
                if !meet1 {
                    if i != (s.len() - 1) {
                        result += 2;
                    }
                    meet1 = true;
                } else {
                    result += 1;
                }
            }*/
        }
        result
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q1404() {
        assert_eq!(Solution::num_steps("1101".to_owned()), 6);
    }
}
