use crate::Solution;


impl Solution {
    /// [1447.最简分数](https://leetcode-cn.com/problems/simplified-fractions/)
    ///
    /// 2022-02-10 14:35:49
    ///
    /// 给你一个整数 `n` ，请你返回所有 0 到 1 之间（不包括 0 和 1）满足分母小于等于 `n` 的 **最简** 分数 。分数可以以 **任意** 顺序返回。
    ///
    /// + **示例 1：**
    ///     + **输入：** n = 2
    ///     + **输出：** \["1/2"\]
    ///     + **解释：** "1/2" 是唯一一个分母小于等于 2 的最简分数。
    /// + **示例 2：**
    ///     + **输入：** n = 3
    ///     + **输出：** \["1/2","1/3","2/3"\]
    /// + **示例 3：**
    ///     + **输入：** n = 4
    ///     + **输出：** \["1/2","1/3","1/4","2/3","3/4"\]
    ///     + **解释：** "2/4" 不是最简分数，因为它可以化简为 "1/2" 。
    /// + **示例 4：**
    ///     + **输入：** n = 1
    ///     + **输出：** \[\]
    /// + **提示：**
    ///     * `1 <= n <= 100`
    /// + Related Topics
    ///     * 数学
    ///     * 字符串
    ///     * 数论
    /// * 👍 60
    /// * 👎 0
    pub fn simplified_fractions(n: i32) -> Vec<String> {
        fn gcd(a: i32, b: i32) -> i32 {
            if b == 0 { a } else { gcd(b, a % b) }
        }
        /*fn gcd(mut a:i32, mut b: i32) -> i32 {
            while b != 0 {
                (a, b) = (b, a % b);
            }
            a
        }*/
        (2..=n).map(|i| (1..i).filter(move |&j| gcd(j, i) == 1).map(move |j| format!("{}/{}", j, i))).flatten().collect()
        /*let mut ans = Vec::<String>::new();
        for i in 2..=n {
            for j in 1..i {
                if gcd(i, j) == 1 {
                    ans.push(format!("{}/{}", j, i));
                }
            }
        }
        ans*/
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q1447() {
        let ans = vec!["1/2".to_string(), "1/3".to_string(), "2/3".to_string()];
        assert_eq!(Solution::simplified_fractions(3), ans);
    }
}
