use crate::Solution;

impl Solution {
    /// [1480.一维数组的动态和](https://leetcode.cn/problems/running-sum-of-1d-array/)
    ///
    /// 2022-08-09 11:20:52
    ///
    /// 给你一个数组 `nums` 。数组「动态和」的计算公式为：`runningSum[i] = sum(nums[0]…nums[i])` 。
    ///
    /// 请返回 `nums` 的动态和。
    ///
    /// + **示例 1：**
    ///     + **输入：** nums = \[1,2,3,4\]
    ///     + **输出：** \[1,3,6,10\]
    ///     + **解释：** 动态和计算过程为 \[1, 1+2, 1+2+3, 1+2+3+4\] 。
    /// + **示例 2：**
    ///     + **输入：** nums = \[1,1,1,1,1\]
    ///     + **输出：** \[1,2,3,4,5\]
    ///     + **解释：** 动态和计算过程为 \[1, 1+1, 1+1+1, 1+1+1+1, 1+1+1+1+1\] 。
    /// + **示例 3：**
    ///     + **输入：** nums = \[3,1,2,10,1\]
    ///     + **输出：** \[3,4,6,16,17\]
    /// + **提示：**
    ///     * `1 <= nums.length <= 1000`
    ///     * `-10^6 <= nums[i] <= 10^6`
    /// + Related Topics
    ///     * 数组
    ///     * 前缀和
    pub fn running_sum(nums: Vec<i32>) -> Vec<i32> {
        nums.into_iter().scan(0, |s, i| {
            *s += i;
            Some(*s)
        }).collect()
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q1480() {
        assert_eq!(Solution::running_sum(vec![1, 2, 3, 4]), vec![1, 3, 6, 10]);
    }
}
