use crate::Solution;

impl Solution {
    /// 1486.数组异或操作
    ///
    /// [原题链接](https://leetcode-cn.com/problems/xor-operation-in-an-array/)
    ///
    /// 2021-05-07 07:27:35
    ///
    /// 给你两个整数，`n` 和 `start` 。
    ///
    /// 数组 `nums` 定义为：`nums[i] = start + 2 * i`（下标从 0 开始）且 `n == nums.length` 。
    ///
    /// 请返回 `nums` 中所有元素按位异或（`XOR`）后得到的结果。
    ///
    /// + 示例 1：
    ///     - 输入：`n = 5, start = 0`
    ///     - 输出：`8`
    ///     - 解释：数组 `nums` 为 `[0, 2, 4, 6, 8]`，其中 `(0 ^ 2 ^ 4 ^ 6 ^ 8) = 8` 。"^" 为按位异或 `XOR` 运算符。
    /// + 示例 2：
    ///     - 输入：`n = 4, start = 3`
    ///     - 输出：`8`
    ///     - 解释：数组 `nums` 为 `[3, 5, 7, 9]`，其中 `(3 ^ 5 ^ 7 ^ 9) = 8`.
    /// + 示例 3：
    ///     - 输入：`n = 1, start = 7`
    ///     - 输出：`7`
    /// + 示例 4：
    ///     - 输入：`n = 10, start = 5`
    ///     - 输出：`2`
    /// + 提示：
    ///     - `1 <= n <= 1000`
    ///     - `0 <= start <= 1000`
    ///     - `n == nums.length`
    ///
    /// Related Topics 位运算 数组
    ///
    /// 👍 39 👎 0
    /// # 方法1
    /// 暴力法
    /// ```rust
    /// pub fn xor_operation(n: i32, start: i32) -> i32 {
    ///     (0..n).fold(0, |acc, i| acc ^ (start + 2 * i))
    /// }
    /// ```
    /// # 方法2
    /// 归纳法，每四个数循环
    pub fn xor_operation(n: i32, start: i32) -> i32 {
        if (start & 3) < 2 {
            (n & 1) * (start + 2 * n - 3) + (n & 3)
        } else {
            (n & 1) * (start + 1 - (n & 3)) + (1 - (n & 1)) * ((start + (n - 1) * 2) ^ (start - 2 + (n & 3)))
        }
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q1486() {
        let n = 10;
        let start = 5;
        let ans = Solution::xor_operation(n, start);
        assert_eq!(ans, 2);
    }
}
