use crate::Solution;

impl Solution {
    /// [1502.判断能否形成等差数列](https://leetcode-cn.com/problems/can-make-arithmetic-progression-from-sequence/)
    ///
    /// 2022-08-03 14:54:25
    ///
    /// 给你一个数字数组 `arr` 。
    ///
    /// 如果一个数列中，任意相邻两项的差总等于同一个常数，那么这个数列就称为 **等差数列** 。
    ///
    /// 如果可以重新排列数组形成等差数列，请返回 `true` ；否则，返回 `false` 。
    ///
    /// + **示例 1：**
    ///     - **输入：** arr = \[3,5,1\]
    ///     - **输出：** true
    ///     - **解释：** 对数组重新排序得到 \[1,3,5\] 或者 \[5,3,1\] ，任意相邻两项的差分别为 2 或 -2 ，可以形成等差数列。
    /// + **示例 2：**
    ///     - **输入：** arr = \[1,2,4\]
    ///     - **输出：** false
    ///     - **解释：** 无法通过重新排序得到等差数列。
    /// + **提示：**
    ///     * `2 <= arr.length <= 1000`
    ///     * `-10^6 <= arr[i] <= 10^6`
    /// + Related Topics
    ///     * 数组
    ///     * 排序
    /// * 👍 29
    /// * 👎 0
    pub fn can_make_arithmetic_progression(arr: Vec<i32>) -> bool {
        match arr.len() {
            0 | 1 | 2 => true,
            _ => std::collections::BinaryHeap::from(arr).into_sorted_vec().windows(3).map(|w| w[1] - w[0] == w[2] - w[1]).skip_while(|i| *i).next().is_none()
        }
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q1502() {
        assert_eq!(Solution::can_make_arithmetic_progression(vec![1, 2, 4]), false);
    }
}
