use crate::Solution;

impl Solution {
    /// [1678.设计 Goal 解析器](https://leetcode.cn/problems/goal-parser-interpretation/)
    ///
    /// 2022-08-09 14:02:12
    ///
    /// 请你设计一个可以解释字符串 `command` 的 **Goal 解析器** 。`command` 由 `"G"`、`"()"` 和/或 `"(al)"` 按某种顺序组成。Goal 解析器会将 `"G"` 解释为字符串 `"G"`、`"()"` 解释为字符串 `"o"` ，`"(al)"` 解释为字符串 `"al"` 。然后，按原顺序将经解释得到的字符串连接成一个字符串。
    ///
    /// 给你字符串 `command` ，返回  **Goal  解析器** 对  `command` 的解释结果。
    ///
    /// + **示例 1：**
    ///     + **输入：** command = "G()(al)"
    ///     + **输出：** "Goal"
    ///     + **解释：** Goal 解析器解释命令的步骤如下所示：
    ///         - G -> G
    ///         - () -> o
    ///         - (al) -> al
    ///         - 最后连接得到的结果是 "Goal"
    /// + **示例 2：**
    ///     + **输入：** command = "G()()()()(al)"
    ///     + **输出：** "Gooooal"
    /// + **示例 3：**
    ///     + **输入：** command = "(al)G(al)()()G"
    ///     + **输出：** "alGalooG"
    /// + **提示：**
    ///     * `1 <= command.length <= 100`
    ///     * `command` 由 `"G"`、`"()"` 和/或 `"(al)"` 按某种顺序组成
    /// + Related Topics
    ///     * 字符串
    pub fn interpret(command: String) -> String {
        let mut answer = vec![];
        let mut pre = b'\0';
        for ch in command.into_bytes() {
            if ch == b'G' {
                answer.push(ch);
            } else if ch == b')' {
                if pre == b'(' {
                    answer.push(b'o');
                } else {
                    answer.push(b'a');
                    answer.push(b'l');
                }
            }
            pre = ch;
        }
        String::from_utf8(answer).unwrap()
        // command.replace("(al)", "al").replace("()", "o")
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q1678() {
        assert_eq!(Solution::interpret("G()(al)".to_owned()), "Goal".to_owned());
    }
}
