use crate::Solution;

impl Solution {
    /// 1723.完成所有工作的最短时间
    ///
    /// [原题链接](https://leetcode-cn.com/problems/find-minimum-time-to-finish-all-jobs/)
    ///
    /// 2021-05-08 07:33:03
    ///
    /// 给你一个整数数组 `jobs` ，其中 `jobs[i]` 是完成第 `i` 项工作要花费的时间。
    ///
    /// 请你将这些工作分配给 `k` 位工人。所有工作都应该分配给工人，且每项工作只能分配给一位工人。工人的 工作时间 是完成分配给他们的所有工作花费时间的总和。请你
    /// 设计一套最佳的工作分配方案，使工人的 最大工作时间 得以 最小化 。
    ///
    /// 返回分配方案中尽可能 最小 的 最大工作时间 。
    ///
    /// + 示例 1：
    ///     - 输入：`jobs = [3,2,3], k = 3`
    ///     - 输出：`3`
    ///     - 解释：给每位工人分配一项工作，最大工作时间是 3 。
    /// + 示例 2：
    ///     - 输入：`jobs = [1,2,4,7,8], k = 2`
    ///     - 输出：`11`
    ///     - 解释：按下述方式分配工作：
    ///         - `1` 号工人：1、2、8（工作时间 = 1 + 2 + 8 = 11）
    ///         - `2` 号工人：4、7（工作时间 = 4 + 7 = 11）
    ///         - 最大工作时间是 `11` 。
    /// + 提示：
    ///     - `1 <= k <= jobs.length <= 12`
    ///     - `1 <= jobs[i] <= 107`
    ///
    /// Related Topics 递归 回溯算法
    ///
    /// 👍 64 👎 0
    pub fn minimum_time_required(jobs: Vec<i32>, k: i32) -> i32 {
        // todo
        let n = jobs.len();
        let k = k as usize;
        let mut sum = vec![0; 1usize << n];
        for i in 1..(1usize << n) {
            let x = i.trailing_zeros() as usize;
            let y = i - (1 << x);
            sum[i] = sum[y] + jobs[x];
        }
        let mut dp = vec![vec![0; 1usize << n]; k];
        for i in 0..(1usize << n) {
            dp[0][i] = sum[i];
        }

        for i in 1..k {
            for j in 0..(1usize << n) {
                let mut min_n = i32::MAX;
                let mut x = j;
                loop {
                    min_n = min_n.min(sum[x].max(dp[i - 1][j - x]));
                    x = (x - 1) & j;
                    if x == 0 { break; }
                }
                dp[i][j] = min_n;
            }
        }
        dp[k - 1][(1 << n) - 1]
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q1723() {
        unimplemented!()
    }
}
