use crate::Solution;

impl Solution {
    /// 1734.解码异或后的排列
    ///
    /// [原题链接](https://leetcode-cn.com/problems/decode-xored-permutation/)
    ///
    /// 2021-05-11 09:45:16
    ///
    /// 给你一个整数数组 `perm` ，它是前 `n` 个正整数的排列，且 `n` 是个 奇数 。
    ///
    /// 它被加密成另一个长度为 `n - 1` 的整数数组 `encoded` ，满足 `encoded[i] = perm[i] XOR perm[i + 1]` 。比方说
    /// ，如果 `perm = [1,3,2]` ，那么 `encoded = [2,1]` 。
    ///
    /// 给你 encoded 数组，请你返回原始数组 perm 。题目保证答案存在且唯一。
    ///
    /// + 示例 1：
    ///     - 输入：`encoded = [3,1]`
    ///     - 输出：`[1,2,3]`
    ///     - 解释：如果 `perm = [1,2,3]` ，那么 `encoded = [1 XOR 2,2 XOR 3] = [3,1]`
    /// + 示例 2：
    ///     - 输入：`encoded = [6,5,4,6]`
    ///     - 输出：`[2,4,1,5,3]`
    /// + 提示：
    ///     - `3 <= n < 105`
    ///     - `n` 是奇数。
    ///     - `encoded.length == n - 1`
    ///
    /// Related Topics 位运算
    ///
    /// 👍 48 👎 0
    pub fn decode2(encoded: Vec<i32>) -> Vec<i32> {
        let mut ans = vec![0; encoded.len() + 1];
        ans[0] = (1..=((encoded.len() + 1) as i32)).fold(0, |a, i| a ^ i) ^ (1..encoded.len()).step_by(2).fold(0, |a, i| a ^ encoded[i]);
        (0..encoded.len()).for_each(|i| ans[i + 1] = ans[i] ^ encoded[i]);
        ans
        /*let mut total = 0;
        for i in 1..=((encoded.len() + 1) as i32) {
            total ^= i;
        }
        let mut odd = 0;
        for i in (1..encoded.len()).step_by(2) {
            odd ^= encoded[i];
        }
        let mut perm = vec![0; encoded.len() + 1];
        perm[0] = total ^ odd;
        for i in 0..encoded.len() {
            perm[i + 1] = perm[i] ^ encoded[i];
        }
        perm*/
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q1734() {
        let encoded = vec![6, 5, 4, 6];
        let ans = Solution::decode2(encoded);
        assert_eq!(ans, vec![2, 4, 1, 5, 3]);
    }
}
