use crate::Solution;

impl Solution {
    /// [1984.学生分数的最小差值](https://leetcode-cn.com/problems/minimum-difference-between-highest-and-lowest-of-k-scores/)
    ///
    /// 2022-02-11 11:01:30
    ///
    /// 给你一个 **下标从 0 开始** 的整数数组 `nums` ，其中 `nums[i]` 表示第 `i` 名学生的分数。另给你一个整数 `k` 。
    ///
    /// 从数组中选出任意 `k` 名学生的分数，使这 `k` 个分数间 **最高分** 和 **最低分** 的 **差值** 达到 **最小化** 。
    ///
    /// 返回可能的 **最小差值** 。
    ///
    /// + **示例 1：**
    ///
    ///     + **输入：** nums = \[90\], k = 1
    ///     + **输出：** 0
    ///     + **解释：** 选出 1 名学生的分数，仅有 1 种方法：
    ///         - \[_**90**_\] 最高分和最低分之间的差值是 90 - 90 = 0
    ///     + 可能的最小差值是 0
    ///
    /// + **示例 2：**
    ///
    ///     + **输入：** nums = \[9,4,1,7\], k = 2
    ///     + **输出：** 2
    ///     + **解释：** 选出 2 名学生的分数，有 6 种方法：
    ///         - \[_**9**_,_**4**_,1,7\] 最高分和最低分之间的差值是 9 - 4 = 5
    ///         - \[_**9**_,4,_**1**_,7\] 最高分和最低分之间的差值是 9 - 1 = 8
    ///         - \[_**9**_,4,1,_**7**_\] 最高分和最低分之间的差值是 9 - 7 = 2
    ///         - \[9,_**4**_,_**1**_,7\] 最高分和最低分之间的差值是 4 - 1 = 3
    ///         - \[9,_**4**_,1,_**7**_\] 最高分和最低分之间的差值是 7 - 4 = 3
    ///         - \[9,4,_**1**_,_**7**_\] 最高分和最低分之间的差值是 7 - 1 = 6
    ///     + 可能的最小差值是 2
    ///
    /// + **提示：**
    ///     * `1 <= k <= nums.length <= 1000`
    ///     * `0 <= nums[i] <= 105`
    /// + Related Topics
    ///     * 数组
    ///     * 排序
    ///     * 滑动窗口
    /// * 👍 36
    /// * 👎 0
    pub fn minimum_difference(mut nums: Vec<i32>, k: i32) -> i32 {
        match k {
            1 => 0,
            _ => std::collections::BinaryHeap::from(nums).into_sorted_vec().windows(k as usize).map(|s| s[s.len() - 1] - s[0]).min().unwrap()
        }
        /*let k = k as usize;
        if k == 1 {
            return 0;
        }
        nums.sort_unstable();
        (k - 1..nums.len()).map(|idx| nums[idx] - nums[idx + 1 - k]).min().unwrap()*/
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q1984() {
        let nums = vec![9,4,1,7];
        let k = 2;
        assert_eq!(Solution::minimum_difference(nums, k), 2);
    }
}
