use crate::Solution;

impl Solution {
    /// [2006.差的绝对值为 K 的数对数目](https://leetcode-cn.com/problems/count-number-of-pairs-with-absolute-difference-k/)
    ///
    /// 2022-02-09 10:02:13
    ///
    /// 给你一个整数数组 `nums` 和一个整数 `k` ，请你返回数对 `(i, j)` 的数目，满足 `i < j` 且 `|nums[i] - nums[j]| == k` 。
    ///
    /// + `|x|` 的值定义为：
    ///     * 如果 `x >= 0` ，那么值为 `x` 。
    ///     * 如果 `x < 0` ，那么值为 `-x` 。
    /// + **示例 1：**
    ///     + **输入：** nums = \[1,2,2,1\], k = 1
    ///     + **输出：** 4
    ///     + **解释：** 差的绝对值为 1 的数对为：
    ///         - \[_**1**_,_**2**_,2,1\]
    ///         - \[_**1**_,2,_**2**_,1\]
    ///         - \[1,_**2**_,2,_**1**_\]
    ///         - \[1,2,_**2**_,_**1**_\]
    /// + **示例 2：**
    ///     + **输入：** nums = \[1,3\], k = 3
    ///     + **输出：** 0
    ///     + **解释：** 没有任何数对差的绝对值为 3 。
    /// + **示例 3：**
    ///     + **输入：** nums = \[3,2,1,5,4\], k = 2
    ///     + **输出：** 3
    ///     + **解释：** 差的绝对值为 2 的数对为：
    ///         - \[_**3**_,2,_**1**_,5,4\]
    ///         - \[_**3**_,2,1,_**5**_,4\]
    ///         - \[3,_**2**_,1,5,_**4**_\]
    /// + **提示：**
    ///     * `1 <= nums.length <= 200`
    ///     * `1 <= nums[i] <= 100`
    ///     * `1 <= k <= 99`
    /// + Related Topics
    ///     * 数组
    ///     * 哈希表
    ///     * 计数
    /// * 👍 26
    /// * 👎 0
    pub fn count_k_difference(nums: Vec<i32>, k: i32) -> i32 {
        if nums.len() < 2 {
            return 0;
        }
        let mut ans = 0;
        for i in 0..nums.len() {
            for j in (i + 1)..nums.len() {
                if (nums[i] - nums[j]).abs() == k {
                    ans += 1;
                }
            }
        }
        ans
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q2006() {
        assert_eq!(Solution::count_k_difference(vec![1, 2, 2, 1], 1), 4);
    }
}
