//! 题库

use crate::structure::*;
use crate::*;
use std::cell::RefCell;
use std::rc::Rc;
use std::ops::Add;

impl Solution {
    /// 51.N皇后
    ///
    /// [原题链接](https://leetcode-cn.com/problems/n-queens/)
    pub fn solve_n_queens(n: i32) -> Vec<Vec<String>> {
        fn generate_board(queens: &Vec<usize>, n: usize) -> Vec<String> {
            let mut board = Vec::<String>::with_capacity(n);
            for i in 0..n {
                let mut row = vec![b'.'; n];
                row[queens[i]] = b'Q';
                board.push(String::from_utf8(row).unwrap());
            }
            board
        }
        fn solve(solutions: &mut Vec<Vec<String>>, queens: &mut Vec<usize>, n: usize, row: usize, columns: usize, diagonals1: usize, diagonals2: usize) {
            if row == n {
                solutions.push(generate_board(queens, n));
            } else {
                let mut available_positions = ((1 << n) - 1) & (!(columns | diagonals1 | diagonals2));
                while available_positions != 0 {
                    let position = available_positions & ((!available_positions) + 1);
                    available_positions = available_positions & (available_positions - 1);
                    let column = position.trailing_zeros() as usize;
                    queens[row] = column;
                    solve(solutions, queens, n, row + 1, columns | position, (diagonals1 | position) >> 1, (diagonals2 | position) << 1);
                    queens[row] = usize::MAX;
                }
            }
        }
        let mut solutions = Vec::<Vec<String>>::new();
        solve(&mut solutions, &mut vec![usize::MAX; n as usize], n as usize, 0, 0, 0, 0);
        solutions
    }

    /// 188.买卖股票的最佳时机 IV
    ///
    /// [原题链接](https://leetcode-cn.com/problems/best-time-to-buy-and-sell-stock-iv/)
    pub fn max_profit_iv(mut k: i32, prices: Vec<i32>) -> i32 {
        /*if prices.is_empty() || k < 1 {
            return 0;
        }
        let n = prices.len();
        let k = std::cmp::min(k as usize, n / 2);
        let mut buy = vec![i32::MIN / 2; k + 1];
        let mut sell = vec![i32::MIN / 2; k + 1];
        buy[0] = -prices[0];
        sell[0] = 0;
        for i in 1..n {
            buy[0] = std::cmp::max(buy[0], sell[0] - prices[i]);
            for j in 1..=k {
                buy[j] = std::cmp::max(buy[j], sell[j] - prices[i]);
                sell[j] = std::cmp::max(sell[j], buy[j - 1] + prices[i]);
            }
        }
        *sell.iter().max().unwrap()*/
        if prices.len() < 2 || k < 1 {
            return 0;
        }
        let k = std::cmp::min(k as usize, prices.len() / 2);
        let mut buy = vec![i32::MIN; k + 1];
        let mut sell = vec![0; k + 1];
        for p in prices {
            for j in 1..=k {
                buy[j] = buy[j].max(sell[j - 1] - p);
                sell[j] = sell[j].max(buy[j] + p);
            }
        }
        sell[k]
    }

    /// 123.买卖股票的最佳时机 III
    ///
    /// [原题链接](https://leetcode-cn.com/problems/best-time-to-buy-and-sell-stock-iii/)
    pub fn max_profit_iii(prices: Vec<i32>) -> i32 {
        if prices.is_empty() {
            return 0;
        }
        use std::cmp::max;
        let (mut buy1, mut sell1) = (-prices[0], 0);
        let (mut buy2, mut sell2) = (-prices[0], 0);

        for i in 1..prices.len() {
            buy1 = max(buy1, -prices[i]);
            sell1 = max(sell1, buy1 + prices[i]);
            buy2 = max(buy2, sell1 - prices[i]);
            sell2 = max(sell2, buy2 + prices[i]);
        }
        sell2
    }

    /// LCP 06.拿硬币
    ///
    /// [原题链接](https://leetcode-cn.com/problems/na-ying-bi/)
    pub fn min_count(coins: Vec<i32>) -> i32 {
        coins.iter().map(|x| (x + 1) >> 1).sum()
    }

    /// LCP 17.速算机器人
    ///
    /// [原题链接](https://leetcode-cn.com/problems/nGK0Fy/)
    ///
    /// # 方法1 遍历
    /// ```rust
    /// pub fn calculate2(s: String) -> i32 {
    ///     let t = s.chars().into_iter().fold((1, 0), |mut acc, ch| {
    ///         if ch == 'A' { acc.0 = 2 * acc.0 + acc.1 } else { acc.1 = 2 * acc.1 + acc.0 }
    ///         acc
    ///     });
    ///     t.0 + t.1
    /// }
    /// ```
    /// # 方法2 数学
    pub fn calculate2(s: String) -> i32 {
        1 << s.len() as i32
    }

    /// 剑指 Offer 05.替换空格
    ///
    /// [原题链接](https://leetcode-cn.com/problems/ti-huan-kong-ge-lcof/)
    pub fn replace_space(s: String) -> String {
        s.replace(" ", "%20")
    }

    /// 239.滑动窗口最大值
    ///
    /// [原题链接](https://leetcode-cn.com/problems/sliding-window-maximum/)
    /// [原题链接](https://leetcode-cn.com/problems/hua-dong-chuang-kou-de-zui-da-zhi-lcof/)
    /// # 方法2 单调队列
    /// ```rust
    /// pub fn max_sliding_window(nums: Vec<i32>, k: i32) -> Vec<i32> {
    ///     if nums.is_empty() {
    ///         return vec![];
    ///     }
    ///     let k = k as usize;
    ///     let mut q = std::collections::VecDeque::<usize>::new();
    ///     for i in 0..k as usize {
    ///         while !q.is_empty() && nums[i] >= nums[*q.back().unwrap()] {
    ///             q.pop_back();
    ///         }
    ///         q.push_back(i);
    ///     }
    ///     let mut ans: Vec<i32> = vec![nums[*q.front().unwrap()]];
    ///     for i in k..nums.len() {
    ///         while !q.is_empty() && nums[i] >= nums[*q.back().unwrap()] {
    ///             q.pop_back();
    ///         }
    ///         q.push_back(i);
    ///         while *q.front().unwrap() <= i - k {
    ///             q.pop_front();
    ///         }
    ///         ans.push(nums[*q.front().unwrap()]);
    ///     }
    ///     ans
    /// }
    /// ```
    pub fn max_sliding_window(nums: Vec<i32>, k: i32) -> Vec<i32> {
        unimplemented!()
    }

    /// 1232.缀点成线
    ///
    /// [原题链接](https://leetcode-cn.com/problems/check-if-it-is-a-straight-line/)
    pub fn check_straight_line(mut coordinates: Vec<Vec<i32>>) -> bool {
        if coordinates.len() <= 2 {
            return true;
        }
        let mut delta_x = coordinates[0][0];
        let mut delta_y = coordinates[0][1];

        for i in 0..coordinates.len() {
            coordinates[i][0] -= delta_x;
            coordinates[i][1] -= delta_y;
        }
        let (a, b) = (coordinates[1][1], -coordinates[1][0]);
        for i in 2..coordinates.len() {
            let (x, y) = (coordinates[i][0], coordinates[i][1]);
            if a * x + b * y != 0 {
                return false;
            }
        }
        true
    }

    /// 1584.连接所有点的最小费用
    ///
    /// [原题链接](https://leetcode-cn.com/problems/min-cost-to-connect-all-points/)
    /// # 方法1 Kruskal算法
    /// ## 源码
    /// ```rust
    /// pub fn min_cost_connect_points(points: Vec<Vec<i32>>) -> i32 {
    ///     let dist = |x: usize, y: usize| -> i32 { (points[x][0] - points[y][0]).abs() + (points[x][1] - points[y][1]).abs() };
    ///     let n = points.len();
    ///     let mut edges = Vec::<(i32, usize, usize)>::new();
    ///     for i in 0..n {
    ///         for j in (i + 1)..n {
    ///             edges.push((dist(i, j), i, j));
    ///         }
    ///     }
    ///     edges.sort_by(|a, b| a.0.cmp(&b.0));
    ///     let mut f = (0..n).collect::<Vec<usize>>();
    ///     let mut rank = vec![1usize; n];
    ///     fn find(f: &mut Vec<usize>, x: usize) -> usize {
    ///         if f[x] != x {
    ///             f[x] = find(f, f[x]);
    ///         }
    ///         f[x]
    ///     }
    ///     fn union_set(f: &mut Vec<usize>, rank: &mut Vec<usize>, x: usize, y: usize) -> bool {
    ///         let (mut fx, mut fy) = (find(f, x), find(f, y));
    ///         if fx == fy {
    ///             return false;
    ///         }
    ///         if rank[fx] < rank[fy] {
    ///             fx ^= fy;
    ///             fy ^= fx;
    ///             fx ^= fy;
    ///         }
    ///         rank[fx] += rank[fy];
    ///         f[fy] = fx;
    ///         return true;
    ///     }
    ///     let (mut ret, mut num) = (0, 1);
    ///     for &(len, x, y) in &edges {
    ///         if union_set(&mut f, &mut rank, x, y) {
    ///             ret += len;
    ///             num += 1;
    ///             if num == n {
    ///                 break;
    ///             }
    ///         }
    ///     }
    ///     ret
    /// }
    /// ```
    /// # 方法2 建图优化Kruskal算法
    /// 实现见源码
    /// # 方法3 prim算法
    pub fn min_cost_connect_points(points: Vec<Vec<i32>>) -> i32 {
        use std::collections::HashSet;

        fn low_bit(k: usize) -> usize {
            k & ((!k) + 1)
        }
        fn update(tree: &mut Vec<i32>, id_rec: &mut Vec<i32>, mut pos: usize, val: i32, id: usize) {
            while pos > 0 {
                if tree[pos] > val {
                    tree[pos] = val;
                    id_rec[pos] = id as i32;
                }
                pos -= low_bit(pos);
            }
        }
        fn query(tree: &mut Vec<i32>, id_res: &mut Vec<i32>, mut pos: usize) -> i32 {
            let mut min_val = i32::MAX;
            let mut j = -1;
            while pos < tree.len() {
                if min_val > tree[pos] {
                    min_val = tree[pos];
                    j = id_res[pos];
                }
                pos += low_bit(pos);
            }
            j
        }
        fn build(pos: &mut Vec<(i32, i32, usize)>, edges: &mut Vec<(i32, usize, usize)>, n: usize) {
            pos.sort_by(|a, b| if a.0 == b.0 { a.1.cmp(&b.1) } else { a.0.cmp(&b.0) });
            let mut a = Vec::<i32>::with_capacity(n);
            let mut set = HashSet::<i32>::new();
            for i in 0..n {
                a.push(pos[i].1 - pos[i].0);
                set.insert(pos[i].1 - pos[i].0);
            }
            let mut b = set.into_iter().collect::<Vec<i32>>();
            b.sort();
            let num = b.len() + 1;
            let mut tree = vec![i32::MAX; num];
            let mut id_rec = vec![-1i32; num];
            for i in (0..n).rev() {
                let poss = b.binary_search(&a[i]).unwrap() + 1;
                let j = query(&mut tree, &mut id_rec, poss);
                if j != -1 {
                    let dis = (pos[i].0 - pos[j as usize].0).abs() + (pos[i].1 - pos[j as usize].1).abs();
                    edges.push((dis, pos[i].2, pos[j as usize].2));
                }
                update(&mut tree, &mut id_rec, poss, pos[i].0 + pos[i].1, i);
            }
        }

        let mut pos = Vec::<(i32, i32, usize)>::with_capacity(points.len());
        let mut edges = Vec::<(i32, usize, usize)>::new();
        let n = points.len();
        for i in 0..n {
            pos.push((points[i][0], points[i][1], i));
        }
        build(&mut pos, &mut edges, n);
        for i in 0..n {
            pos[i].0 ^= pos[i].1;
            pos[i].1 ^= pos[i].0;
            pos[i].0 ^= pos[i].1;
            //swap(&mut pos[i].0, &mut pos[i].1);
        }
        build(&mut pos, &mut edges, n);
        for i in 0..n {
            pos[i].0 = -pos[i].0;
        }
        build(&mut pos, &mut edges, n);
        for i in 0..n {
            pos[i].0 ^= pos[i].1;
            pos[i].1 ^= pos[i].0;
            pos[i].0 ^= pos[i].1;
        }
        build(&mut pos, &mut edges, n);

        edges.sort_by(|a, b| a.0.cmp(&b.0));
        let mut f = (0..n).collect::<Vec<usize>>();
        let mut rank = vec![1usize; n];
        fn find(f: &mut Vec<usize>, x: usize) -> usize {
            if f[x] != x {
                f[x] = find(f, f[x]);
            }
            f[x]
        }
        fn union_set(f: &mut Vec<usize>, rank: &mut Vec<usize>, x: usize, y: usize) -> bool {
            let (mut fx, mut fy) = (find(f, x), find(f, y));
            if fx == fy {
                return false;
            }
            if rank[fx] < rank[fy] {
                fx ^= fy;
                fy ^= fx;
                fx ^= fy;
            }
            rank[fx] += rank[fy];
            f[fy] = fx;
            return true;
        }
        let (mut ret, mut num) = (0i32, 1usize);
        for &(len, x, y) in &edges {
            if union_set(&mut f, &mut rank, x, y) {
                ret += len;
                num += 1usize;
                if num == n {
                    break;
                }
            }
        }
        ret
    }

    /// 1489.找到最小生成树里的关键边和伪关键边
    ///
    /// [原题链接](https://leetcode-cn.com/problems/find-critical-and-pseudo-critical-edges-in-minimum-spanning-tree/)
    /// # 方法1 枚举+最小生成树判定
    /// ## 源码
    /// ```rust
    /// pub fn find_critical_and_pseudo_critical_edges(n: i32, mut edges: Vec<Vec<i32>>) -> Vec<Vec<i32>> {
    ///     fn find_set(parent: &mut Vec<usize>, x: usize) -> usize {
    ///         if parent[x] == x {
    ///             x
    ///         } else {
    ///             parent[x] = find_set(parent, parent[x]);
    ///             parent[x]
    ///         }
    ///     }
    ///     fn unite(parent:&mut Vec<usize>, size:&mut Vec<usize>, x:usize, y:usize, set_count: &mut usize) -> bool {
    ///         let mut x_root = find_set(parent, x);
    ///         let mut y_root = find_set(parent, y);
    ///         if x_root == y_root {
    ///             return false;
    ///         }
    ///         if size[x_root] < size[y_root] {
    ///             x_root ^= y_root;
    ///             y_root ^= x_root;
    ///             x_root ^= y_root;
    ///         }
    ///         parent[y_root] = x_root;
    ///         size[x_root] += size[y_root];
    ///         *set_count -= 1;
    ///         true
    ///     }
    ///     let m = edges.len();
    ///     for i in 0..m {
    ///         edges[i].push(i as i32);
    ///     }
    ///     edges.sort_by(|u, v| u[2].cmp(&v[2]));
    ///     let n = n as usize;
    ///     let mut parent = (0..n).collect::<Vec<usize>>();
    ///     let mut size = vec![1usize; n];
    ///     let mut set_count = n;
    ///     let mut value = 0;
    ///     for i in 0..m {
    ///         if unite(&mut parent, &mut size, edges[i][0] as usize, edges[i][1] as usize, &mut set_count) {
    ///             value += edges[i][2];
    ///         }
    ///     }
    ///     let mut ans = vec![Vec::<i32>::new(); 2];
    ///     for i in 0..m {
    ///         let mut parent0 = (0..n).collect::<Vec<usize>>();
    ///         let mut size0 = vec![1usize; n];
    ///         let mut set_count0 = n;
    ///         let mut value0 = 0;
    ///         for j in 0..m {
    ///             if i != j && unite(&mut parent0, &mut size0, edges[j][0] as usize, edges[j][1] as usize, &mut set_count0) {
    ///                 value0 += edges[j][2];
    ///             }
    ///         }
    ///         if set_count0 != 1 || value0 > value {
    ///             ans[0].push(edges[i][3]);
    ///             continue;
    ///         }
    ///         let mut parent1 = (0..n).collect::<Vec<usize>>();
    ///         let mut size1 = vec![1usize; n];
    ///         let mut set_count1 = n;
    ///         unite(&mut parent1, &mut size1, edges[i][0] as usize, edges[i][1] as usize, &mut set_count1);
    ///         let mut value1 = edges[i][2];
    ///         for j in 0..m {
    ///             if i != j && unite(&mut parent1, &mut size1, edges[j][0] as usize, edges[j][1] as usize, &mut set_count1) {
    ///                 value1 += edges[j][2];
    ///             }
    ///         }
    ///         if value1 == value {
    ///             ans[1].push(edges[i][3]);
    ///         }
    ///     }
    ///     ans
    /// }
    /// ```
    pub fn find_critical_and_pseudo_critical_edges(n: i32, mut edges: Vec<Vec<i32>>) -> Vec<Vec<i32>> {
        fn find_set(parent: &mut Vec<usize>, x: usize) -> usize {
            if parent[x] == x {
                x
            } else {
                parent[x] = find_set(parent, parent[x]);
                parent[x]
            }
        }
        fn unite(parent: &mut Vec<usize>, size: &mut Vec<usize>, x: usize, y: usize, set_count: &mut usize) -> bool {
            let mut x_root = find_set(parent, x);
            let mut y_root = find_set(parent, y);
            if x_root == y_root {
                return false;
            }
            if size[x_root] < size[y_root] {
                std::mem::swap(&mut x_root, &mut y_root);
            }
            parent[y_root] = x_root;
            size[x_root] += size[y_root];
            *set_count -= 1;
            true
        }

        fn get_cutting_edge_(edges: &mut Vec<Vec<usize>>, edges_id: &mut Vec<Vec<usize>>, low: &mut Vec<usize>, dfn: &mut Vec<usize>, ans: &mut Vec<usize>, ts: &mut i32, u: usize, parent_edge_id: usize) {
            *ts += 1;
            dfn[u] = *ts as usize;
            low[u] = *ts as usize;
            for i in 0..edges[u].len() {
                let v = edges[u][i];
                let id = edges_id[u][i];
                if dfn[v] == dfn.len() {
                    get_cutting_edge_(edges, edges_id, low, dfn, ans, ts, v, id);
                    low[u] = low[u].min(low[v]);
                    if low[v] > dfn[u] {
                        ans.push(id);
                    }
                } else if id != parent_edge_id {
                    low[u] = low[u].min(dfn[v]);
                }
            }
        }

        fn get_cutting_edge(n: usize, mut edges: Vec<Vec<usize>>, mut edges_id: Vec<Vec<usize>>) -> Vec<usize> {
            let mut low = vec![n; n];
            let mut dfn = vec![n; n];
            let mut ts = -1;
            let mut ans = Vec::<usize>::new();
            for i in 0..n {
                if dfn[i] == n {
                    get_cutting_edge_(&mut edges, &mut edges_id, &mut low, &mut dfn, &mut ans, &mut ts, i, n);
                }
            }
            ans
        }

        let m = edges.len();
        for i in 0..m {
            edges[i].push(i as i32);
        }
        edges.sort_by(|u, v| u[2].cmp(&v[2]));
        let n = n as usize;
        let mut parent = (0..n).collect::<Vec<usize>>();
        let mut size = vec![1usize; n];
        let mut set_count = n;
        let mut ans = vec![Vec::<i32>::new(); 2];
        let mut label = vec![0; m];
        let mut i = 0;
        while i < m {
            //let w = edges[i][2];
            let mut j = i;
            while j < m && edges[j][2] == edges[i][2] {
                j += 1;
            }
            let mut comp_to_id = std::collections::HashMap::<usize, usize>::new();
            let mut gn = 0usize;
            for k in i..j {
                let x = find_set(&mut parent, edges[k][0] as usize);
                let y = find_set(&mut parent, edges[k][1] as usize);
                if x != y {
                    if !comp_to_id.contains_key(&x) {
                        comp_to_id.insert(x, gn);
                        gn += 1;
                    }
                    if !comp_to_id.contains_key(&y) {
                        comp_to_id.insert(y, gn);
                        gn += 1;
                    }
                } else {
                    label[edges[k][3] as usize] = -1;
                }
            }
            let mut gm = vec![Vec::<usize>::new(); gn];
            let mut gm_id = vec![Vec::<usize>::new(); gn];
            for k in i..j {
                let x = find_set(&mut parent, edges[k][0] as usize);
                let y = find_set(&mut parent, edges[k][1] as usize);
                if x != y {
                    let idx = comp_to_id[&x];
                    let idy = comp_to_id[&y];
                    gm[idx].push(idy);
                    gm_id[idx].push(edges[k][3] as usize);
                    gm[idy].push(idx);
                    gm_id[idy].push(edges[k][3] as usize);
                }
            }
            let bridges = get_cutting_edge(gn, gm, gm_id);

            for id in bridges {
                ans[0].push(id as i32);
                label[id] = 1;
            }
            for k in i..j {
                unite(&mut parent, &mut size, edges[k][0] as usize, edges[k][1] as usize, &mut set_count);
            }
            i = j;
        }
        for i in 0..m {
            if label[i] == 0 {
                ans[1].push(i as i32);
            }
        }
        ans
    }

    /// 1319.连通网络的操作次数
    ///
    /// [原题链接](https://leetcode-cn.com/problems/number-of-operations-to-make-network-connected/)
    pub fn make_connected(n: i32, connections: Vec<Vec<i32>>) -> i32 {
        if connections.len() + 1 < n as usize {
            return -1;
        }
        let n = n as usize;
        let mut parent = (0..n).collect::<Vec<usize>>();
        let mut size = vec![1usize; n];
        let mut set_count = n;
        fn find_set(parent: &mut Vec<usize>, x: usize) -> usize {
            if parent[x] == x {
                x
            } else {
                parent[x] = find_set(parent, parent[x]);
                parent[x]
            }
        }
        fn unite(parent: &mut Vec<usize>, size: &mut Vec<usize>, x: usize, y: usize, set_count: &mut usize) -> bool {
            let mut x_root = find_set(parent, x);
            let mut y_root = find_set(parent, y);
            if x_root == y_root {
                return false;
            }
            if size[x_root] < size[y_root] {
                x_root ^= y_root;
                y_root ^= x_root;
                x_root ^= y_root;
            }
            parent[y_root] = x_root;
            size[x_root] += size[y_root];
            *set_count -= 1;
            true
        }
        for c in connections {
            unite(&mut parent, &mut size, c[0] as usize, c[1] as usize, &mut set_count);
        }
        set_count as i32 - 1
    }

    /// 1579.保证图可完全遍历
    ///
    /// [原题链接](https://leetcode-cn.com/problems/remove-max-number-of-edges-to-keep-graph-fully-traversable/)
    /// # 并查集
    pub fn max_num_edges_to_remove(n: i32, mut edges: Vec<Vec<i32>>) -> i32 {
        fn find_set(parent: &mut Vec<usize>, x: usize) -> usize {
            if parent[x] == x {
                x
            } else {
                parent[x] = find_set(parent, parent[x]);
                parent[x]
            }
        }
        fn unite(parent: &mut Vec<usize>, size: &mut Vec<usize>, x: usize, y: usize, set_count: &mut usize) -> bool {
            let mut x_root = find_set(parent, x);
            let mut y_root = find_set(parent, y);
            if x_root == y_root {
                return false;
            }
            if size[x_root] < size[y_root] {
                x_root ^= y_root;
                y_root ^= x_root;
                x_root ^= y_root;
            }
            parent[y_root] = x_root;
            size[x_root] += size[y_root];
            *set_count -= 1;
            true
        }
        let n = n as usize;
        let mut parent1 = (0..n).collect::<Vec<usize>>();
        let mut parent2 = (0..n).collect::<Vec<usize>>();
        let mut size1 = vec![1usize; n];
        let mut size2 = vec![1usize; n];
        let mut set_count1 = n;
        let mut set_count2 = n;
        let mut ans = 0;
        for edge in edges.iter_mut() {
            edge[1] -= 1;
            edge[2] -= 1;
        }
        for edge in &edges {
            if edge[0] == 3 {
                if !unite(&mut parent1, &mut size1, edge[1] as usize, edge[2] as usize, &mut set_count1) {
                    ans += 1;
                } else {
                    unite(&mut parent2, &mut size2, edge[1] as usize, edge[2] as usize, &mut set_count2);
                }
            }
        }
        for edge in &edges {
            if edge[0] == 1 {
                if !unite(&mut parent1, &mut size1, edge[1] as usize, edge[2] as usize, &mut set_count1) {
                    ans += 1;
                }
            } else if edge[0] == 2 {
                if !unite(&mut parent2, &mut size2, edge[1] as usize, edge[2] as usize, &mut set_count2) {
                    ans += 1;
                }
            }
        }
        if set_count1 != 1 || set_count2 != 1 {
            return -1;
        }
        ans
    }

    /// 面试题 01.08.零矩阵
    ///
    /// [原题链接](https://leetcode-cn.com/problems/zero-matrix-lcci/)
    pub fn set_zeroes(matrix: &mut Vec<Vec<i32>>) {
        let n = matrix.len();
        let m = matrix[0].len();
        let mut row_lookup = vec![false; n];
        let mut col_lookup = vec![false; m];
        for i in 0..n {
            for j in 0..m {
                if matrix[i][j] == 0 {
                    row_lookup[i] = true;
                    col_lookup[j] = true;
                }
            }
        }
        for i in 0..n {
            if row_lookup[i] {
                for j in 0..m {
                    matrix[i][j] = 0;
                }
            }
        }
        for j in 0..m {
            if col_lookup[j] {
                for i in 0..n {
                    matrix[i][j] = 0;
                }
            }
        }
    }

    /// 1631.最小体力消耗路径
    ///
    /// [原题链接](https://leetcode-cn.com/problems/path-with-minimum-effort/)
    /// # 方法1 Dijkstra 算法
    /// # 方法2 并查集
    ///
    pub fn minimum_effort_path(heights: Vec<Vec<i32>>) -> i32 {
        struct UnionFind {
            parent: Vec<usize>,
            size: Vec<usize>,
            n: usize,
            set_count: usize,
        }
        impl UnionFind {
            fn new(n: usize) -> UnionFind {
                UnionFind {
                    parent: (0..n).collect::<Vec<usize>>(),
                    size: vec![1; n],
                    n,
                    set_count: n,
                }
            }
            fn find_set(&mut self, x: usize) -> usize {
                if self.parent[x] == x {
                    x
                } else {
                    self.parent[x] = self.find_set(self.parent[x]);
                    self.parent[x]
                }
            }
            fn unite(&mut self, x: usize, y: usize) -> bool {
                let mut root_x = self.find_set(x);
                let mut root_y = self.find_set(y);
                if root_x == root_y {
                    return false;
                }
                if self.size[root_x] < self.size[root_y] {
                    std::mem::swap(&mut root_x, &mut root_y);
                }
                self.parent[root_y] = root_x;
                self.size[root_x] += self.size[root_y];
                self.set_count -= 1;
                true
            }
            fn connected(&mut self, x: usize, y: usize) -> bool {
                let root_x = self.find_set(x);
                let root_y = self.find_set(y);
                root_x == root_y
            }
        }
        let (m, n) = (heights.len(), heights[0].len());
        let mut edges = Vec::<(usize, usize, i32)>::new();
        for i in 0..m {
            for j in 0..n {
                let id = i * n + j;
                if i > 0 {
                    edges.push((id - n, id, (heights[i][j] - heights[i - 1][j]).abs()));
                }
                if j > 0 {
                    edges.push((id - 1, id, (heights[i][j] - heights[i][j - 1]).abs()));
                }
            }
        }
        edges.sort_unstable_by_key(|x| x.2);
        let mut uf = UnionFind::new(m * n);
        let mut ans = 0;
        for (x, y, v) in edges {
            uf.unite(x, y);
            if uf.connected(0, m * n - 1) {
                ans = v;
                break;
            }
        }
        ans
    }
    /*pub fn minimum_effort_path(heights: Vec<Vec<i32>>) -> i32 {
        const DIRS: [(i32, i32); 4] = [(-1, 0), (1, 0), (0, -1), (0, 1)];
        #[derive(PartialEq, Eq)]
        struct Item(usize, usize, i32);
        impl PartialOrd for Item {
            fn partial_cmp(&self, other: &Self) -> Option<std::cmp::Ordering> {
                other.2.partial_cmp(&self.2)
            }
        }
        impl Ord for Item {
            fn cmp(&self, other: &Self) -> std::cmp::Ordering {
                other.2.cmp(&self.2)
            }
        }
        let (m, n) = (heights.len(), heights[0].len());
        let mut queue = std::collections::binary_heap::BinaryHeap::<Item>::new();
        queue.push(Item(0, 0, 0));
        let mut dist = vec![i32::MAX; m * n];
        dist[0] = 0;
        let mut visited = vec![false; m * n];
        while !queue.is_empty() {
            let Item(x, y, d) = queue.pop().unwrap();
            let id = x * n + y;
            if visited[id] { continue; }
            if x == m - 1 && y == n - 1 { break; }
            visited[id] = true;
            for (dx, dy) in DIRS.iter() {
                let (nx, ny) = ((x as i32 + dx) as usize, (y as i32 + dy) as usize);
                if nx < m && ny < n && d.max((heights[x][y] - heights[nx][ny]).abs()) < dist[nx * n + ny] {
                    dist[nx * n + ny] = d.max((heights[x][y] - heights[nx][ny]).abs());
                    queue.push(Item(nx, ny, dist[nx * n + ny]));
                }
            }
        }
        dist[m * n - 1]
    }*/
}

// 单元测试
#[cfg(test)]
mod tests {
    use super::*;

    /*#[test]
    fn test_sqrt() {
        use std::time::Instant;

        let t1 = Instant::now();
        let n = 2147395599;
        let t = 10000000;
        for i in 0..t {
            let z = 1.0 / (n as f64).sqrt();
        }
        println!("{}", t1.elapsed().as_millis());
        let t2 = Instant::now();
        for i in 0..t {
            Solution::my_sqrt(n);
        }
        println!("{}", t2.elapsed().as_millis());
    }*/

    #[test]
    fn test_minimum_effort_path() {
        let h = vec![vec![1, 2, 2], vec![3, 8, 2], vec![5, 3, 5]];
        let i = Solution::minimum_effort_path(h);
        //println!("{}", i);
        assert_eq!(i, 2);
    }

    #[test]
    fn test_find_critical_and_pseudo_critical_edges() {
        let n = 5;
        let edges = vec![vec![0, 1, 1], vec![1, 2, 1], vec![2, 3, 2], vec![0, 3, 2], vec![0, 4, 3], vec![3, 4, 3], vec![1, 4, 6]];
        let ret = Solution::find_critical_and_pseudo_critical_edges(n, edges);
        //println!("{:?}", ret);
        assert_eq!(ret, vec![vec![1, 0], vec![2, 3, 4, 5]]);
    }

    #[test]
    fn test_min_cost_connect_points() {
        let points = vec![vec![0, 0], vec![2, 2], vec![3, 10], vec![5, 2], vec![7, 0]];
        let ret = Solution::min_cost_connect_points(points);
        //println!("{}", ret);
        assert_eq!(ret, 20);
    }
}